systemd System and Service Manager

CHANGES WITH 260 in spe:

        Feature Removals and Incompatible Changes:

        * Support for System V service scripts has been removed. Please make
          sure to update your software *now* to include a native systemd unit
          file instead of a legacy System V script.

          The following components have been removed:

          * systemd-rc-local-generator and rc-local.service,
          * systemd-sysv-generator,
          * systemd-sysv-install (hook for systemctl enable/disable/is-enabled).

          The corresponding meson options '-Drc-local=', '-Dsysvinit-path=',
          and '-Dsysvrcnd-path=' are deprecated, and will be dropped in a future
          release.

        * Meson options '-Dintegration-tests=' and '-Dcryptolib=' (deprecated
          in v258) have been removed.

        * Support for libidn has been removed. IDN functionality now requires
          libidn2. The corresponding meson option '-Dlibidn=' is deprecated
          too and will be dropped in a future release.

        * The parsing of RootImageOptions= and the mount image parameters of
          ExtensionImages= and MountImages= has been changed so that the last
          duplicated definition for a given partition wins and is applied,
          rather than the first, to keep these options coherent with other
          unit settings.

CHANGES WITH 259:

        Announcements of Future Feature Removals and Incompatible Changes:

        * Support for System V service scripts is deprecated and will be
          removed in v260. Please make sure to update your software *now* to
          include a native systemd unit file instead of a legacy System V
          script to retain compatibility with future systemd releases.
          Following components will be removed:

          * systemd-rc-local-generator,
          * systemd-sysv-generator,
          * systemd-sysv-install (hook for systemctl enable/disable/is-enabled).

        * Required minimum versions of following components are planned to be
          raised in v260:

          * Linux kernel >= 5.10 (recommended >= 5.14),
          * glibc >= 2.34,
          * libxcrypt >= 4.4.0 (libcrypt in glibc will be no longer supported),
          * util-linux >= 2.37,
          * elfutils >= 0.177,
          * openssl >= 3.0.0,
          * cryptsetup >= 2.4.0,
          * libseccomp >= 2.4.0,
          * python >= 3.9.0.

        * The parsing of RootImageOptions= and the mount image parameters of
          ExtensionImages= and MountImages= will be changed in the next version
          so that the last duplicated definition for a given partition wins and
          is applied, rather than the first, to keep these options coherent with
          other unit settings.

        Feature Removals and Incompatible Changes:

        * The cgroup2 file system is now mounted with the
          "memory_hugetlb_accounting" mount option, supported since kernel 6.6.
          This means that HugeTLB memory usage is now counted towards the
          cgroup’s overall memory usage for the memory controller.

        * The default storage mode for the journal is now 'persistent'.
          Previously, the default was 'auto', so the presence or lack of
          /var/log/journal determined the default storage mode, if no
          overriding configuration was provided. The default can be changed
          with -Djournal-storage-default=.

        * systemd-networkd and systemd-nspawn no longer support creating NAT
          rules via iptables/libiptc APIs; only nftables is now supported.

        * systemd-boot's and systemd-stub's support for TPM 1.2 has been
          removed (only TPM 2.0 supported is retained). The security value of
          TPM 1.2 support is questionable in 2025, and because we never
          supported it in userspace, it was always quite incomplete to the
          point of uselessness.

        * The image dissection logic will now enforce the VFAT file system type
          for XBOOTLDR partitions, similar to how it already does this for the
          ESP. This is done for security, since both the ESP and XBOOTLDR must
          be directly firmware-accessible and thus cannot by protected by
          cryptographic means. Thus it is essential to not mount arbitrarily
          complex file systems on them. This restriction only applies if
          automatic dissection is used. If other file system types shall be
          used for XBOOTLDR (not recommended) this can be achieved via explicit
          /etc/fstab entries.

        * systemd-machined will now expose "hidden" disk images as read-only by
          default (hidden images are those whose name begins with a dot). They
          were already used to retain a pristine copy of the downloaded image,
          while modifications were made to a 2nd, local writable copy of the
          image. Hence, effectively they were read-only already, and this is
          now official.

        * The LUKS volume label string set by systemd-repart no longer defaults
          to the literal same as the partition and file system label, but is
          prefixed with "luks-". This is done so that on LUKS enabled images a
          conflict between /dev/disk/by-label/ symlinks is removed, as this
          symlink is generated both for file system and LUKS superblock
          labels. There's a new VolumeLabel= setting for partitions that can be
          used to explicitly choose a LUKS superblock label, which can be used
          to explicitly revert to the old naming, if required.

        Service manager/PID1:

        * The service manager's Varlink IPC has been extended considerably. It
          now exposes service execution settings and more. Its Unit.List() call
          now can filter by cgroup or invocation ID.

        * The service manager now exposes Reload() and Reexecute() Varlink IPC
          calls, mirroring the calls of the same name accessible via D-Bus.

        * The $LISTEN_FDS protocol has been extended to support pidfd inode
          IDs. The $LISTEN_PID environment variable is now augmented with a new
          $LISTEN_PIDFDID environment variable which contains the inode ID of
          the pidfd of the indicated process. This removes any ambiguity
          regarding PID recycling: a process which verified that $LISTEN_PID
          points to its own PID can now also verify the pidfd inode ID, which
          does not recycle IDs.

        * The log message made when a service exits will now show the
          wallclock time the service took in addition to the previously shown
          CPU time.

        * A new pair of properties OOMKills and ManagedOOMKills are now exposed
          on service units (and other unit types that spawn processes) that
          count the number of process kills made by the kernel or systemd-oomd.

        * The service manager gained support for a new
          RootDirectoryFileDescriptor= property when creating transient service
          units. It is similar to RootDirectory= but takes a file descriptor
          rather than a path to the new root directory to use.

        * The service manager now supports a new UserNamespacePath= setting
          which mirrors the existing IPCNamespacePath= and
          NetworkNamespacePath= options, but applies to Linux user namespaces.

        * The service manager gained a new ExecReloadPost= setting to configure
          commands to execute after reloading of the configuration of the
          service has completed.

        * Service manager job activation transactions now get a per-system
          unique 64-bit numeric ID assigned. This ID is logged as an additional
          log field for in messages related to the transaction.

        * The service manager now keeps track of transactions with ordering
          cycles and exposes them in the TransactionsWithOrderingCycle D-Bus
          property.

        systemd-sysext/systemd-confext:

        * systemd-sysext and systemd-confext now support configuration files
          /etc/systemd/systemd-sysext.conf and /etc/systemd/systemd-confext.conf,
          which can be used to configure mutability or the image policy to
          apply to DDI images.

        * systemd-sysext's and systemd-confext's --mutable= switch now accepts
          a new value "help" for listing available mutability modes.

        * systemd-sysext now supports configuring additional overlayfs mount
          settings via the $SYSTEMD_SYSEXT_OVERLAYFS_MOUNT_OPTIONS environment
          variable. Similarly systemd-confext now supports
          $SYSTEMD_CONFEXT_OVERLAYFS_MOUNT_OPTIONS.

        systemd-vmspawn/systemd-nspawn:

        * systemd-vmspawn will now initialize the "serial" fields of block
          devices attached to VMs to the filename of the file backing them on
          the host. This makes it very easy to reference the right media in
          case many block devices from files are attached to the same VM via
          the /dev/disk/by-id/… links in the VM.

        * systemd-nspawn's .nspawn file gained support for a new NamespacePath=
          setting in the [Network] section which takes a path to a network
          namespace inode, and which ensures the container is run inside that
          when booted. (This was previously only available via a command line
          switch.)

        * systemd-vmspawn gained two new switches
          --bind-user=/--bind-user-shell= which mirror the switches of the same
          name in systemd-nspawn, and allow sharing a user account from the host
          inside the VM in a simple one-step operation.

        * systemd-vmspawn and systemd-nspawn gained a new --bind-user-group=
          switch to add a user bound via --bind-user= to the specified group
          (useful in particular for the 'wheel' or 'empower' groups).

        * systemd-vmspawn now configures RSA4096 support in the vTPM, if swtpm
          supports it.

        * systemd-vmspawn now enables qemu guest agent via the
          org.qemu.guest_agent.0 protocol when started with --console=gui.

        systemd-repart:

        * repart.d/ drop-ins gained support for a new TPM2PCRs= setting, which
          can be used to configure the set of TPM2 PCRs to bind disk encryption
          to, in case TPM2-bound encryption is used. This was previously only
          settable via the systemd-repart command line. Similarly, KeyFile= has
          been added to configure a binary LUKS key file to use.

        * systemd-repart's functionality is now accessible via Varlink IPC.

        * systemd-repart may now be invoked with a device node path specified
          as "-". Instead of operating on a block device this will just
          determine the minimum block device size required to apply the defined
          partitions and exit.

        * systemd-repart gained two new switches --defer-partitions-empty=yes
          and --defer-partitions-factory-reset=yes which are similar to
          --defer-partitions= but instead of expecting a list of partitions to
          defer will defer all partitions marked via Format=empty or
          FactoryReset=yes. This functionality is useful for installers, as
          partitions marked empty or marked for factory reset should typically
          be left out at install time, but not on first boot.

        * The Subvolumes= values in repart.d/ drop-ins may now be suffixed with
          :nodatacow, in order to create subvolumes with data Copy-on-Write
          disabled.

        systemd-udevd:

        * systemd-udevd rules gained support for OPTIONS="dump-json" to dump
          the current event status in JSON format. This generates output
          similar to "udevadm test --json=short".

        * The net_id builtin for systemd-udevd now can generate predictable
          interface names for Wifi devices on DeviceTree systems.

        * systemd-udevd and systemd-repart will now reread partition tables on
          block devices in a more graceful, incremental fashion. Specifically,
          they no longer use the kernel BLKRRPART ioctl() which removes all
          in-memory partition objects loaded into the kernel and then recreates
          them as new objects. Instead they will use the BLKPG ioctl() to make
          minimal changes, and individually add, remove, or grow modified
          partitions, avoiding removal/re-adding where the partitions were left
          unmodified on disk. This should greatly improve behaviour on systems
          that make modifications to partition tables on disk while using them.

        * A new udev property ID_BLOCK_SUBSYSTEM is now exposed on block devices
          reporting a short identifier for the subsystem a block device belongs
          to. This only applies to block devices not connected to a regular bus,
          i.e. virtual block devices such as loopback, DM, MD, or zram.

        * systemd-udevd will now generate /dev/gpio/by-id/… symlinks for GPIO
          devices.

        systemd-homed/homectl:

        * homectl's --recovery-key= option may now be used with the "update"
          command to add recovery keys to existing user accounts. Previously,
          recovery keys could only be configured during initial user creation.

        * Two new --prompt-shell= and --prompt-groups= options have been added
          to homectl to control whether to query the user interactively for a
          login shell and supplementary groups memberships when interactive
          firstboot operation is requested. The invocation in
          systemd-homed-firstboot.service now turns both off by default.

        systemd-boot/systemd-stub:

        * systemd-boot now supports log levels. The level may be set via
          log-level= in loader.conf and via the SMBIOS Type 11 field
          'io.systemd.boot.loglevel='.

        * systemd-boot's loader.conf file gained support for configuring the
          SecureBoot key enrollment time-out via
          secure-boot-enroll-timeout-sec=.

        * Boot Loader Specification Type #1 entries now support a "profile"
          field which may be used to explicitly select a profile in
          multi-profile UKIs invoked via the "uki" field.

        sd-varlink/varlinkctl:

        * sd-varlink's sd_varlink_set_relative_timeout() call will now reset
          the timeout to the default if 0 is passed.

        * sd-varlink's sd_varlink_server_new() call learned two new flags
          SD_VARLINK_SERVER_HANDLE_SIGTERM + SD_VARLINK_SERVER_HANDLE_SIGINT,
          which are honoured by sd_varlink_server_loop_auto() and will cause it
          to exit processing cleanly once SIGTERM/SIGINT are received.

        * varlinkctl in --more mode will now send a READY=1 sd_notify() message
          once it receives the first reply. This is useful for tools or scripts
          that wrap it (and implement the $NOTIFY_SOCKET protocol) to know when
          a first confirmation of success is received.

        * sd-varlink gained a new sd_varlink_is_connected() call which reports
          whether a Varlink connection is currently connected.

        Shared library dependencies:

        * Linux audit support is now implemented via dlopen() rather than
          regular dynamic library linking. This means the dependency is now
          weak, which is useful to reduce footprint inside of containers and
          such, where Linux audit doesn't really work anyway.

        * Similarly PAM support is now implemented via dlopen() too (except for
          the PAM modules pam_systemd + pam_systemd_home + pam_systemd_loadkey,
          which are loaded by PAM and hence need PAM anyway to operate).

        * Similarly, libacl support is now implemented via dlopen().

        * Similarly, libblkid support is now implemented via dlopen().

        * Similarly, libseccomp support is now implemented via dlopen().

        * Similarly, libselinux support is now implemented via dlopen().

        * Similarly, libmount support is now implemented via dlopen(). Note,
          that libmount still must be installed in order to invoke the service
          manager itself. However, libsystemd.so no longer requires it, and
          neither do various ways to invoke the systemd service manager binary
          short of using it to manage a system.

        * systemd no longer links against libcap at all. The simple system call
          wrappers and other APIs it provides have been reimplemented directly
          in systemd, which reduced the codebase and the dependency tree.

        systemd-machined/systemd-importd:

        * systemd-machined gained support for RegisterMachineEx() +
          CreateMachineEx() method calls which operate like their counterparts
          without "Ex", but take a number of additional parameters, similar to
          what is already supported via the equivalent functionality in the
          Varlink APIs of systemd-machined. Most importantly, they support
          PIDFDs instead of PIDs.

        * systemd-machined may now also run in a per-user instance, in addition
          to the per-system instance. systemd-vmspawn and systemd-nspawn have
          been updated to register their invocations with both the calling
          user's instance of systemd-machined and the system one, if
          permissions allow it. machinectl now accepts --user and --system
          switches that control which daemon instance to operate on.
          systemd-ssh-proxy now will query both instances for the AF_VSOCK CID.

        * systemd-machined implements a resolve hook now, so that the names of
          local containers and VMs can be resolved locally to their respective
          IP addresses.

        * systemd-importd's tar extraction logic has been reimplemented based
          on libarchive, replacing the previous implementation calling GNU tar.
          This completes work begun earlier which already ported
          systemd-importd's tar generation.

        * systemd-importd now may also be run as a per-user service, in
          addition to the existing per-system instance. It will place the
          downloaded images in ~/.local/state/machines/ and similar
          directories. importctl gained --user/--system switches to control
          which instance to talk to.

        systemd-firstboot:

        * systemd-firstboot's and homectl's interactive boot-time interface
          have been updated to show a colored bar at the top and bottom of the
          screen, whose color can be configured via /etc/os-release. The bar
          can be disabled via the new --chrome= switches to both tools.

        * systemd-firstboot's and homectl's interactive boot-time interface
          will now temporarily mute the kernel's and PID1's own console output
          while running, in order to not mix the tool's own output with the
          other sources. This logic can be controlled via the new
          --mute-console= switches to both tools. This is implemented via a new
          systemd-mute-console component (which provides a simple Varlink
          interface).

        * systemd-firstboot gained a new switch --prompt-keymap-auto. When
          specified, the tool will interactively query the user for a keymap
          when running on a real local VT console (i.e. on a user device where
          the keymap would actually be respected), but not if invoked on other
          TTYs (such as a serial port, hypervisor console, SSH, …), where the
          keymap setting would have no effect anyway. The invocation in
          systemd-firstboot.service now uses this.

        systemd-creds:

        * systemd-creds's Varlink IPC API now supports a new "withKey"
          parameter on the Encrypt() method call, for selecting what to bind
          the encryption to precisely, matching the --with-key= switch on the
          command line.

        * systemd-creds now allow explicit control of whether to accept
          encryption with a NULL key when decrypting, via the --allow-null and
          --refuse-null switches. Previously only the former existed, but null
          keys were also accepted if UEFI SecureBoot was reported off. This
          automatism is retained, but only if neither of the two switches are
          specified. The systemd-creds Varlink IPC API learned similar
          parameters on the Decrypt() call.

        systemd-networkd:

        * systemd-networkd's DHCP sever support gained two settings EmitDomain=
          and Domain= for controlling whether leases handed out should report a
          domain, and which. It also gained a per-static lease Hostname=
          setting for the hostname of the client.

        * systemd-networkd now exposes a Describe() method call to show network
          interface properties.

        * systemd-networkd now implements a resolve hook for its internal DHCP
          server, so that the hostnames tracked in DHCP leases can be resolved
          locally. This is now enabled by default for the DHCP server running
          on the host side of local systemd-nspawn or systemd-vmspawn networks.

        systemd-resolved:

        * systemd-resolved gained a new Varlink IPC method call
          DumpDNSConfiguration() which returns the full DNS configuration in
          one reply. This is exposed by resolvectl --json=.

        * systemd-resolved now allows local, privileged services to hook into
          local name resolution requests. For that a new directory
          /run/systemd/resolve.hook/ has been introduced. Any privileged local
          service can bind an AF_UNIX Varlink socket there, and implement the
          simple io.systemd.Resolve.Hook Varlink API on it. If so it will
          receive a method call on it for each name resolution request, which
          it can then reply to. It can reply positively, deny the request or
          let the regular request handling take place.

        * DNS0 has been removed from the default fallback DNS server list of
          systemd-resolved, since it ceased operations.

        TPM2 infrastructure:

        * systemd-pcrlock no longer locks to PCR 12 by default, since its own
          policy description typically ends up in there, as it is passed into a
          UKI via a credential, and such credentials are measured into PCR 12.

        * The TPM2 infrastructure gained support for additional PCRs
          implemented via TPM2 NV Indexes in TPM2_NT_EXTEND mode. These
          additional PCRs are called "NvPCRs" in our documentation (even though
          they are very much volatile, much like the value of TPM2_NT_EXTEND NV
          indexes, from which we inherit the confusing nomenclature). By
          introducing NvPCRs the scarcity of PCRs is addressed, which allows us
          to measure more resources later without affecting the definition and
          current use of the scarce regular PCRs. Note that NvPCRs have
          different semantics than PCRs: they are not available pre-userspace
          (i.e. initrd userspace creates them and initializes them), including
          in the pre-kernel firmware world; moreover, they require an explicit
          "anchor" initialization of a privileged per-system secret (in order
          to prevent attackers from removing/recreating the backing NV indexes
          to reset them). This makes them predictable only if the result of the
          anchor measurement is known ahead of time, which will differ on each
          installed system. Initialization of defined NvPCRs is done in
          systemd-tpm2-setup.service in the initrd. Information about the
          initialization of NvPCRs is measured into PCR 9, and finalized by a
          separator measurement. The NV index base handle is configurable at
          build time via the "tpm2-nvpcr-base" meson setting. It currently
          defaults to a value the TCG has shown intent to assign to Linux, but
          this has not officially been done yet. systemd-pcrextend and its
          Varlink APIs have been extended to optionally measure into an NvPCR
          instead of a classic PCR.

        * A new service systemd-pcrproduct.service is added which is similar to
          systemd-pcrmachine.service but instead of the machine ID
          (i.e. /etc/machined-id) measures the product ID (as reported by SMBIOS
          or Devicetree). It uses a new NvPCR called "hardware" for this.

        * systemd-pcrlock has been updated to generate CEL event log data
          covering NvPCRs too.

        systemd-analyze:

        * systemd-analyze gained a new verb "dlopen-metadata" which can show
          the dlopen() weak dependency metadata of an ELF binary that declares
          that.

        * A new verb "nvpcrs" has been added to systemd-analyze, which lists
          NvPCRs with their names and values, similar to the existing "pcrs"
          operation which does the same for classic PCRs.

        systemd-run/run0:

        * run0 gained a new --empower switch. It will invoke a new session with
          elevated privileges – without switching to the root user.
          Specifically, it sets the full ambient capabilities mask (including
          CAP_SYS_ADMIN), which ensures that privileged system calls will
          typically be permitted. Moreover, it adds the session processes to
          the new "empower" system group, which is respected by polkit and
          allows privileged access to most polkit actions. This provides a much
          less invasive way to acquire privileges, as it will not change $HOME
          or the UID and hence risk creation of files owned by the wrong UID in
          the user's home. (Note that --empower might not work in all cases, as
          many programs still do access checks purely based on the UID, without
          Linux process capabilities or polkit policies having any effect on
          them.)

        * systemd-run gained support for --root-directory= to invoke the service
          in the specified root directory. It also gained --same-root-dir (with
          a short switch -R) for invoking the new service in the same root
          directory as the caller's. --same-root-dir has also been added to run0.

        sd-event:

        * sd-event's sd_event_add_child() and sd_event_add_child_pidfd() calls
          now support the WNOWAIT flag which tells sd-event to not reap the
          child process.

        * sd-event gained two new calls sd_event_set_exit_on_idle() and
          sd_event_get_exit_on_idle(), which enable automatic exit from the
          event loop if no enabled (non-exit) event sources remain.

        Other:

        * User records gained a new UUID field, and the userdbctl tool gained
          the ability to search for user records by UUID, via the new --uuid=
          switch. The userdb Varlink API has been extended to allow server-side
          searches for UUIDs.

        * systemd-sysctl gained a new --inline switch, similar to the switch of
          the same name systemd-sysusers already supports.

        * systemd-cryptsetup has been updated to understand a new
          tpm2-measure-keyslot-nvpcr= option which takes an NvPCR name to
          measure information about the used LUKS keyslot into.
          systemd-gpt-auto-generator now uses this for a new "cryptsetup"
          NvPCR.

        * systemd will now ignore configuration file drop-ins suffixed with
          ".ignore" in most places, similar to how it already ignores files
          with suffixes such as ".rpmsave". Unlike those suffixes, ".ignore" is
          package manager agnostic.

        * systemd-modules-load will now load configured kernel modules in
          parallel.

        * systemd-integrity-setup now supports HMAC-SHA256, PHMAC-SHA256,
          PHMAC-SHA512.

        * systemd-stdio-bridge gained a new --quiet option.

        * systemd-mountfsd's MountImage() call gained support for explicitly
          controlling whether to share dm-verity volumes between images that
          have the same root hashes. It also learned support for setting up
          bare file system images with separate Verity data files and
          signatures.

        * journalctl learned a new short switch "-W" for the existing long
          switch "--no-hostname".

        * system-alloc-{uid,gid}-min are now exported in systemd.pc.

        * Incomplete support for musl libc is now available by setting the
          "libc" meson option to "musl". Note that systemd compiled with musl
          has various limitations: since NSS or equivalent functionality is not
          available, nss-systemd, nss-resolve, DynamicUser=, systemd-homed,
          systemd-userdbd, the foreign UID ID, unprivileged systemd-nspawn,
          systemd-nsresourced, and so on will not work. Also, the usual memory
          pressure behaviour of long-running systemd services has no effect on
          musl. We also implemented a bunch of shims and workarounds to
          support compiling and running with musl. Caveat emptor.

          This support for musl is provided without a promise of continued
          support in future releases. We'll make the decision based on the
          amount of work required to maintain the compatibility layer in
          systemd, how many musl-specific bugs are reported, and feedback on
          the desirability of this effort provided by users and distributions.

        Contributions from: 0x06, Abílio Costa, Alan Brady, Alberto Planas,
        Aleksandr Mezin, Alexandru Tocar, Alexis-Emmanuel Haeringer,
        Allison Karlitskaya, Andreas Schneider, Andrew Halaney,
        Anton Tiurin, Antonio Alvarez Feijoo, Antonio Álvarez Feijoo,
        Arian van Putten, Armin Brauns, Armin Wolf, Bastian Almendras,
        Charlie Le, Chen Qi, Chris Down, Christian Hesse,
        Christoph Anton Mitterer, Colin Walters, Craig McLure,
        Daan De Meyer, Daniel Brackenbury, Daniel Foster, Daniel Hast,
        Daniel Rusek, Danilo Spinella, David Santamaría Rogado,
        David Tardon, Dimitri John Ledkov, Dr. David Alan Gilbert,
        Duy Nguyen Van, Emanuele Giuseppe Esposito, Emil Renner Berthing,
        Eric Curtin, Erin Shepherd, Evgeny Vereshchagin,
        Fco. Javier F. Serrador, Felix Pehla, Fletcher Woodruff, Florian,
        Francesco Valla, Franck Bui, Frantisek Sumsal, Gero Schwäricke,
        Goffredo Baroncelli, Govind Venugopal, Guido Günther, Haiyue Wang,
        Hans de Goede, Henri Aunin, Igor Opaniuk, Ingo Franzki, Itxaka,
        Ivan Kruglov, Jelle van der Waa, Jeremy Kerr, Jesse Guo,
        Jim Spentzos, Joshua Krusell, João Rodrigues, Justin Kromlinger,
        Jörg Behrmann, Kai Lueke, Kai Wohlfahrt, Le_Futuriste,
        Lennart Poettering, Luca Boccassi, Lucas Adriano Salles,
        Lukáš Nykrýn, Lukáš Zaoral, Managor, Mantas Mikulėnas,
        Marc-Antoine Riou, Marcel Leismann, Marcos Alano, Marien Zwart,
        Markus Boehme, Martin Hundebøll, Martin Srebotnjak, Masanari Iida,
        Matteo Croce, Maximilian Bosch, Michal Sekletár, Mike Gilbert,
        Mike Yuan, Miroslav Lichvar, Moisticules, Morgan, Natalie Vock,
        Nick Labich, Nick Rosbrook, Nils K, Osama Abdelkader, Oğuz Ersen,
        Pascal Bachor, Pasquale van Heumen, Pavel Borecki, Peter Hutterer,
        Philip Withnall, Pranay Pawar, Priit Jõerüüt, Quentin Deslandes,
        QuickSwift315490, Rafael Fontenelle, Rebecca Cran, Ricardo Salveti,
        Ronan Pigott, Ryan Brue, Sebastian Gross, Septatrix, Simon Barth,
        Stephanie Wilde-Hobbs, Taylan Kammer, Temuri Doghonadze,
        Thomas Blume, Thomas Mühlbacher, Tobias Heider, Vivian Wang,
        Xarblu, Yu Watanabe, Zbigniew Jędrzejewski-Szmek, anthisfan, cvlc12,
        dgengtek, dramforever, gvenugo3, helpvisa, huyubiao, jouyouyun, jsks,
        kanitha chim, lumingzh, n0099, ners, nkraetzschmar, nl6720, q66,
        theSillywhat, val4oss, 雪叶

        — Edinburgh, 2025/12/17

CHANGES WITH 258:

        Incompatible changes:

        * Support for cgroup v1 ('legacy' and 'hybrid' hierarchies) has been
          removed. cgroup v2 ('unified' hierarchy) will always be mounted
          during system bootup and systemd-nspawn container initialization.

        * The minimum kernel baseline version has been bumped to v5.4 (released
          in 2019), with the recommended version now going up to v5.7. Consult
          the README file for a list of required kernel APIs.

        * The default access mode of tty/pts device nodes has been changed to
          0600, which was 0620 in the older releases, due to general security
          concerns about terminals being written to by other users. To restore
          the old default access mode, use the '-Dtty-mode=0620' meson build
          option. (This effectively means "mesg n" is now the default, rather
          than "mesg y", see mesg(1) man page for help.)

        * ACLs for device nodes requested by "uaccess" udev tag are now always
          applied/updated by systemd-udevd through "uaccess" udev builtin, and
          systemd-logind no longer applies/updates ACLs but triggers "change"
          uevents to make systemd-udevd apply/update ACLs. Hence, the "uaccess"
          udev tag should be set not only on "add" action but also on "change"
          action, and it is highly recommended that the rule is applied all
          actions except for "remove" action.
          Recommended example:
              ACTION!="remove", SUBSYSTEM=="hidraw", TAG+="uaccess"
          The following example does not work since v258:
              ACTION=="add", SUBSYSTEM=="hidraw", TAG+="uaccess"
          Udev rules files setting the "uaccess" tag need to have a file name
          starting with a number smaller than 73 to be applied.

        * systemd-run's --expand-environment= switch, which was disabled
          by default when combined with --scope, has been changed to be
          enabled by default. This brings cmdline expansion of transient
          scopes on par with services.

        * systemd-logind PAM sessions that previously were automatically
          determined to be of class "background", and which are owned by root
          or system accounts, will now automatically be set to class
          "background-light" instead. PAM sessions that previously were
          automatically determined to be of class "user", and which are owned
          by non-root system users, will now automatically be set to class
          "user-light" instead. This effectively means that cron jobs or FTP
          sessions (i.e. all PAM sessions that have no TTY assigned and neither
          are graphical) for system users no longer pull in a service manager
          by default. This behaviour can be changed by explicitly setting the
          session class (for example via the class= parameter to
          pam_systemd.so, or by setting the XDG_SESSION_CLASS environment
          variable as input for the service's PAM stack). This change does not
          affect graphical sessions, nor does it affect regular users. This is
          an incompatible change of sorts, since per-user services will
          typically not be available for such PAM sessions of system users.

        * systemd-udevd ignores OWNER=/GROUP= settings with a non-system
          user/group specified in udev rules files, to avoid device nodes being
          owned by a non-system user/group. It is recommended to check udev
          rules files with 'udevadm verify' and/or 'udevadm test' commands if
          the specified user/group in OWNER=/GROUP= are valid.
          Similarly, systemd-networkd refuses User=/Group= settings with a
          non-system user/group specified in .netdev files for Tun/Tap
          interfaces.

        * systemd-cryptenroll, systemd-repart and systemd-creds no longer
          default to locking TPM2 enrollments to the current, literal value of
          PCR 7, i.e. the PCR the SecureBoot policy is measured into by the
          firmware. This change reflects the fact that nowadays SecureBoot
          policies are updated (at least) as frequently as firmware code
          (simply because SecureBoot policy updates are typically managed by
          fwupd these days). The new default PCR mask for new TPM2 enrollments
          is thus empty by default. It is recommended to use managed
          systemd-pcrlock policies for binding to PCR 7 instead (as well as
          combining such policies with signed policies for PCR 11). Or in other
          words, it's recommended to make more use of the logic behind the
          --tpm2-public-key=, --tpm2-public-key-pcrs= and --tpm2-pcrlock=
          switches of the mentioned tools in place of --tpm2-pcrs=.

        * Support for the SystemdOptions EFI variable has been removed.

        * Meson options '-Dsplit-usr=', '-Drootlibdir=', '-Drootprefix='
          (deprecated in v255), '-Ddefault-hierarchy=' (deprecated in v256),
          and '-Dnscd=' (deprecated in v257) have been removed.

        * OpenSSL is now the only supported cryptography backend for
          systemd-resolved and systemd-importd, and support for gnutls and
          gcrypt has been removed. Hence, 'gnutls' setting for the
          '-Ddns-over-tls=' meson option has been deprecated. Also, the
          '-Dcryptolib=' meson option has been deprecated. They will be removed
          in a future release.

        * systemd-logind's session tracking, which used to be performed via a
          FIFO installed in the client, now uses PIDFDs. The file descriptor
          returned by CreateSession() and related calls is therefore unused.
          Moreover, the exit of the session leader process will immediately
          cause the session to be stopped.

        * To work around limitations of X11's keyboard handling systemd's
          keyboard mapping hardware database (hwdb.d/60-keyboard.hwdb) so far
          mapped the microphone mute and touchpad on/off/toggle keys to the
          function keys F20, F21, F22, F23 instead of their correct key codes.
          This key code mangling has been removed from udev.

          To maintain compatibility with X11 applications that rely on the old
          function key code mappings, this mangling has now been added to the
          relevant X11 keyboard driver modules. In order to ensure these keys
          continue to work, update to xf86-input-evdev >= 2.11.0 and
          xf86-input-libinput >= 1.5.0 before updating to systemd >= 258.

        * The D-Bus method org.freedesktop.systemd1.StartAuxiliaryScope() has
          been removed, which was deprecated since v257.

        * systemd-networkd previously emitted the machine ID as chassis ID
          through LLDP protocol, but now emits a deterministic ID,
          cryptographically derived from the machine ID as chassis ID. If you
          want to use the previous behavior, please set
          SYSTEMD_LLDP_SEND_MACHINE_ID=1 environment variable for
          systemd-networkd.

        * Support for the !! command line prefix on ExecStart= lines (and
          related) has been removed, and if specified will be ignored. The
          concept was supposed to provide compatibility with kernels that
          predated the introduction of "ambient" process capabilities. However,
          the kernel baseline of the systemd project is now far beyond any
          kernels that lacked support for it, hence the prefix serves no
          purpose anymore.

        * The default keyring for systemd-importd and related tools, shipped
          in /usr/lib/systemd/, has been renamed from import-pubring.gpg to
          import-pubring.pgp, as it is supported by other PGP tools as well as
          GPG. The local keyring /etc/systemd/import-pubring.gpg is still parsed
          if present, to preserve backward compatibility.

        * Normally, per-user encrypted credentials are decrypted via the the
          systemd-creds.socket Varlink service, while the per-system ones are
          directly encrypted within the execution context of the intended
          service (which hence typically required access to /dev/tpmrm0). This
          has been changed: units that enable either PrivateDevices= or use
          DeviceAllow=/DevicePolicy= (and thus restrict access to device nodes)
          will now also make use of the systemd-creds.socket Varlink
          functionality, and will not attempt to decrypt the credentials
          in-process (and attempt to try to talk to the TPM for that).
          Previously, encrypted credentials for per-system services were
          incompatible with PrivateDevices= and resulted in automatic extension
          of the DeviceAllow= list. The latter behaviour has been removed.

        * The command 'journalctl --follow' now exits with success on
          SIGTERM/SIGINT and when the pipe it is writing to is disconnected.

        * Support for System V style system state control has been removed:
          - The /dev/initctl device node has been removed.
          - The initctl, runlevel, and telinit commands have been removed.
          - Support for system state control via the init command (e.g.
            'init 3') has been removed.
          - The units runlevel[0-6].target have been removed.
          - The concept of runlevels has been removed, so runlevel transitions
            are no longer recorded in the utmp/wtmp databases.

        * Support for traditional /forcefsck and /fastboot files to control
          execution mode of fsck on boot has been removed from systemd-fsck. To
          control the mode, please use the fsck.mode= kernel command line option
          or newly introduced fsck.mode credential.

        * Support for traditional /forcequotacheck file to control execution
          mode of quotacheck on boot has been removed from systemd-quotacheck.
          To control the mode, please use the quotacheck.mode= kernel command
          line option of newly introduced quotacheck.mode credential.

        * systemd-stub v258 requires ukify v257.9 or v258 or newer when
          building a UKI. Due to an incompatible change necessary in order to
          fix a bug related to embedding a .sbat section larger than 512 bytes,
          ukify v257.8 or older will not be able to use systemd-stub v258 or
          newer.

        Announcements of Future Feature Removals:

        * (postponed to v260) Support for System V service scripts is deprecated
          and will be removed in v259. Please make sure to update your software
          *now* to include a native systemd unit file instead of a legacy System
          V script to retain compatibility with future systemd releases.

        * Support for the legacy /run/lock/ directory is deprecated and will be
          removed in v259. Any software that still needs access to this legacy
          directory is encouraged to ship their own tmpfiles.d configuration to
          set it up according to their needs. In general, services should store
          their lock files in RuntimeDirectory=/$RUNTIME_DIRECTORY, and software
          directly executed by users should use $XDG_RUNTIME_DIR. Software
          working with specific devices (e.g. serial port devices) should flock
          the device directly rather than creating a separate lock file.

        * Support for systemd-repart's FactoryReset EFI variable has been
          deprecated and support for it will be removed in v260. Use the newer,
          more generic FactoryResetRequest variable instead, which can be
          managed by "systemd-factory-reset request" and "systemd-factory-reset
          complete".

        * The meson option '-Dintegration-tests=' has been deprecated, and will
          be removed in a future release.

        * The legacy iptables support through libiptc will be removed in v259.
          Only nftables backend will be supported by systemd-networkd and
          systemd-nspawn since v259.

        * (postponed to v260) Required minimum versions of following components
          are planned to be raised in the next release:

          * Linux kernel >= 5.10 (recommended >= 5.14),
          * glibc >= 2.34,
          * libxcrypt >= 4.4.0 (libcrypt in glibc will be no longer supported),
          * util-linux >= 2.37,
          * elfutils >= 0.177,
          * openssl >= 3.0.0,
          * cryptsetup >= 2.4.0,
          * libfido2 >= 1.5.0,
          * libseccomp >= 2.4.0,
          * python >= 3.9.0.

          Please provide feedback on systemd-devel if this would cause problems.

        Service manager/PID1:

        * The PrivateUsers= unit setting now accepts a new value "full", which
          is similar to "identity", but maps the whole 32bit UID range instead
          of just the first 2¹⁶.

        * The ProtectHostname= unit setting now accepts a new value "private",
          which is similar to "yes", but allows the unit's processes to
          modify the hostname. Since a UTC namespace is allocated for the unit
          this hostname change remains local to the unit, and does not affect
          the system as a whole. Optionally, the "private" string may be
          suffixed by a colon and a literal hostname specification, which is
          then used to initialize the hostname of the namespace to.

        * .mount units now also support systemd credentials
          (i.e. SetCredential=/LoadCredential=/ImportCredential= and related
          settings). Previously this was available for service units only.

        * A new unit file condition ConditionKernelModuleLoaded= has been added
          that may be used to check if a certain kernel module is already
          loaded (or built into the kernel). This is used to shortcut
          modprobe@.service instances, reducing redundant explicit modprobe
          invocations at boot to cover for kernels that have various subsystems
          built-in, while still providing support for kernels that have those
          subsystems built as loadable modules.

        * Encrypted systemd service credentials are now available for user
          services too, including if locked to TPM. Previously, they could only
          be used for system services.

        * Services instantiated for Accept=yes socket units will now include
          the Linux socket cookie (SO_COOKIE) in the instance name, as well as
          the PIDFD inode ID for the peer (the latter is only available for
          AF_UNIX sockets). This should make it easier to match specific
          service instances to the connections and peers they are associated
          with.

        * The security rules enforced by the per-unit AttachProcesses() bus API
          call have been relaxed a bit: unprivileged clients may now use the
          call on arbitrary processes which run in any user namespace owned by
          the client's UID. Previously, a stricter rule applied that required
          the UIDs of the process to move and of the client to match exactly.

        * A new per-unit RemoveSubgroup() D-Bus API call has been added that
          makes the service manager attempt to remove a sub-cgroup of units
          with cgroup delegation enabled. This is useful for unprivileged user
          namespace operation, where subgroups might be owned by user IDs that
          do not match the user ID the unit was delegated to, as is typical in
          user namespace scenarios. Per-user service managers will use this new
          call provided by the per-system service manager to clean up user
          units that contain cgroups owned by user namespace UIDs.

        * .mount units gained support for a special x-systemd.graceful-option=
          pseudo-mount option, which may be used to list additional mount
          options that shall be used for the mount when it is established,
          under the condition the local kernel supports them. If the local
          kernel does not, they are automatically removed from the option
          string. This only works for kernel-level mount options, not for those
          implemented in userspace. This is useful for various purposes, for
          example to include "usrquota" for tmpfs mount options where that's
          supported.

        * Per-user quota is now enabled on /dev/shm/ and /tmp/ (the latter only
          if backed by tmpfs).

        * If PAMName= is used for a service and the PAM session prompts for a
          password, it will now be queried via the systemd-ask-password
          logic. Previously the prompt would simply be denied, typically causing
          the PAM session (and thus service activation) to fail. One effect of
          this change is that when lingering is enabled for a systemd-homed
          user the user's password will now be prompted at boot to unlock the
          user's home directory in order to be able to start the per-user
          service manager early, as requested.

        * The $MAINPID and $MANAGERPID environment variables we pass to
          processes executed for service units are now paired with new
          environment variables $MAINPIDFDID and $MANAGERPIDFDID. These new
          environment variables contain the numeric inode ID of the pidfd for
          the relevant process. As these 64bit IDs are unique for all processes
          of a specific Linux boot they can be used to race-freely reference a
          process, unlike the PID which is subject to races by recycling.

        * So far the ConditionHost= condition matched against the local host
          name and machine UUID. It now also matches against the local product
          ID of the system (as provided by SMBIOS/DMI) and the boot ID.

        * A new setting DelegateNamespaces= for units has been added, which
          controls which type of Linux namespaces to delegate to the invoked
          unit processes. This primarily controls if the listed namespace types
          shall be owned by the host user namespace, or by the private user
          namespace of the unit. In the former case services cannot modify the
          relevant namespaces since they don't own it, in the latter case they
          can.

        * If the service manager receives a RESTART_RESET=1 sd_notify() message
          from a service, it will now reset the automatic restart counter it
          maintains for the service. This is useful to give services control
          over RestartMaxDelaySec=/RestartSteps= progress.

        * The /etc/hostname file may now include question mark characters
          ("?"), which when read will be initialized by hexadecimal digits
          hashed from the machine ID. This is useful when managing a fleet of
          devices that each shall have a valid and distinct hostname, generated
          in a predictable fashion. Example: if /etc/hostname contains
          "foobar-????-????" each booted system will end up with a hostname
          such as "foobar-7aaf-846c" or similar.

        * ConditionKernelVersion= has been replaced by a more generic
          ConditionVersion= setting, that can check the versions of more key
          components of the OS, besides the kernel. Initially, that's systemd's
          and glibc's versions. The older setting remains supported for
          compatibility.

        * Slice units gained new ConcurrencySoftMax= and ConcurrencyHardMax=
          settings which control how many concurrent units may be active and
          queued for the slice at the same time. If more services are queued
          for a slice than the soft limit, they won't be dispatched until the
          concurrency falls below the limit again, but they remain in the job
          queue. If more services are queued than the hard limit the jobs will
          fail. This introduces a powerful job execution mechanism to systemd,
          with strong resource management, and support for hierarchial job
          pools (by means of slices).

        * ExecStart= lines (and the other ExecXYZ= lines) now support a new '|'
          prefix that causes the command line to be invoked via a shell.

        * A basic Varlink API is now implemented in the service manager that
          can be used to determine its current state, and list units and their
          states.

        * Processes invoked via the .socket Accept=yes logic will now get an
          environment variable $SO_COOKIE that contains the Linux socket
          cookie (which otherwise can be acquired via getsockopt()) of the
          connection socket, formatted in decimal.

        * When a service's configuration is reloaded (via "systemctl reload" or
          an equivalent operation), any confext images for the services are
          also reloaded.

        * A new RandomizedOffsetSec= setting has been added to .timer units
          which allows configured of a randomized but stable time offset for
          when the timer shall elapse.

        * Whenever a TTY is initialized by the service manager, an attempt is
          made to read the terminfo identifier from it via DCS sequences, as
          part of the regular ANSI sequence initialization scheme. The
          identifier is used to initialize $TERM. This is not done if $TERM is
          already set from some other sources. Note that the DCS sequence for
          this is widely supported, but not universal (at this point VTE-based
          terminal emulators lack the necessary support). This functionality
          should be particularly useful on serial TTYs as $TERM information
          will likely be initialized to a useful value instead of a badly
          guessed default of vt220.

        * .socket units gained a new PassPIDFD= setting that controls the new
          SO_PASSPIDFD socket option for AF_UNIX socket. There's also a new
          setting AcceptFileDescriptors= that controls the new SO_PASSRIGHTS.

        * A new job type "lenient" has been added, that is similar to the
          existing "fail" job mode, and which will fail the submitted
          transaction immediately if it would stop any currently running unit.

        * .socket units gained a new pair of settings DeferTrigger= and
          DeferTriggerMaxSec= which modify triggering behaviour of the
          socket. When used this will cause the triggered unit to be enqueued
          with the new "lenient" job mode, and if the submission of the
          transaction fails it is later retried to be submitted (up to a
          configurable timeout), whenever a unit is stopped.

        * The "preset" logic has been extended so that there are now three
          preset directories: one that declares the default enablement state
          for per-system services run on the host, one for per-user services,
          and – now new – one for per-system services that are run in the
          initrd. This reflects the fact that in many cases services that shall
          be enabled by default on the host should not be enabled by default in
          the initrd, or vice versa. Note that while the regular per-system
          preset policy defaults to enabled, the one for the initrd defaults to
          disabled.

        * There are now new per-service settings
          StateDirectoryQuota=/StateDirectoryAccounting=,
          CacheDirectoryQuota=/CacheDirectoryAccounting=,
          LogsDirectoryQuota=/LogsDirectoryAccounting= which allow doing
          per-unit quota of the indicated per-unit directories. This is
          implemented via project quota, as supported by xfs and ext4. This
          does not support btrfs, currently. If quota accounting is enabled
          this information is shown in the usual "systemctl status" output.

        * The service manager gained a new KillUnitSubgroup() syscall which may
          be used to send a signal to a sub-control group of the unit's control
          group. systemctl kill gained a new --kill-subgroup= switch to make
          this available from the shell.

        * A new PrivateBPF= switch has been added for unit files, which may be
          used to mount a private bpffs instance for the unit's processes.

        * Four new options added to mount the bpffs with the delegate options:
          BPFDelegateCommands= BPFDelegateMaps=
          BPFDelegatePrograms= BPFDelegateAttachments=
          These allow an unprivileged container to use some BPF functionalities.
          See also https://lwn.net/Articles/947173/

        * New user manager services systemd-nspawn@.service and
          systemd-vmspawn@.service and a machines.target unit to manage them
          have been added.

        systemd-journald & journal-remote:

        * journalctl's --setup-keys command now supports JSON output.

        * HTTP compression negotiation has been added to journal-upload and
          journal-remote.

        * journal-remote/journal-upload now support inserting additional HTTP
          fields into their requests, via the Header= configuration file setting.

        * journalctl gained a new --synchronize-on-exit=yes switch. If
          specified in combination with --follow and the journalctl process
          receives SIGINT (for example because the user hits Ctrl-C), a
          synchronization request is enqueued to systemd-journald, and log
          output continues until it completes. Or in other words, when this
          option is used any log output submitted before the SIGINT is
          guaranteed to be shown before journactl exits.

        * systemd-journald's Synchronize() Varlink call has been reworked so
          that it no longer returns only once the logging subsystem has become
          completely idle, but already when all messages queued before the call
          was initiated are definitely written to disk. Effectively this means
          that the call is now guaranteed to complete in bounded time, even
          though it's slightly weaker in effect.

        * Many of systemd-journald's Varlink calls (such as the aforementioned
          Synchronize()) are now available to unprivileged clients.

        systemd-udevd & systemd-hwdb:

        * A new udev property ID_NET_BRING_UP_BEFORE_JOINING_BRIDGE= is now
          supported that may be set on network interface devices (via hwdb),
          and tells systemd-networkd to bring the interface up before joining
          it to a bridge device.

        * A new udev property ID_NET_NAME_INCLUDE_DOMAIN= is now supported that
          may be set on network interface devices (via hwdb), that indicates
          that the automatic network device naming logic should suppress
          inclusion of the PCI domain in the naming scheme. This is used for
          Azure MANA devices.

        * A new udev property ID_AV_LIGHTS= has been defined that may be set on
          USB controlled A/V lights. Devices marked like this (via hwdb) will
          have the uaccess logic enabled, i.e. they will be associated with a
          seat and unprivileged users will get access to them.

        * udevadm's trigger command gained a switch --include-parents. If
          specified udevadm will not just trigger all devices matching whatever
          is specified otherwise on the command line, but also all parent
          devices of these devices.

        * systemd-udevd now provides a Varlink interface with various runtime
          and lifecycle operations. It mostly replaces the previous private,
          undocumented "control" IPC API spoken between udevadm and
          systemd-udevd.

        * .link files gained two new knobs ReceiveFCS= (which controls whether
          to pass the Frame Check Sequence value up the stack) and ReceiveAll=
          (which controls whether to accept damaged Ethernet frames). It also
          gained a knob PartialGenericSegmentationOffload= for controlling
          Partial GSO support.

        * 'udevadm info/trigger/test/test-builtin' commands now also take device
          IDs to specify devices.

        * udevadm test gained a new "--verbose" switch for generating
          additional debug output for the test.

        * The OPTIONS= udev expression now supports the new "dump" value, which
          will result in the current event's status to be logged at the moment
          the expression is processed. This is useful for debugging udev rules.

        * A new kernel command line option udev.trace= has been added that
          allows enabling udev's tracing logic while booting an OS. udevadm
          control gained a new --trace= switch to change the same setting at
          runtime.

        * udevadm test gained a new --extra-rules-dir= switch which may be
          used to look for udev rules in additional directories for testing
          purposes.

        * udevadm gained a new "cat" command for showing the contents of
          installed rules files.

        * udev will now create /dev/input/by-{id,path}/* style symlinks for
          hidraw devices too. (Previously these would be created for other
          input device types only.)

        * *.link files gained support for configuring various Energy Efficient
          Ethernet (EEE) settings in a new [EnergyEfficientEthernet] section.

        * udevadm test gained a new --json= switch for generating JSON output.

        * A new udev builtin "factory_reset" has been added that simply reports
          if the system is currently booted in factory reset mode. This can be
          used by udev rules that determine the location of the root file
          system, in order to decide whether to expect that a root file already
          exists or still needs to be created/formatted/encrypted.

        * The "blkid" builtin of udev has been changed to determine the host
          root file system by looking for the used ESP/XBOOTLDR only while
          running in the initrd. When running after the initrd→host transition
          it now just uses the root file system already mounted to /. Of
          course, usually this should have the same results, but there are
          situations thinkable where the ESP is on one disk and the root fs on
          another, and we better not second guess this once we transitioned
          onto the root file system.

        * A new udev builtin "dissect_image" has been added that uses the usual
          DDI image dissection code to identify partitions and their use and
          relationships. This is used by new udev rules to generate a set of
          symlinks in /dev/disk/by-designator/ that point to the various
          discovered partitions by their designator.

        * Android debug USB interfaces (ADB DbC, ADB, Fastboot) are now
          automatically marked for unprivileged access, generically via a new
          ID_DEBUG_APPLIANCE= udev property. Or in other words, running "adb"
          again your Android phone connected via USB, set to debug mode should
          just work without any additional rules.

        * A new standard group "clock" has been introduced that is now used by
          default for PTP and RTC device nodes in /dev/.

        systemd-networkd:

        * systemd-networkd now supports configuring the timeout for IPv4
          Duplicate Address Detection via a new setting
          IPv4DuplicateAddressDetectionTimeoutSec=. The default timeout value
          has been changed from 7 seconds to 200 milliseconds.

        * systemd-networkd gained support for IPv6 SIP, i.e. DHCPv6 options
          SD_DHCP6_OPTION_SIP_SERVER_DOMAIN_NAME (21) and
          SD_DHCP6_OPTION_SIP_SERVER_ADDRESS (22), controlled by a new UseSIP=
          option in the [DHCPv6] section.

        * A new MPLSRouting= setting in the [Network] section in .network files
          can be used to control whether Multi-Protocol Label Switching is
          enabled on an interface.

        * A system-wide default for ClientIdentifier= may now be set in
          networkd.conf. (Previously this had to be configured individually in
          each .network file.)

        * PersistLeases= setting in [DHCPServer] section now also accepts
          "runtime", to make the DHCP server saves and loads bound leases on
          the runtime storage.

        * A new Preference= setting has been added to the [IPv6RoutePrefix]
          section to configure the route preference field.

        * New LinkLocalLearning=, Locked=, MACAuthenticationBypass=,
          VLANTunnel= settings have been added the [Bridge] section of .network
          files.

        * .netdev files gained new External=/VNIFilter= settings in [VXLAN]
          section.

        * .netdev files can now configure HSR/SRP network devices too, via a
          new [HSR] section.

        * The LLDP client will now pick up the VLAN Id from LLDP data. The LLDP
          sender will now send this field on VLAN devices.

        * The DHCPv4 client in systemd-networkd now also supports BOOTP (via a
          new BOOTP= setting).

        * The Local= setting in [Tunnel] section gained a new "dhcp_pd" value
          to allow setting the local address based on dhcp-pd addresses.

        sd-varlink & sd-json:

        * An API call sd_varlink_reset_fds() has been added that undoes the
          effect of sd_varlink_push_fd() (the API for submitting file
          descriptors to send along with a method call), without actually
          sending a Varlink message.

        * An API call sd_varlink_server_listen_name() has been added that is
          just like sd_varlink_server_listen_auto() but takes one additional
          parameter: the file descriptor name (in the sense of $LISTEN_FDNAMES)
          to look for, instead of "varlink". This is useful for services that
          implement multiple Varlink services on distinct sockets and shall be
          activatable through either.

        * A pair of API calls sd_json_variant_type_from_string() and
          sd_json_variant_type_to_string() have been added that may be used to
          convert the JSON variant type identifier into a string representation
          and back.

        * A pair of API calls sd_varlink_get_input_fd() and
          sd_varlink_get_output_fd() have been added that allow querying the
          connection file descriptors individually for each direction, in case
          two distinct file descriptors are used (for example in stdin/stdout
          scenarios).

        * A new API call sd_varlink_get_current_method() has been added which
          reports the method call name currently being processed.

        * Two new flags SD_VARLINK_SERVER_ALLOW_FD_PASSING_INPUT and
          SD_VARLINK_SERVER_ALLOW_FD_PASSING_OUTPUT have been defined, which
          may be passed to sd_varlink_server_new(), and ensure that any
          connections associated with the server instance are automatically
          created with file descriptor passing enabled for input or output.

        * The "io.systemd.System" fallback Varlink errors that sd-varlink
          generates for Linux 'errno' style error numbers now carry both the
          numeric value (as before) and the symbolic name (i.e. "ENOENT"),
          ensuring that the error remains somewhat portable (as the numeric
          values are Linux and possibly architecture-specific).

        * The generic "io.systemd.service" Varlink service that various of our
          long-running services implement, gained a new GetEnvironment() call
          that returns the current environment block of the service's main
          process. In addition, this service interface has been implemented in
          many more long-running services.

        * A new sd-varlink call sd_varlink_get_description() has been added
          that returns the string previously set via
          sd_varlink_set_description().

        * A new sd-varlink API call sd_varlink_get_n_fds() has been added that
          returns the number of pending incoming file descriptors on the
          current message.

        * A new flag SD_VARLINK_SERVER_MODE_MKDIR_0755 may now be ORed into the
          mode parameter of sd_varlink_server_listen_address(). If specified
          then any leading directories in the provided AF_UNIX socket path are
          automatically created with an 0755 access mode, should they be
          missing.

        * sd_varlink_idl_parse() and sd_varlink_interface_free() have been
          added to sd-varlink, which can be used to parse Varlink IDL data.

        varlinkctl:

        * varlinkctl gained a new --exec switch. When used a command line of a
          command to execute once a Varlink method call reply has been received
          may be specified. The command will receive the method call reply on
          standard input in JSON format, and any passed file descriptors via
          the $LISTEN_FDS protocol. This is useful for invoking method calls
          that return file descriptors from shell scripts.

        * varlinkctl gained a new --push-fd= switch which may be used to issue
          a Varlink method call and send along one or more file descriptors on
          transports that support it (i.e. AF_UNIX).

        sd-device:

        * A new API call sd_device_enumerator_add_all_parents() has been added
          that may be used to include all parent devices of otherwise matching
          devices in the enumeration.

        * A new API call sd_device_get_sysattr_value_with_size() has been added
          that returns a sysfs attribute file in binary form along with its
          size.

        systemd-logind:

        * A new configuration knob WallMessages= has been added to logind.conf,
          which may be used to control whether wall(1) style messages shall be
          sent to all consoles when the system goes down.

        * A new pseudo session class "none" has been defined. This may be used
          with the class= parameter of pam_systemd.so (and some other places)
          to disable allocation of a systemd-logind session for a specific
          session. Note that this is not a recommended mode of operation, as
          such "ghost" sessions will not be properly accounted for, and are
          excluded from the per-user/per-session resource accounting.

        * Two new session classes "user-light"/"user-early-light" have been
          added, that are just like the regular "user"/"user-early" session
          classes, but differ in one way: they do not cause activation of the
          per-user service manager. These new session classes are now used for
          logins of non-regular users which are used in a non-interactive way.

        * The pidfd inode ID of a session's leader process is now exposed as
          D-Bus property for session objects, in addition to the PID. The inode
          ID is a 64bit unique identifier for a process that is not vulnerable
          to recycling issues.

        systemd-resolved:

        * When issuing parallel A and AAAA lookups for the same domain name,
          and one succeeds quickly, we'll now shorten the timeout for the
          other. This should improve behaviour with DNS servers whose IPv6
          support is flaky and reply to A quickly but not at all to AAAA.

        * The "Monitor" Varlink IPC API of systemd-resolved now gained support
          for a new SubscribeDNSConfiguration() call that enables subscription
          to any DNS configuration changes, as they happen.

        * systemd-networkd-wait-online gained a new --dns switch that ensures
          that not only network connectivity is available, but also DNS
          configuration is established in systemd-resolved, making use of the
          new, aforementioned Varlink interface.

        * resolved.conf gained a new setting RefuseRecordTypes= which takes a
          list of RR types for which to refuse lookup attempts. This may be
          used to for example block A or AAAA lookups on IPv4- or IPv6-only
          hosts.

        * A new DNS "delegate zone" concept has been introduced, which are
          additional lookup scopes (on top of the existing per-interface and
          the one global scope so far supported in resolved), which carry one
          or more DNS server addresses and a DNS search/routing domain. It
          allows routing requests to specific domains to specific servers.
          Delegate zones can be configured via drop-ins below
          /etc/systemd/dns-delegate.d/*.dns-delegate.

        * "resolvectl query -t sshfp" will now decode the returned RR
          information, and show the cryptographic algorithms by name instead of
          number.

        * The search domains hard cap has been bumped from 256 to 1024, in order
          to accommodate complex network setups.

        systemd-hostnamed:

        * The system hardware's serial number may now be read from DeviceTree
          too, in addition to the existing SMBIOS/DMI based logic.

        * New properties for the Chassis Asset Tag, the hardware SKU, and the
          hardware version are now provided (backed by SMBIOS/DMI).

        * hostnamed also exposes properties now for the image ID and image
          version (this is very useful on image-based systems).

        systemd-stub, systemd-boot & bootctl:

        * UEFI firmware images may now be embedded in UKIs (in an ".efifw" PE
          section), for use in bring-your-own-firmware scenarios in
          Confidential Computing. The firmware is matched via CHIDs to the
          local invoking VM, in a fashion conceptually close to the DeviceTree
          selection already available since v257. If a suitable firmware image
          is found at boot, and the system's firmware version does not match it,
          the update is applied and the system is rebooted. If the firmware
          matches, boot proceeds as usual.

        * When systemd-stub is invoked through a network boot provided UKI, it
          will now query the source URL and write it to the LoaderDeviceURL EFI
          variable. This may then be used by Linux userspace to look for
          further resources (such as a root disk image) at the same location.

        * systemd-boot now understands two new Boot Loader Specification Type #1
          stanzas: "uki" and "uki-url", which is very similar to "efi" and
          "linux", and references an UKI, the latter on a remote HTTP/HTTPS
          server. The latter is particularly relevant for implementing a fully
          UKI based boot process, but with network provided UKI images.

        * systemd-boot now looks for the special SMBIOS Type #11 vendor strings
          io.systemd.boot.entries-extra=, and synthesizes additional boot menu
          entries from the provided data. This is useful with systemd-vmspawn's
          --smbios11= switch, see below.

        * systemd-stub now defaults to a minimum of 120 available PE sections,
          instead of the previous default of 30. This reflects the fact that
          multi-profile UKI typically require a lot more sections than
          traditional single-profile UKIs. Note that this is just a
          compile-time default, downstream distributions might choose to raise
          this further – in particular on ARM systems where many Devicetree
          blobs shall be embedded into an UKI.

        * systemd-boot's loader.conf configuration file gained a new
          "reboot-on-error" setting which controls what to do if booting a
          selected entry fails, i.e. whether to reboot or just show the menu
          again.

        * bootctl's --no-variables switch has been replaced by
          --variables=yes/no. By setting --variables=yes modification of EFI
          variables can be forced now in environments where we'd previously
          automatically turn this off (e.g. in choot() contexts).

        * bootctl's --graceful is now implicitly enabled when running in a
          chroot, to ease integration in packaging scriptlets.

        * systemd-stub gained support for a couple of "extension" CHIDs, that
          are not part of the Microsoft's original spec, and which include EDID
          display identification information in the hash. This may be used to
          match Devicetree blobs in UKIs. "systemd-analyze chid" has been
          updated to support these extension CHIDs, too. (They are clearly
          marked as extensions CHIDs, to emphasize they are systemd's own
          invention, and not based on the Windows CHID spec.)

        * systemd-boot's loader.conf configuration file gained a new
          secure-boot-enroll-action setting which controls the action to take
          once automatic Secure Boot keys have been enrolled, i.e. whether to
          reboot or whether to shut down the system.

        * Userspace may set a new LoaderSysFail EFI variable. It is used by
          systemd-boot: when set and the system firmware reports some kind of
          system failure (for now this is pretty much only about failed
          firmware updates), systemd-boot will use the specified entry instead
          of following the usual fallback entry selection logic. bootctl gained
          a new "set-sysfail" verb to set this variable.

        * systemd-boot will now set LoaderTpm2ActivePcrBanks EFI variable to
          let the userspace know which TPM2 PCR banks are available. This is
          more reliable then trying to figure this out through sysfs.

        * systemd-stub will now also load global sysexts and confexts from
          ESP/loader/extensions/*.{sysext,confext}.raw.

        systemd-nsresourced & systemd-mountfsd:

        * When a new user namespace is registered and a name for it must be
          supplied, this name may now optionally be mangled automatically so
          that it follows the naming rules for namespaces employed. This makes
          it easier to provide suitable identifiers to the service, without any
          client-side preparations or clean-ups, and thus ensures allocation of
          a userns can ultimately "just work".

        * A special, fixed UID/GID range has been defined called the "foreign"
          UID/GID range. It's intended to be used to persistently own
          bootable OS/container images on disk (i.e. OS trees that use a
          UID/GID assignments not local to the host, but "foreign", i.e. they
          have their own /etc/passwd + /etc/group table or similar database),
          so that they can be mapped to other user namespace UID/GID ranges at
          runtime through ID-mapped mounts.

        * systemd-mountfsd gained a new IPC call accessible to unprivileged
          clients for acquiring an ID-mapped mount for any OS/container
          directory tree which is itself owned by the foreign UID/GID range,
          and has a parent directory owned by the caller's UID. This means the
          systemd-nsresourced/systemd-mountfsd combination is now suitable for
          running unprivileged containers both from a disk image and from a
          directory tree.

        * When activating a DDI via mountfsd's MountImage() call the returned
          data will now include the literal path to attach each returned path
          to, to simplify implementation of clients.

        * systemd-nsresourced gained an API for allocating a network TAP device
          to associate with a user namespaces. This can be used by unprivileged
          VMMs, to acquire IP networking. The network interface associated with
          the TAP device comes with a matching .link and .network file, so that
          systemd-networkd will set up IP routing (with masquerading) on it
          automatically.

        * systemd-nsresourced will now always ask polkit for authorization of
          its operations, even if they are supposed to be accessible to
          unprivileged clients, so that the PK policy has the last word.

        * systemd-nsresourced gained a new API call MakeDirectory(), which
          creates a new directory, owned by the foreign UID range. It's
          supposed to be used in conjunction with MountDirectory() for creating
          and populating new container trees within user/$HOME context.

        systemd-nspawn:

        * Support for unprivileged invocation of container images stored in
          plain directories has been added, using the new IPC APIs provided by
          "systemd-mountfsd", see above.

        * systemd-nspawn's --private-users= switch now supports a new value
          "managed", which will ensure allocation of a userns via
          systemd-nsresourced, even if run privileged.

        * If systemd-nspawn is used interactively, two new special key
          sequences can be used to trigger an immediate clean shutdown or
          reboot of the container with systemd running as PID 1: '^]^]p' for
          shutdown and '^]^]r' for reboot. This is in addition to the
          previously supported '^]^]^]' which triggers immediate shutdown
          without going through the usual shutdown logic.

        * systemd-nspawn will now invoke the TTY password agent if invoked
          interactively and without privileges. This makes sure unprivileged
          containers start to work even when no other polkit agent is currently
          running for the user. The usual --no-ask-password switch is now also
          available in systemd-nspawn to disable this.

        * systemd-nspawn gained a new --bind-user-shell= switch which allows to
          tweak the shell field of users bound into a container with
          --bind-user=….

        systemd-vmspawn:

        * A new --smbios11= switch may be used to pass an SMBIOS Type #11
          vendor string easily into the booted process. This has various uses,
          one of them is to add additional menu entries to systemd-boot for a
          specific invocation. Example:

          --smbios11=io.systemd.boot.entries-extra:particleos-current.conf=$'title ParticleOS Current\nuki-url http://example.com/somedir/uki.efi'

        * A new switch --grow-image= has been added taking a size in bytes. If
          specified, the image booted into is grown to the specified size if
          found to be smaller.

        * systemd-vmspawn supports unprivileged networking now, using
          systemd-nsresourced's new API to acquire a TAP network device
          unprivileged.

        * systemd-vmspawn now supports --slice and --property= settings,
          matching systemd-nspawn.

        * A new --tpm-state= setting allows precise control of TPM state
          persistency.

        * A new --notify-ready= setting can be used to specify whether to
          expect a READY=1 notification from the guest.

        systemd-machined:

        * systemd-machined now provides a comprehensive Varlink IPC API.

        * The pidfd inode ID of a machine's leader process is now exposed as
          D-Bus property for machine objects, in addition to the PID. The inode
          ID is a 64bit unique identifier for a process that is not vulnerable
          to recycling issues.

        * A new "org.freedesktop.machine1.register-machine" polkit action is
          used when checking for privileges to register a machine. Previously,
          "org.freedesktop.machine1.create-machine" was used for creation and
          registration operations.

        * systemd-machined now also tracks the "supervisor" process of a
          machine, i.e. the host process that manages the payload. This
          information is exposed through the Supervisor/SupervisorPIDFDId D-Bus
          properties and "supervisor"/supervisorProcessId" varlink properties.

        systemd-measure, ukify, systemd-keyutil, systemd-sbsign:

        * systemd-measure gained a new "policy-digest" verb. It's a lot like
          "sign" but instead of calculating the right TPM policy digest for a
          specific UKI to sign and then signing it, it leaves the latter step
          out. This is useful to implement offline signing of the policy digest
          of UKIS. ukify gained a --policy-digest option that exposes this
          logic.

        * ukify gained a new --sign-profile= switch for signing a specific UKI
          profile (to support multi-profile UKIs).

        * ukify gained a pair of --join-pcrsig= and --pcrsig= options which is
          useful for offline signing TPM PCR policies, as it allows inserting
          pre-prepared PCR signature blobs into a UKI.

        * ukify gained a new --pcr-certificate= switch that takes the path to
          an X.509 certificate to use in place of a PEM public key, as provided
          via the existing --pcr-public=.

        * systemd-keyutil gained a new verb "pkcs7" which can be used to
          convert between PKCS#1 and PKCS#7 signatures. The --content= switch
          may be used to generate inline signatures (as opposed to the default
          of detached signatures). It also gained a new --hash-algorithm=
          switch to select the hash algorithm for signatures.

        * systemd-sbsign learnt support for offline SecureBoot signing via
          --prepare-offline-signing, --signed-data=, --signed-data-signature=.

        TPM2:

        * A new PCR phase string is now measured into PCR 11 when storage
          target mode is entered, ensuring that access to TPM key material can
          be taken away, once storage target mode is activated.

        * Similarly, a new string is measured when booting into factory reset
          mode.

        * A new service systemd-tpm2-clear.service has been introduced that can
          be used to request clearing of the local TPM on next reboot. It comes
          with a kernel command line option systemd.tpm2_allow_clear= that
          controls its effect. The unit is hooked into the generic
          factory-reset.target unit, so that it can do its thing when a factory
          reset is requested.

        * If systemd-pcrextend (i.e. the tool making the various userspace TPM
          PCR measurements) fails to do its thing, an immediate reboot is now
          triggered, ensuring that somehow making PCR extensions fails cannot
          be used to gain access to TPM objects to which access should have
          been blocked already via PCR measurements.

        * systemd-pcrlock gained a new "is-supported" verb that determines
          whether local TPM and system provide all necessary functionality for
          systemd-pcrlock to work. It does a superset of the checks
          "systemd-analyze has-tpm2" does, and additionally ensures that the
          TPM supports PolicyAuthorizeNV and SHA-256.

        systemd-userdbd & systemd-homed:

        * User records now support a new field "aliases" that may list
          additional names the user record shall be accessible under. Any
          string listed in the "aliases" array may be used wherever and
          whenever the primary name may be used too, for example when logging
          in. systemd-homed and in particular homectl have been updated to
          support configuration of such alias names.

        * If a user record has an initialized "realm" field, then the record
          may now be referenced via the primary user name or any alias name,
          suffixed with "@" and the realm, too.

        * User records gained new fields tmpLimit, tmpLimitScale, devShmLimit,
          devShmLimitScale which enforce quota on /tmp/ and /dev/shm/ at login
          time, either in absolute or in relative values. These values default
          to 80% for regular users, ensuring that a single user cannot easily
          DoS a local system by taking away all disk space in /tmp/. The
          homectl tool has been updated to make these new fields configurable.

        * The userdb Varlink interface has been extended to support server-side
          filtering by UID/GID min/max, fuzzy name matching and user
          disposition. Previously this was supported by the userdbctl
          client-side only. With this, userdb providers may now optionally
          implement this server-side too in order to optimize the lookups.

        * User records now support a concept of home "areas",
          i.e. subdirectories of the primary $HOME directory that a user can
          log into. This is useful to maintain separate development
          environments or configuration contexts, but within the ownership of
          the same user. Support for this is implemented in systemd-homed, but
          is conceptually open to other backends, too.

          New home areas can be created via "mkdir -p ~/Areas/ && cp /etc/skel
          ~/Areas/foo", or removed by "rm -rf ~/Areas/foo". Whenever prompted
          for login and a user name is requested, it is possible to enter a
          username suffixed by "%" and the area name in order to log into the
          specified area of the user. (e.g. "bar%foo"). Effectively this
          ensures that $HOME and $XDG_RUNTIME_DIR include the area choice after
          login. Note that at this moment it's not possible to log into a full
          graphical session with this, since we'd have to start a per-area user
          service manager for that, and we currently do not do this. But we
          hope to provide this in one of the next releases. In order to
          implement all this user records gained a new "defaultArea" field,
          which is configurable with homectl's --default-area= switch.

        * An explicit MIME type application/x.systemd-home is now used for all
          LUKS *.home files managed by systemd.

        * userdbctl gained a new switch --from-file=. If used the tool will not
          look up a user or group record from the system's user database but
          instead read it from the specified JSON file, and then present it in
          the usual, human-readable fashion.

        * systemd-homed gained D-Bus API calls for listing, adding, removing and
          showing use record signing keys.

        * homectl gained the verbs "list-signing-keys", "get-signing-key",
          "add-signing-key", "remove-signing-key" and a switch
          --key-name=. These may be used to easily make a single home directory
          usable on multiple systems. A system credential
          home.add-signing-key.* has been added that allows provisioning such
          user record signing keys at boot.

        * homectl gained a new switch "--dry-run" which can be used when
          registering/creating users, and which will show the user record data
          before it's submitted to systemd-homed. The tool will then terminate
          before the submission.

        * User/group records' perMachine section now support negative matches
          too (i.e. for settings that apply to all systems but some selected
          few).

        * systemd-homed gained a bus API call AdoptHome() for "adopting" a
          .home file or .homedir directory from a foreign system
          locally. homectl added a verb "adopt" exposing the new call. Together
          with the signing key management functionality described above it
          makes it very easy to migrate homes between systems.

        * systemd-homed gained two new bus API calls RegisterHome() and
          UnregisterHome() for registering a home locally by providing just the
          user record, without any logic to actually create the home directory.
          homectl gained "register" and "unregister" verbs exposing this. This
          is useful for registering network user accounts locally, i.e. where
          some foreign user record and home directory already exists on some
          server, and just need to be registered locally. This can be used to
          make a local systemd-homed home directory securely accessible from
          some other system:

          $ homectl update lennart --ssh-authorized-keys=… -N \
              --storage=cifs --cifs-service="//$HOSTNAME/lennart"
          $ homectl get-signing-key |
              ssh targetsystem homectl add-signing-key --key-name="$HOSTNAME".public
          $ homectl inspect -E lennart |
              ssh targetsystem homectl register -
          $ ssh lennart@targetsystem

          There's also a new system credential 'home.register.*' that causes
          registration for the provided user record automatically at boot.

        * homectl gained a new switch --seize= taking a boolean argument. If
          true when used together with the "create" or "register" verbs any
          cryptographic signature information is stripped from the user record,
          taking over the user record for local ownership. This switch is
          useful when migrating a home directory to a different host, without
          retaining the relationship to the originating host.

        * homectl gained a new --match= switch which allows to generate
          accounts with perMachine matching sections.

        * userdbctl gained a new verb "load-credentials", with a service unit
          systemd-userdb-load-credentials.service which invokes it. When
          invoked this command will look for any passed credentials named
          userdb.user.* or userdb.group.*. These credentials may contain
          user/group records in JSON format. They will be copied into
          /run/userdb/ (where static userdb JSON records can be placed), with
          the appropriate symlink from the UID/GID added in, as any membership
          relationships between user/groups replicated as .membership files. Or
          in other words: it's very easy to provision a complete user/group
          record in an invoked system, by providing the user/group JSON record
          as system credential. Note that these credentials are unrelated to
          similar credentials supported by systemd-homed. "userdb
          load-credentials" creates "static" user records via drop-in files in
          /run/userdb/ (and thus covers system users and suchlike) while
          systemd-homed creates only systemd-homed managed use (i.e. only
          regular users).

        * User/group records gained a new "uuid" field that may be used to
          place an identifying UUID in the record.

        systemd-run and run0:

        * run0 gained a new --lightweight= switch which controls whether to
          pull in a service manager for the target session (i.e. this
          ultimately chooses between the "user"/"user-early" session class on
          one hand or the "user-light"/"user-early-light" session class on the
          other, see above).

        * systemd-run gained a new --job-mode= switch for controlling the job
          mode when enqueuing the start job for the transient unit. This is
          similar to the switch of the same name of "systemctl start".

        * run0 gained a new --area= switch for directly entering a specific
          home area (see above).

        * systemd-run/run0 gained a new --pty-late switch that is just like
          --pty but sets up TTY forwarding only once the unit is fully
          activated. This is relevant for avoiding TTY ownership collisions between
          the TTY forwarding and potential password queries using the
          systemd-ask-password infrastructure. run0 now defaults to this mode for
          interactive operations.

        * The --chdir= switch now accepts the special value '~' to force
          changing into the target user's home directory.

        * run0 gained a new --via-shell switch that ensures any specified
          command is invoked via the target user's shell instead of directly.

        DDI support & systemd-dissect:

        * systemd-dissect gained a new --loop-ref-auto switch which initializes
          the --look-ref= field from a suitable string derived from the DDI
          filename.

        * systemd-dissect's --attach command now supports a new --quiet switch
          that suppressed output of the loopback device node path that is
          usually shown.

        * A generic service template systemd-loop@.service has been added that
          wraps "systemd-dissect --attach", and attaches a disk image whose
          path is encoded in the instance identifier of the unit to a new
          loopback block device. This may be used to attach arbitrary disk
          images to loopback devices at boot.

        * There's now a per-user counterpart of /var/lib/machines/ defined as
          ~/.local/state/machines/. Various tools such as systemd-nspawn +
          systemd-vmspawn now will search this directory when looking for a
          disk image, when invoked in unprivileged user context.
          systemd-dissect's --discover command may now be combined with --user
          or --system to choose in which of the directory scopes to look for
          images.

        * systemd-dissect gained a new --all switch. If specified the tool will
          not just discover DDIs (i.e. disk images) but also images stored in
          regular directories.

        * systemd-dissect gained a new "--shift" switch for recursively
          re-chown()ing a directory tree from one set of UID/GIDs to another.
          This may be used to shift a tree from the base-0-UID range to the
          foreign UID range or back.

        * systemd-dissect gained new --usr-hash= and --usr-hash-sig= options,
          that are similar to the existing --root-hash=/--root-hash-sig=
          options, but for the /usr/ partition. This allows the root hash of
          the /usr/ Verity volume and its signature to be specified.

        * When dissecting/mounting a DDI disk image, and no Verity root hash or
          signature is provided, suitable values are now automatically
          discovered from the image itself.

        * systemd-gpt-auto-generator now understands root=dissect and
          mount.usr=dissect as kernel command line options that explicitly
          request the full blown DDI dissector to be used to discover the root
          and /usr/ file system, including automatic Verity root hash and
          signature discovery, automatic handling of versioning, image policy
          enforcement and filtering and so on.

        * The DDI dissection logic now understands a concept of partition
          "filtering". A partition filter is simply a per-designator globbing
          pattern to match the partition labels against. This may be used
          support parallel installations of multiple operating systems on the
          same disk, where each OS names its partitions with a specific prefix
          or similar. systemd-dissect gained a new --image-filter= switch to
          configure this filter. The new "dissect_image" udev plugin and
          systemd-gpt-auto-generator now understand the new
          systemd.image_filter= kernel command line switch configuring this
          filter for the system.

        systemd-importd & importctl:

        * systemd-pull/importctl now supports ASCII armored (*.asc) GPG signatures.

        * The systemd.pull= and rd.systemd.pull= kernel command line switches
          (which may be used to automatically download a VM, container, confext,
          or sysext at boot) now understand a new flag "blockdev". When
          specified the downloaded image is attached to a loopback block device
          after download. This may be used to boot directly into a disk image
          downloaded via HTTP via a kernel command line like this:

          rd.systemd.pull=raw,machine,verify=no,blockdev:image:https://192.168.100.1:8081/image.raw \
              root=/dev/disk/by-loop-ref/image.raw-part2

        * systemd.pull=/rd.systemd.pull= also gained support for a new flag
          "bootorigin". If specified and if the system was network booted
          through systemd-stub (which now sets the LoaderDeviceURL EFI
          variable, see above), the URL to boot from is now automatically
          formed from the UKI network boot URL with a new suffix. Example:

          rd.systemd.pull=raw,machine,verify=no,blockdev,bootorigin:rootdisk:image.raw.xz \
              root=/dev/disk/by-loop-ref/rootdisk.raw-part2

        * The systemd.pull=/rd.systemd.pull= switches now also support a new
          flag "runtime=", taking a boolean argument. If true the downloaded
          image is placed below the /run/ hierarchy instead of /var/. It
          defaults to true for rd.systemd.pull= (i.e. for downloads made in the
          initrd), and false for systemd.pull= (i.e. for those made after the
          initrd→host transition).

        * New generic target units imports-pre.target and imports.target have
          been introduced that are ordered before and after all downloads.

        * systemd-importd gained support for downloading images compressed with
          zstd now, too. (In addition to .xz, .gz and .bz2.)

        Factory Reset:

        * A new tool systemd-factory-reset has been added that may be used to
          request or cancel a factory reset request for the next reboot. It is
          also accessible via its own Varlink API.

        * A new target unit factory-reset-now.target has been added that
          executes an immediate factory reset. (Previously factory-reset.target
          existed already that requested it for next reboot).

        * A new kernel command line option systemd.factory_reset= has been
          added for explicitly requesting a factory reset. (Implemented via a
          new systemd-factory-reset-generator)

        * A new document explaining the factory reset logic in detail has been
          added. It is available online here:

          https://systemd.io/FACTORY_RESET

        systemd-repart:

        * systemd-repart gained a new switch --join-signature= for supporting
          offline Verity signing.

        * systemd-repart gained a new switch --append-fstab= for controlling
          how to write or append automatically generated /etc/fstab entries.

        * CopyFiles= lines can now contain an "fsverity=copy" flag to preserve
          the fs-verity status of the source files when populating the
          filesystem.

        * systemd-repart has been updated to automatically generate the
          extended attributes systemd-validatefs@.service understands (see
          below), for all partitions it recognizes. Controllable via the
          AddValidateFS= partition setting (which defaults to true).

        * repart.d/ drop-ins gained a new setting FileSystemSectorSize= which
          allows configuring the sector size that file systems for newly
          formatted file systems explicitly.

        * systemd-repart will now enforce a minimum size for ESP/XBOOTLDR
          partitions of 100M (on 512b sector drives) or 260M (on 4K sector
          drives), in accordance to the requirements for these kind of
          partitions.

        * The Format= setting in repart.d/ files gained support for a special
          value "empty". This is a shortcut to set up an empty partition and
          set the partition label to "_empty", and set the "NoAuto" GPT
          flag. The former is useful as systemd-sysupdate recognizes empty
          partitions that way, the latter is useful to ensure that the
          partition is not automatically made used of as is, on any OS that
          supports GPT.

        systemd-analyze:

        * systemd-analyze gained a new "chid" verb, which shows the "Computer
          Hardware IDs" (CHIDs) of the local system. This is useful for
          preparing CHID-to-DeviceTree mappings when building UKIs.

        * systemd-analyze gained a new "transient-settings" verb, which shows
          all unit settings one can configure dynamically via the
          "--property="/"-p" switch when invoking transient units.

        * systemd-analyze gained a new "unit-shell" verb that invokes an
          interactive shell inside the namespaces of the main process
          of a specified unit. This is useful for debugging unit sandboxes, and
          getting an idea how things look like from the "inside" of a service.

        * systemd-analyze gained a new "unit-gdb" verb to attach a debugger
          to a unit.

        Other:

        * systemd-ask-password now provides a small Varlink API to
          interactively query the user for a password using the usual agent
          logic. This makes it easier for external programs (for example
          daemons) to query for boot-time passwords and similar, using
          systemd's infrastructure.

        * The logging logic in systemd's codebase now implements the
          DEBUG_INVOCATION= interface added to service management in v257. Or
          in other words: the RestartMode=debug setting may now be added for
          any of systemd's own service and has the intended effect of enabling
          debug logging if it gets automatically restarted.

        * The "package note" specification ELF binaries has been extended to
          cover PE binaries (i.e. UEFI binaries), too.

        * New kernel command line parameters systemd.break= and
          rd.systemd.break= have been introduced that insert interactive (as
          in: shell prompt) "breakpoints" into the boot process at various
          locations, in order to simplify debugging. For now four breakpoints
          are defined: "pre-udev", "pre-basic", "pre-mount",
          "pre-switch-root". Similar functionality has previously existed in
          the Dracut initrd generator, but is generalized with this new
          concept, and extended to the post-switch-root boot phases.

        * The systemd-path tool now learnt new paths for the per-system and
          per-user credential store.

        * A new tool systemd-pty-forward has been added that allocates a pseudo
          TTY ("PTY") and invokes a process on it, forwarding any output to the
          TTY it is invoked on. It can optionally apply background coloring and
          suchlike, and is mostly just a separate tool that makes the PTY
          forwarding logic used in systemd-nspawn, systemd-vmspawn, run0
          available separately.

        * systemd-oomd can now reload its configuration at runtime, following
          the usual protocols.

        * systemd-detect & ConditionVirtualization= now recognize the "Arm
          Confidential Compute Architecture" (cca) confidential virtualization.

        * systemd-detect-virt now correctly distinguishes between bare-metal
          and virtualized machines in Google Compute Engine, and will not
          report the former as virtualized.

        * systemd-sysusers now generates Linux audit records when it adds
          system users.

        * systemd-firstboot's interactive prompts for locale or keymaps now
          support tab completion.

        * systemd-mount gained support for a new --canonicalize= switch that
          may be used to turn off client-side path canonicalization before
          trying to unmount some path.

        * systemd-notify gained a new --fork switch which inverts the role that
          systemd-notify plays in the sd_notify() protocol: instead of sending
          out notification messages, it will listen for them, forking off a
          command that is expected to send them. Once READY=1 is received
          systemd-notify will exit, leaving the child running. This is useful
          for correctly forking off processes that implement the sd_notify()
          protocol from shell scripts.

        * systemd-fstab-generator now supports a root=bind:… syntax for
          creating bind mounts for the root file system. This is useful for
          booting into tarballs downloaded at boot. As an example, consider a
          kernel command line like this:

          rd.systemd.pull=tar,machine,verify=no:root:http://192.168.100.1:8081/image.tar root=bind:/run/machines/root ip=any

        * libapparmor is now loaded via dlopen() instead of using direct shared
          library linking. This allows downstream distributions to provide AA
          support as a runtime option instead of making the AA userspace a
          mandatory dependency.

        * A new generic remote-integritysetup.target unit has been added that
          matches remote-veritysetup.target and remote-cryptsetup.target's role
          for remote block devices, but for dm-integrity devices.

        * A new document about finding boot components and the root disk of the
          OS has been added. It's available online here:

          https://systemd.io/ROOTFS_DISCOVERY

        * Whenever any systemd tool begins or ends a new TTY context (i.e. takes
          over a TTY for some time) a new OSC sequence is now emitted, with
          various details about the context. This new OSC sequence can be
          interpreted by terminal emulators to visualize the context/source TTY
          output originates from or to show various kinds of metadata for
          it. The OSC sequence is specified in this document:

          https://systemd.io/OSC_CONTEXT

          Contexts are generated for systemd-nspawn/systemd-vmspawn boots, for
          run0 or systemd-run sessions, whenever PAM TTY sessions start or end,
          and when shell command executions start and end. Metadata sent along
          contains hostname, machine ID, boot ID, exit status, unit information
          and more.

        * If PID 1 makes up a suitable $TERM for a TTY it activates a service
          on (in case there are no other hints on how to choose it) it will now
          also set $COLORTERM=truecolor. Moreover, if $COLORTERM or $NO_COLOR
          are set on the kernel cmdline we'll now import them into PID1's
          environment block, just like $TERM itself. Moreover, systemd-nspawn
          and run0 will now propagate $COLORTERM and $NO_COLOR from the calling
          to the target environment, if set, just like $TERM is already
          handled. Or to say this with different words: the triplet of $TERM,
          $COLORTERM, $NO_COLOR is now processed jointly and in similar ways,
          wherever appropriate.

        * systemd-update-done gained a new --root= switch to operate in
          "offline" mode on a specific file system tree.

        * A new template service systemd-validatefs@.service has been added
          that can validate usage of file systems. Specifically, it will look
          for certain extended attributes stored on the top-level directory
          inode of the mount, which may encode various constraints on use of
          the file system. For example, it may encode a directory path the file
          system must be mounted to, a GPT type UUID that must be used for the
          partition the file system is located in and more. This provides
          protection in case GPT auto-discovery is used to discover the mounts,
          but essential metadata outside of the file system itself has been
          tampered with. This operates under the assumption that the extended
          attributes on the root inode of the file system are protected by
          dm-verity or dm-crypt/dm-integrity, even if the GPT metadata has no
          equivalent cryptographic protection. If a file system carries these
          extended attributes but they do not match the current use and
          location of the file system an immediate reboot is triggered.

        * systemd-gpt-auto-generator now understands a new mount option
          x-systemd.validatefs for /etc/fstab entries. If specified an instance
          of systemd-validatefs@.service is automatically pulled in by the
          relevant mount.

        * systemd-fstab-auto-generator and systemd-gpt-auto-generator now
          understand root=off on the kernel command line which may be used to
          turn off any automatic or non-automatic mounting of the root file
          system. This is useful in scenarios where a boot process shall never
          transition from initrd context into host context.

        * systemd-ssh-proxy now supports an alternative syntax for connecting
          to SSH-over-AF_VSOCK, in order to support scp and rsync better: "scp
          foo.txt vsock%4711:" should work now. (The pre-existing syntax used
          "/" instead of "%" as separator, which is ambiguous in scp/rsync
          context even if not for ssh itself.)

        * "systemctl start" and related verbs now support a new --verbose
          mode. If specified the live log output of the units operated on is
          shown as long as the operation lasts.

        * sd-bus: a new API call sd_bus_message_dump_json() returns a JSON
          representation of a D-Bus message.

        * sd-daemon: a new call sd_pidfd_get_inode_id() has been added
          for acquiring the unique inode ID of a pidfd, coupling the
          $MAINPIDFDID/$MANAGERPIDFDID and session/machine leader pidfd IDs
          exposed as described above.

        * systemd-coredump will now attach a new COREDUMP_DUMPABLE= journal
          field to all coredumps indicating the "dumpable" per-process flag (as
          settable via PR_SET_DUMPABLE) at the moment the coredump took
          place. It will also add a new journal field COREDUMP_BY_PIDFD= that
          indicates whether the coredump was acquired via a stable pidfd to the
          process.

        * systemd-sysext (and portable services with sysexts applied) will now
          take the os-release "ID_LIKE=" field into account when validating that
          a sysext images is compatible with the underlying image. Previously
          it would only check "ID=".

        * A new UID range has been defined for "greeters", i.e. graphical login
          prompt UIs that shall be security isolated from each other. This is
          supposed to be used by graphical display managers (specifically:
          gdm), to ensure that it is harder to exploit the UI sessions used to
          prompt the user for login credentials, in order to gain access to the
          prompts of other users.

        * systemd-socket-activate gained a new --now switch which ensures the
          specified binary is immediately invoked, and not delayed until a
          connection comes in.

        * systemd-ssh-generator will now generate the AF_VSOCK ssh listener
          .socket unit, so that a tiny new helper "systemd-ssh-issue" is
          invoked when the socket is bound, that generates a drop-in file
          /run/issue.d/50-ssh-vsock.issue that is shown by "login" and other
          subsystems at login time. The file reports the AF_VSOCK CID of the
          system, along with very brief information how to connect to the
          system via ssh-over-AF_VSOCK. Or in other words: if the system is
          booted up in an AF_VSOCK capable VM the console login screen shown
          once boot-up is complete will tell you how to connect to the system
          via SSH, if that's available.

        * systemd-fsck gained fsck.mode and fsck.repair credentials support to
          control the execution mode of fsck.

        * systemd-quotacheck gained quotacheck.mode credential support to
          control the execution mode of quotacheck.

        Contributions from: 16mc1r, A. Wilcox, Aaron Rogers,
        Abderrahim Kitouni, Adam Williamson, Adrian Vovk, Ahmad Fatoum,
        Alberto Planas, Alex, Alex Xu (Hello71), Alexander Bruy,
        Alexander Krabler, Alexander Kurtz, Alexander Shopov,
        Alexander Stepchenko, Allison Karlitskaya, Aman Verma,
        Américo Monteiro, Andika Triwidada, AndreFerreiraMsc,
        Andreas Henriksson, Andreas Schneider, Andreas Stührk, Andres Beltran,
        Andrew Sayers, Andrii Chubatiuk, André Monteiro, Andy Shevchenko,
        Ani Sinha, Anthony Avina, Anthony Messina, Anton Ryzhov, Anton Tiurin,
        Antonio Alvarez Feijoo, Arian van Putten, Arkadiusz Bokowy, Arnaudv6,
        AsciiWolf, Avram Dorfman, Bastien Nocera, Beniamino Galvani,
        Brett Holman, Busayo Dada, ButterflyOfFire, Carlo Teubner, Chris Grant,
        Chris Hofstaedtler, Chris Mayo, Christian Glombek, Christian Hesse,
        Christopher Head, Colin Foster, Cosima Neidahl, Craig McLure,
        Daan De Meyer, Dai MIKURUBE, Dan McGregor, Dan Streetman,
        Daniel Foster, Daniel Rusek, Daniil, David C. Manuelda, David Härdeman,
        David Rheinsberg, David Tardon, DeKoile, Debarshi Ray, Deli Zhang,
        Devilish Spirits, Dimitri John Ledkov, Duncan Overbruck, Dusty Mabe,
        Eaterminer, Eisuke Kawashima, Emilio Sepulveda, Emir SARI,
        Emmanuel Ferdman, Enrico Tagliavini, Erik Larsson, Erin Shepherd,
        Ettore Atalan, Fabian Möller, Fabian Vogt, Fco. Javier F. Serrador,
        Federico Giovanardi, Felix Pehla, Fleuria, Florian Schmaus, Franck Bui,
        Frantisek Sumsal, Frede Braendstrup, Gabríel Arthúr Pétursson,
        Gavin Li, George Tsiamasiotis, Graham Clinch, Grimmauld, H A, Hang Li,
        Harrison Vanderbyl, Hendrik Wolff, Henri Aunin, Igor Opaniuk, Itxaka,
        Ivan Kruglov, Ivan Trubach, Jack Wu, Jacob McNamee, James Hilliard,
        Jan Engelhardt, Jan Fooken, Jan Kalabza, Jan Macku, Jan Vaclav,
        Jan Čermák, Jared Baur, Jaroslav Škarvada, Jasmine Andrever-Wright,
        Javier Francisco, Jelle van der Waa, Jeremy Linton, Jesper Nilsson,
        Jesse Guo, Jim Spentzos, Joaquim Monteiro, Joey Holtzman,
        John Rinehart, Jonas Gorski, Jordan Petridis, Jose Ortuno,
        Josh Triplett, Jules Lamur, Justinas Kairys, Jörg Behrmann,
        Kamil Páral, Katariina Lounento, Kevin P. Fleming, Khem Raj, KidGrimes,
        Kurt Borja, Lennart Poettering, Li Tian, Lin Jian, Linus Heckemann,
        Lorenzo Arena, Louis Sautier, LuK1337, Luca Boccassi,
        Lucas Adriano Salles, Luke Yeager, Lukáš Nykrýn, Luna Jernberg,
        Léane GRASSER, Marco Trevisan (Treviño), Marcos Alano,
        Mario Limonciello, Markus Kurz, Martin Homuth-Rosemann,
        Martin Hundebøll, Martin Srebotnjak, Martin Wilck, Mate Kukri,
        Matteo Croce, Matthew Schwartz, Matthias Gerstner, Matthias Lisin,
        Matthieu Baerts (NGI0), Matthieu LAURENT, MaxHearnden,
        Michael Catanzaro, Michael Ferrari, Michael Limiero, Michael Olbrich,
        Michal Koutný, Michal Sekletár, Michał Moczulski, Mike Yuan,
        Miroslav Lichvar, Morten Hauke Solvang,
        Muhammad Nuzaihan Bin Kamal Luddin, Myrrh Periwinkle, Nathan,
        NetSysFire, Nick Labich, Nick Owens, Nick Rosbrook, Nils K,
        Noel Georgi, Nuno Sá, Oliver Schramm, Paul Fertser, Pavithra Barithaya,
        Philip Freeman, Philip Withnall, Piotr Drąg, Pontus Lundkvist, Raura,
        Ricky Tigg, RocketDev, Ronan Pigott, Rostislav Lastochkin,
        Rudi Heitbaum, Ryan Blue, Ryan Thompson, Ryan Wilson, Salim B,
        Salvatore Cocuzza, Sam James, Sam Leonard, Samuel Dionne-Riel,
        Sea-Eun Lee, Septatrix, Sergey A, Shubhendra Kushwaha, Silvio Knizek,
        Solar Designer, SoloSaravanan, Sonia Zorba, Soumyadeep Ghosh,
        Stefan Hansson, Stefan Herbrechtsmeier, Steve Ramage,
        Temuri Doghonadze, TheHillBright, Thomas Hebb, Thorsten Kukuk,
        Tim Crawford, Tim Small, Tim Vangehugten, Tobias Heider,
        Tobias Klauser, Todd C. Miller, Tommi Rantala, Tommy Unger, Trollimpo,
        Ubuntu, Valentin David, Valentin Hăloiu, Vasiliy Kovalev,
        Vishal Chillara Srinivas, Vishwanath Chandapur, Vitaly Kuznetsov,
        Volodymyr Shkriabets, Vyacheslav Yurkov, Werner Sembach, Y T,
        Yaping Li, Yu Watanabe, ZIHCO, Zbigniew Jędrzejewski-Szmek,
        andrejpodzimek, anonymix007, anthisfan, cvlc12, damnkiwi6120, davjav,
        fishears, hanjinpeng, haxibami, herbrechtsmeier, honjow, hsu zangmen,
        igo95862, jane400, jinyaoguo, joo es, kanitha chim, keentux, kmeaw,
        luc-salles, madroach, maia x., msizanoen, naly zzwd, nkraetzschmar,
        nl6720, novenary, peelz, persmule, richfifeg, ssoss, tim tom, tuxmainy,
        tytan652, val4oss, ver4a, victor-ok, vlefebvre, wrvsrx, wtmpx,
        xinpeng wang, z z, Дамјан Георгиевски, наб, 铝箔, 김인수

        — Edinburgh, 2025/09/17

CHANGES WITH 257:

        Incompatible changes:

        * The --purge switch of systemd-tmpfiles (which was added in v256) has
          been reworked: it will now only apply to tmpfiles.d/ lines marked
          with the new "$" flag. This is an incompatible change, and means any
          tmpfiles.d/ files which shall be used together with --purge need to
          be updated accordingly. This change has been made to make it harder
          to accidentally delete too many files when using --purge incorrectly.

        * The systemd-creds 'cat' verb now expects base64-encoded encrypted
          credentials as input, for consistency with the 'decrypt' verb and the
          LoadCredentialEncrypted= service setting. Previously it could only
          read raw, unencoded binary data.

        * Support for automatic flushing of the nscd user/group database caches
          has been dropped.

        * The FileDescriptorName= setting for socket units is now honored by
          Accept=yes sockets too, where it was previously silently ignored and
          "connection" was used unconditionally.

        * systemd-logind now always obeys block inhibitor locks, where previously
          it ignored locks taken by the caller or when the caller was root. A
          privileged caller can always close the other sessions, remove the
          inhibitor locks, or use --force or --check-inhibitors=no to ignore the
          inhibitors. This change thus doesn't affect security, since everything
          that was possible before at a given privilege level is still possible,
          but it should make the inhibitor logic easier to use and understand,
          and also help avoiding accidental reboots and shutdowns. New 'block-weak'
          inhibitor modes were added, if taken they will make the inhibitor lock
          work as in the previous versions. Inhibitor locks can also be taken by
          remote users (subject to polkit policy).

        * systemd-nspawn will now mount the unified cgroup hierarchy into a
          container if no systemd installation is found in a container's root
          filesystem. $SYSTEMD_NSPAWN_UNIFIED_HIERARCHY=0 can be used to override
          this behavior.

        * /dev/disk/by-id/nvme-* block device symlinks without an NVMe
          namespace identifier are now fixed to namespace 1 of the device. If
          no namespace 1 exists for a device no such symlink is
          created. Previously, these symlinks would point to an unspecified
          namespace, and thus not be strictly stable references to
          multi-namespace NVMe devices. These un-namespaced symlinks are mostly
          obsolete, users and applications should always use the ones with
          encoded namespace information instead. This change should not affect
          too many systems, because most NVMe devices only know a namespace 1
          by default.

        * Support for cgroup v1 ('legacy' and 'hybrid' hierarchies) is now
          considered obsolete and systemd by default will ignore configuration
          that enables them. To forcibly reenable cgroup v1 support,
          SYSTEMD_CGROUP_ENABLE_LEGACY_FORCE=1 must additionally be set on the
          kernel command line.

       Announcements of Future Feature Removals:

        * The D-Bus method org.freedesktop.systemd1.StartAuxiliaryScope() is
          deprecated because accounting data and such cannot be reasonably
          migrated between cgroups. It is likely to be fully removed in a
          future release (reach out if you have use cases).

        * The recommended kernel baseline version has been bumped to v5.4
          (released in 2019). Expect limited testing on older kernel versions,
          where "old-kernel" taint flag would also be set. Support for them
          will be phased out in a future release in 2025, i.e. we expect to bump
          the minimum baseline to v5.4 then too.

        * The complete removal of support for cgroup v1 ('legacy' and 'hybrid'
          hierarchies) is scheduled for v258.

        * Support for System V service scripts is deprecated and will be
          removed in v258. Please make sure to update your software
          *now* to include a native systemd unit file instead of a legacy
          System V script to retain compatibility with future systemd releases.

        * To work around limitations of X11's keyboard handling systemd's
          keyboard mapping hardware database (hwdb.d/60-keyboard.hwdb) so far
          mapped the microphone mute and touchpad on/off/toggle keys to the
          function keys F20, F21, F22, F23 instead of their correct key codes.
          This key code mangling will be removed in the next systemd release.
          To maintain compatibility with X11 applications that rely on the old
          function key code mappings, this mangling has now been moved to the
          relevant X11 keyboard driver modules. In order to ensure these keys
          continue to work, update to xf86-input-evdev >= 2.11.0 and
          xf86-input-libinput >= 1.5.0 before updating to systemd >= 258.

        * Support for the SystemdOptions EFI variable is deprecated.
          'bootctl systemd-efi-options' will emit a warning when used. It seems
          that this feature is little-used and it is better to use alternative
          approaches like credentials and confexts. The plan is to drop support
          altogether at a later point, but this might be revisited based on
          user feedback.

        * systemd-run's switch --expand-environment= which currently is disabled
          by default when combined with --scope, will be changed in a future
          release to be enabled by default.

        libsystemd:

        * systemd's JSON API is now available as public interface of
          libsystemd, under the name "sd-json". The purpose of the library is
          to allow structures to be conveniently created in C code and
          serialized to JSON, and for JSON to be conveniently deserialized into
          in-memory structures, using callbacks to handle specific
          keys. Various data types like integers, floats, booleans, strings,
          UUIDs, base64-encoded and hex-encoded binary data, and arrays are
          supported natively. The library has been part of systemd for a while
          as internal component, and is now made publicly available. One major
          user of sd-json is sd-varlink (see below). Note that the
          documentation of sd-json is very much incomplete for now, but the
          systemd codebase provides plenty real-life code examples.

        * systemd's Varlink IPC API is now available as part of libsystemd,
          under the name "sd-varlink". This library is a C implementation of
          the Varlink IPC system (https://varlink.org/) that has been adopted
          by systemd for various interfaces. It relies on the sd-json JSON
          component, see above. Note that the documentation of sd-varlink is
          very much incomplete for now, but the systemd codebase provides
          plenty real-life code examples.

        * sd-bus gained a new call sd_bus_pending_method_calls() which returns
          the number of currently open asynchronous method calls initiated on
          this connection towards peers.

        * sd-device gained a new call sd_device_monitor_is_running() that
          returns whether the specified monitor object is already running. It
          also gained sd_device_monitor_get_fd(),
          sd_device_monitor_get_events(), sd_device_monitor_get_timeout() and
          sd_device_monitor_receive() to permit sd-device to run on top of a
          foreign event loop implementation. It also gained
          sd_device_get_driver_subsystem() which returns the subsystem of
          driver objects. The new sd_device_get_device_id() call returns a
          short string identifying the device record.

        System and Service Management:

        * The environment variable $REMOTE_ADDR is now set when using
          per-connection socket activation for AF_UNIX stream sockets. It
          contains the AF_UNIX peer address of the connection. (Previously the
          environment variable was only set for IP sockets.)

        * Multipath TCP (MPTCP) is now supported as a socket protocol for
          .socket units.

        * A new /etc/fstab option x-systemd.wants= creates "Wants="
          dependencies.  (This is similar to the previously available
          x-systemd.requires=.)

        * The initialization of the system clock during boot and updates has
          been simplified: both PID 1 or systemd-timesyncd will pick the latest
          minimum time as indicated by the compiled-in epoch,
          /usr/lib/clock-epoch, and /var/lib/systemd/timesync/clock. See
          systemd(1) for an detailed updated description.

        * The kernel's Ctrl-Alt-Delete handling is re-enabled during late
          shutdown, so that the user may use it to initiate a reboot if the
          system freezes otherwise.

        * The new value "identity" for the unit setting PrivateUsers= may be
          used to request a user namespace with an identity mapping for the
          first 65536 UIDs/GIDs.  This is analogous to the systemd-nspawn's
          --private-users=identity.

        * The new value "disconnected" for the unit setting PrivateTmp= may be
          used to specify that a separate tmpfs instance should be used for
          /tmp/ and /var/tmp/ for the unit.

        * The server manager (and various other tools too) use pidfds in more
          places to refer to processes.

        * A build option -D link-executor-shared=false can be used to build
          the systemd-executor binary (added in a previous release) in a way
          where it does not link to shared libsystemd-shared-….so library.
          PID1 holds a reference to the executor binary that was on disk when
          the manager was started or restarted, but the shared libraries it is
          linked to are not loaded until the executor binary needs to be used.
          This partial static linking is a workaround for the issue where,
          during upgrades, the old libsystemd-shared-….so may have already
          been removed and the pinned executor binary will just fail to
          execute.

        * The systemd.machine_id= kernel command line parameter interpreted by
          PID 1 now supports an additional special value: if set to "firmware"
          the machine ID is initialized from the SMBIOS/DeviceTree system
          UUID. (Previously this was already done automatically in VM
          environments, this extends the concept to any system, but only on
          explicit request via this option.)

        * The ImportCredential= setting in service unit files now permits
          renaming of credentials as they are imported.

        * The RestartMode= setting gained a new "debug" value. If specified and
          the service fails so that it shall be restarted it is invoked in
          "debugging mode". Debugging mode means that the $DEBUG_INVOCATION
          environment variable will be set to "1" for the new
          invocation. Moreover, any setting LogLevelMax= will be temporarily
          changed to "debug" for the next invocation. This mode is useful to
          automatically repeat invocation of tools in case they fail – but with
          additional logging or testing routines enabled.

        * A new service setting BindLogSockets= has been added that
          controls whether the AF_UNIX sockets required for logging shall be
          bind mounted to the mount sandbox allocated for the service.

        * At early boot, PID 1 will now optionally load a policy for the new
          Linux IPE LSM.

        * Transient services (as invoked by the StartTransientUnit() D-Bus
          method) may now receive additional, arbitrary file descriptors to
          pass to executed service processes during activation using the new
          ExtraFileDescriptor= unit property.

        * Calendar .timer units gained a new boolean DeferReactivation=
          option. If enabled and the repetitive calendar timer elapses again
          while the service the timer activates is still running, immediate
          reactivation of the service once it finishes is skipped, and the
          timer has to elapse again before the service is reactivated.

        * Generator processes invoked by the service manager will now receive a
          new environment variable $SYSTEMD_SOFT_REBOOTS_COUNT that indicates
          how many times the system has been soft-rebooted since the kernel
          initialized.

        * A new service property ManagedOOMMemoryPressureDurationSec= has been
          added that complements the existing
          ManagedOOMMemoryPressureDurationLimit= and specifies the PSI
          measurement interval for the specific unit.

        * The sd_notify() protocol has been extended to allow changing the main
          PID of a process by providing a pidfd of the new main process, or by
          specifying the pidfd inode number. Previously this was only supported
          by specifying the classic UNIX PID, which of course is racy.

        * The SocketUser=/SocketGroup= settings of .socket units are now also
          applied to POSIX message queues.

        * The ProtectControlGroups= unit file setting now supports two
          additional values: if set to "private" a new cgroup namespace is
          allocated for the service and cgroupfs mounted accordingly; if set to
          "strict" a new cgroup namespace is allocated for the service, and
          cgroupfs is mounted read-only for the service.

        * The StateDirectory=, RuntimeDirectory=, CacheDirectory=,
          LogsDirectory=, and ConfigurationDirectory= settings gained support
          for configuring the respective directories as read-only, via a ':ro'
          flag that can be appended to each setting's value.

        * When DynamicUser= is combined with
          StateDirectory=/RuntimeDirectory=/CacheDirectory=/LogsDirectory= and
          ID mapped mounts are available on the referenced path, the data in
          there is now preferably made available by establishing ID mapped from
          the "nobody" user to the dynamic user, rather than via recursive
          chown()ing.

        * A new service property PrivatePIDs= has been added that runs executed
          processes as PID 1 - the init process - within their own PID
          namespace.  PrivatePIDs= also mounts /proc/ so only processes within
          the new PID namespace are visible.

        systemd-udevd:

        * udev rules now set 'uaccess' for /dev/udmabuf, giving locally
          logged-in users access to the hardware. This is useful in order to
          support IPMI cameras with libcamera.

        * Serial port devices will no longer show up as systemd units, unless
          they have an IO port or memory assigned to them. This means that only
          serial ports that actually exist should show up as .device units now.

        * mtd devices (i.e. certain kinds of flash memory devices) will now
          show up as .device units in systemd.

        * The firmware_node/sun sysfs attribute will now be used (if available)
          for naming slot-based network interfaces, i.e. ID_NET_NAME_SLOT.
          Moreover the interface aliases specified in DeviceTree are now
          searched for both on the interface's parent device (as before) and
          the device itself (new).

        * Various USB hardware wallets are now recognized by udev via a .hwdb
          file, and get the ID_HARDWARE_WALLET= property set, which enables
          "uaccess" for them, i.e. direct unprivileged access.

        * udevadm info will now output the device ID string in lines prefixed
          with "J:", and the driver subsystem in lines prefixed with "B:".

        * udev rules files now support case-insensitive attribute matching
          (e.g. ATTR{foo}==i"abcd")

        systemd-logind:

        * New DesignatedMaintenanceTime= configuration option allows shutdowns
          to be automatically scheduled at the specified time.

        * logind now reacts to Ctrl-Alt-Shift-Esc being pressed. It will send
          out a org.freedesktop.login1.SecureAttentionKey signal, indicating a
          request by the user for the system to display a secure login dialog.
          The handling of SAK can be suppressed in logind configuration.

        * logind now supports handing off session-managed access to hidraw
          devices via its D-Bus APIs, the same way it already supports that for
          DRM and evdev input devices. This permits unprivileged clients to get
          hidraw fds for a device, that are automatically suspended when the
          session switches away.

        * systemd-logind now exposes two D-Bus properties CanLock and CanIdle
          for all sessions. These properties indicate whether the session's
          class supports screen locking and idleness detection.

        * systemd-inhibit now allows interactive polkit authorization. It
          gained a --no-ask-password option to suppress it.

        systemd-machined:

        * Unprivileged clients are now allowed to register VMs and containers.
          Machines started via the systemd-vmspawn@.service unit will now be
          registered with systemd-machined.

        * systemd-machined gained a pretty complete set of Varlink APIs
          exposing its functionality. This is an alternative to the
          pre-existing D-Bus interface.

        systemd-resolved and resolvectl:

        * The resolvconf command now supports '-p' switch. If specified, the
          interface will not be used as the default route for domain name
          lookups.

        * resolvectl now enables interactive polkit authorization. It gained a
          --no-ask-password option to suppress it.

        * systemd-resolved now implements continuous mDNS querying as per
          RFC6762 §5.2. Clients can subscribe to the notification stream using
          varlink.

        systemd-networkd and networkctl:

        * IPv6 address labels can be also configured in a new [IPv6AddressLabel]
          section with Prefix= and Label= settings in networkd.conf. Please see
          networkd.conf(5) for more details.

        * 'networkctl edit' can now read the new file contents from standard
          input with the new --stdin option.

        * 'networkctl edit' and 'cat' now support editing/showing .netdev files
          by link. 'networkctl cat' can also list all configuration files
          associated with an interface at once with ':all'.

        * networkctl gained a --no-ask-password option to suppress interactive
          polkit authorization.

        * "mac" has been added to the default AlternativeNamesPolicy= setting
          for network links (via 99-default.link). This means "enx*" interface
          names will now be added to the list of alternative interface names by
          default, for all interfaces that have a MAC address assigned
          by hardware.

        * networkd .netdev bridge devices gained a new setting FDBMaxLearned=
          for setting a limit on the number of dynamically learned FDB entries.

        * networkd .network files for bridge devices now support Layer 2 (in
          addition to the pre-existing Layer 3) MDB entries, via
          MulticastGroupAddress=.

        * systemd-networkd will now log when per-network sysctls belonging to
          network interfaces managed by it are changed outside of networkd,
          thus highlighting conflict of ownership/management of these knobs.

        * systemd-networkd will now make RFC9463 DNR fields available to
          systemd-resolved, for automatic DNS DoT configuration, and similar.

        * The "dhcp" and "dhcp-on-stop" values for KeepConfiguration= setting in
          .network file are replaced with "dynamic" and "dynamic-on-stop",
          respectively. When specified, systemd-networkd will preserve all
          dynamic configurations via DHCPv4, DHCPv6, NDISC, and IPv4LL with
          ACD, while previously only DHCPv4 configurations were kept. Also,
          when systemd-networkd is restarted, regardless of the setting, these
          dynamic configurations are unconditionally kept. So, systemd-networkd
          can be restarted without disturbing ongoing connections.

        * systemd-networkd now updates traffic control configuration without
          clearing existing settings. Thus, those settings can be updated by
          editing relevant .network files and triggering 'networkctl reload'.

        * systemd-networkd now gracefully updates netdev settings specified in
          .netdev files when 'networkctl reload' is called. Previously, if the
          relevant interfaces existed, new settings would not be applied. Now,
          new settings will be applied if possible. Some settings cannot be
          updated after a netdev is configured, e.g. VLAN ID can be only
          specified on creation. To change such settings, user needs to remove
          existing interfaces, and invoke 'networkctl reload' or restart
          systemd-networkd.

        systemd-boot, systemd-stub, and related tools:

        * The EFI stub now supports loading of .ucode sections with microcode
          from PE add-on files. It also now supports loading .initrd sections
          from PE add-on files.

        * A new .profile PE section type is now documented and supported in
          systemd-measure, ukify, systemd-stub and systemd-boot. These new
          sections allow multiple "profiles" to be stored together in the UKI,
          where each .profile section creates groupings of sections in the UKI,
          allowing some sections to be shared and other sections like .cmdline
          or .initrd unique to the profile. This may be used to provide a
          single UKI that synthesizes multiple menu items in the boot menu (for
          example, a regular one to boot, plus a debugging one, or a factory
          reset one, and so on – which only differ in kernel command line, but
          nothing else).

        * New .dtbauto and .hwids sections are now documented and supported in
          systemd-measure, ukify, systemd-stub, and systemd-boot. A single UKI
          can contain multiple .dtbauto sections, and the 'compatible' string
          therein will be compared with the equivalent field in the DTB
          provided by the firmware, if present. If absent, SMBIOS will be used
          to calculate hardware IDs (CHIDs) and look them up in the content of
          .hwids, hopefully revealing an fallback 'compatible' string. This
          allows including multiple DTBs in a single UKI, with systemd-stub
          automatically loading the correct one for the current hardware.

        * ukify gained an --extend switch to import an existing UKI to
          be extended, and a --measure-base= switch to support measurement
          of multi-profile UKIs.

        * ukify gained a --certificate-provider switch to use an OpenSSL
          provider to load the certificate used to sign artifacts, instead of
          having to provide the path to a file on disk.

        * bootctl, systemd-keyutil, systemd-measure, systemd-repart, and
          systemd-sbsign gained a new --certificate-source switch that allows
          loading the X.509 certificate from an OpenSSL provider instead of a
          file system path.

        * systemd-boot's menu will now react to volume up/down rocker presses
          the same way as to arrow up/down presses: they move the menu item up
          or down. This is useful on device form factors that have only a
          volume rocker but no arrow keys (e.g. phones).

        * systemd-stub will report the partition UUID and image identifier its
          UKI executable is placed on separately from the data systemd-boot
          provides about where to find its own executable, via EFI
          variables. This is useful when systemd-boot and UKIs are placed on
          distinct partitions (i.e. ESP and XBOOTLDR).

        * bootctl gained new switches --print-loader-path and --print-stub-path
          that output the path to the boot loader or UKI used for the current
          boot.

        * bootctl kernel-identify now recognizes EFI add-ons.

        * bootctl gained a --random-seed=yes|no option to control provisioning
          of the random seed file in the ESP. (This is useful when producing an
          image that will be used in multiple instances.)

        * bootctl now optionally supports installing UEFI Secure Boot databases
          (i.e. db/dbx/…  databases in ESL format) for systemd-boot to pick up
          and automatically enroll if the system is booted in Setup Mode. This
          is controlled via bootctl's new --secure-boot-auto-enroll=yes switch
          (and some auxiliary ones). A certificate can be provided in DER
          format, and is automatically converted into an ESL, as needed.

        * bootctl, systemd-measure, systemd-repart when referencing signing
          keys on OpenSSL engines may now query for PINs and similar via
          systemd's native systemd-ask-password logic (and take benefit of its
          caching and UI).

        * A new systemd-sbsign tool has been added, that can be used to sign
          EFI binaries (PE) for Secure Boot. This tool supports OpenSSL engines
          and providers, with pin caching support for PKCS11. ukify supports it
          as an alternative to sbsigntool and pesign.

        * A new systemd-keyutil tool has been added, that can be used to perform
          various operations on private keys and X.509 certificates.

        The journal:

        * journalctl can now list invocations of a unit with the
          --list-invocation options and show logs for a specific invocation
          with the new --invocation/-I option. (This is analogous to the
          --list-boots/--boot/-b options.)

        systemd-sysupdate and related tools:

        * systemd-sysupdated has been added as system service, allowing
          unprivileged clients to update the system via D-Bus calls. Note that
          for now the systemd-sysupdated API is considered experimental, and is
          not considered stable yet.

          A new updatectl command-line tool can be used to control the
          service.

        * systemd-sysupdate gained a new --offline option to force it to
          operate locally. This is useful when listing locally installed
          versions.

        * systemd-sysupdate gained a new --transfer-source= option to set the
          directory to which transfer sources configured with
          PathRelativeTo=explicit will be interpreted.

        * systemd-sysupdate now reports download progress via sd_notify().

        * systemd-sysupdate now supports output in JSON mode for all commands.

        * systemd-sysupdate definitions may now carry references to ChangeLog
          and AppStream metadata.

        * Transfer definitions for systemd-sysupdate are supposed to carry the
          ".transfer" suffix now, changing from ".conf". The latter remains
          supported for compatibility, but it's recommended to rename all files
          reflecting this suffix change.

        * systemd-sysupdate now supports new ".feature" files that may be
          used in conjunction with ".transfer" files to group them together, and
          allow them to be turned off or on, individually per group.

        TPM & systemd-cryptsetup:

        * The 'has-tpm2' verb which reports whether TPM2 functionality is
          available has been moved from systemd-creds to systemd-analyze.

        * systemd-tpm2-setup will gracefully handle TPMs that have a PIN set on
          the TPM, and not attempt to automatically set up a Storage Root Key
          (SRK) in that case.

        * New crypttab option password-cache=yes|no|read-only can be used to
          customize password caching.

        * New crypttab options fido2-pin=, fido2-up=, fido2-uv= can be used to
          enable/disable the PIN query, User Presence check, and User
          Verification.

        * systemd-cryptenroll gained new options --fido2-salt-file= and
          --fido2-parameters-in-header= to simplify manual enrollment of FIDO2
          tokens.

        * systemd-cryptenroll, systemd-repart, and systemd-storagetm gained a
          new --list-devices option to list appropriate candidate block
          devices.

        * systemd-cryptenroll/systemd-cryptsetup now support combined signed
          PCR policies and local systemd-pcrlock policies for unlocking a
          disk. Or in other words, it's now possible to bind unlocking of a
          local disk to a specific OS vendor *and* a locally managed set of
          measurements describing the local system.

        varlinkctl:

        * varlinkctl gained a new verb 'list-methods' to show a list of
          methods implemented by a service.

        * varlinkctl gained a --quiet/-q option to suppress method call
          replies.

        * varlinkctl gained a --graceful= option to suppress specific Varlink
          errors, and treat them as success.

        * varlinkctl gained a --timeout= option to limit how long the
          invocation can take.

        * varlinkctl allows remote invocations over ssh, via the new
          "ssh-exec:" address specification. It'll make an ssh connection,
          start the specified executable on the remote side, and communicate
          with the remote process using the Varlink protocol.

          The "ssh:" address specification has been renamed to "ssh-unix:"
          (reflecting the fact it is used to connect to a remote AF_UNIX socket
          via SSH). The old syntax is still supported for backwards
          compatibility.

        * varlinkctl's 'introspect' verb no longer requires specification of an
          interface name. If none is specified all interfaces exposed by the
          service are shown. Moreover, more than one interface name may be
          specified now, in which case all specified ones are displayed.

        systemd-repart:

        * systemd-repart's CopyBlocks= directive can now use a character device
          as source (in addition to previously supported regular files and
          block devices). This is useful for initializing a partition from
          /dev/urandom or similar.

        * systemd-repart gained new Compression= and CompressionLevel= settings
          to enable internal compression in filesystems created offline.

        * systemd-repart understands a new MakeSymlinks= option to create one
          or more symlinks (each specified as a symlink name and target) within
          a newly formatted file system.

        * systemd-repart gained a new SupplementFor= setting that allows
          allocating a partition only if some other existing partition cannot
          be adjusted to match the constraints defined for it. This is useful
          to generate an XBOOTLDR partition if and only if an ESP already
          exists that is too small for the required constraints.

        * The default size of verity hash partitions is now automatically
          derived from SizeMaxBytes= of the data partition it is protecting.

        systemd-ssh-proxy:

        * systemd-ssh-proxy now also supports the AF_UNIX-based "VSOCK MUX"
          protocol used by CloudHypervisor/Firecracker to expose AF_VSOCK
          sockets of the VM on the host. Or in other words: it's now possible
          to directly connect to ssh via AF_VSOCK from hosts to VMs of these
          two hypervisors (previously this was only supported for hypervisors
          which expose AF_VSOCK on the host as AF_VSOCK, such as qemu).

        * systemd-ssh-proxy can now reference local VMs by their name: connect
          to any local VM "foobar" registered with systemd-machined via "ssh
          machine/foobar" using the AF_VSOCK protocol.

        systemd-analyze:

        * systemd-analyze will now show the SMBIOS #11 vendor strings set for
          the machine with a new 'smbios11' verb.

        * systemd-analyze gained a new --instance= option that can be used to
          provide an instance name to analyze multiple templates instantiated
          with the same instance name.

        * systemd-analyze's "capability" verb now gained a new --mask
          parameter. If specified a numeric capbality mask can be specified
          which is decoded for its contained capabilities.

        * systemd-analyze's "plot" verb gained two new settings: --scale-svg=
          allows the X axis of the split to be stritched by a factor. If
          --detailed is specified activation timestamps are shown in the plot.

        busctl:

        * 'busctl monitor' gained new options --limit-messages= and --timeout=
          to set the number of matches or limit the runtime of the command.

        * busctl now supports doing method calls with embedded unix file
          descriptors.

        * busctl acquired a new "wait" command to wait for a specific signal to
          arrive.

        systemd-nspawn:

        * systemd-nspawn --bind-user= will now propagate the bound user's SSH
          public key (if included in the user record) into the container,
          ensuring that any such bound user is directly accessible via ssh.

        * systemd-nspawn now supports unprivileged FUSE inside containers.

        systemd-importd:

        * A new generator sytemd-import-generator has been added to synthesize
          image download jobs. This provides functionality similar to
          importctl, but is configured via the kernel command line and system
          credentials. It may be used to automatically download sysext,
          confext, portable service, nspawn container or vmspawn VM images at
          boot.

        * systemd-importd now provides a Varlink IPC interface, in addition to
          its existing D-Bus IPC interface.

        * The individual import/export tools will now display a nice progress
          bar when downloading files.

        systemd-userdb & systemd-homed:

        * userdbctl gained a pair of switches --uid-min= and --uid-max= to
          filter the UID/GID range of the listed users or groups. It also
          gained a new switch --disposition= to filter them by disposition
          (i.e. show only system users or only regular users, and so on). It
          also gained a new switch --fuzzy that permits a "fuzzy" search for a
          user, i.e. doing a substring and string distance search, and looking
          into the real name field of the user and other similar fields. It
          gained a new switch --boundaries=no for disabling display of the
          UID/GID range boundaries in its output.

        * User records learnt a new set of fields that may list field names
          that may be changed by the user themselves without requiring
          administrator authentication. This new field is honoured by
          systemd-homed to allow users to change selected properties of their
          own user records.

        systemd-run & run0:

        * run0 gained a new pair of settings --pty and --pipe that control
          whether to invoke the specified binary on a freshly allocated pseudo
          TTY, or whether to pass the client's STDIN/STDOUT/STDERR through
          directly.

        * run0 gained a new switch --shell-prompt-prefix= that permits passing
          in a string to display on each shell prompt as prefix. If not
          specified otherwise this will show a superhero emoji (🦸), in order
          to visually communicate the temporarily elevated privileges a run0
          session provides. This makes use of the $SHELL_PROMPT_PREFIX
          environment variables mentioned below.

        * systemd-run can output some of its runtime data in JSON format via
          the new --json= option.

        systemd-tmpfiles:

        * systemd-tmpfiles --purge switch now requires specification of at
          least one tmpfiles.d/ drop-in file.

        * tmpfiles.d/ files gained a new '?' specifier for the 'L' line type to
          create a symlink only if the source exists, and gracefully skip the
          line otherwise.

        Miscellaneous:

        * systemctl now supports the --now option with the 'reenable' verb.

        * systemd-mount can now output JSON with a new --json= switch, for use
          with --list-devices. It also shows the "diskseq" property in the
          block device list.

        * systemd-id128 gained a new 'var-partition-uuid' verb to calculate
          the DPS UUID for /var/ keyed by the local machine-id.

        * localectl gained a -l/--full option to show output without
          ellipsization.

        * timedatectl now supports interactive polkit authorization.

        * The new Linux mseal(), listmount(), statmount() syscalls have been
          added to relevant system call groups.

        * The systemd-ask-password logic has been extended with a per-user
          scope, i.e. user programs may now ask for passwords via the same
          mechanism and the previously system-wide only mechanism.

        * A new set of system/service credentials are added:
          shell.prompt.prefix, shell.prompt.suffix and shell.welcome. At login
          time these are propagated into the $SHELL_PROMPT_PREFIX,
          $SHELL_PROMPT_SUFFIX, $SHELL_PROMPT_WELCOME environment
          variables. These in turn are included in the shell prompt of
          interactive shells and shown at login time, via
          /etc/profile.d/70-systemd-shell-extra.sh. This functionality is
          useful to visually highlight the fact a specific shell prompt
          originates from a specific system, execution context or tool. These
          credentials and environment variables are supposed to be generically
          useful within and outside of the immediate systemd context. It is
          also used by 'run0', see above.

        * New RELEASE_TYPE=, EXPERIMENT=, EXPERIMENT_URL= fields have been
          defined for the /etc/os-release file. For example,
          "RELEASE_TYPE=development|stable|lts" can be used to indicate various
          stages of the release life cycle, and "RELEASE_TYPE=experimental" can
          indicate experimental builds, with the EXPERIMENT= field providing a
          human-readable description of the nature of the experiment.

        * A new sleep.conf HibernateOnACPower= option has been added, which
          when disabled will suppress hibernation in suspend-then-hibernate
          mode until the system is disconnected from a power source.

        * A bunch of patches to ease building against musl have been merged.

        * The various components that display progress bars
          (i.e. systemd-repart, systemd-sysupdate/updatectl, importctl), will
          now also issue the ANSI sequences for progress reports that Windows
          Terminal understands. Most Linux terminals currently do not support
          this sequence (and ignore it), but hopefully this will change one
          day. The progress information is used to display a nice progress
          animation in the terminal tab and icon. For details about the ANSI
          sequence and its effects, see:

          https://github.com/microsoft/terminal/pull/8055
          https://conemu.github.io/en/AnsiEscapeCodes.html#ConEmu_specific_OSC

        * systemd-sysusers is now able to create fully locked user
          accounts. For compatibility it so far created accounts with a locked
          (i.e. invalid) password, but not marked locked as a whole. With the
          new "!" modifier for "u" lines, it is now possible to create fully
          locked accounts. The distinction between accounts with a locked
          password and fully locked accounts is relevant when considering
          non-password forms of authentication, i.e. SSH and such. It is
          strongly recommended to make use of this new feature for almost all
          system accounts, since they usually do not require (and should not
          permit) interactive logins. All of systemd's own system users have
          been changed to be marked as fully locked.

        * systemd-coredump now supports a new EnterNamespace= option, which
          defaults to off. If enabled systemd-coredump will access the mount
          namespace of any crashed process to acquire debug symbol information,
          in order to be able to symbolize backtraces. This option is useful to
          improve backtraces of processes of containerized applications. (Note
          that the host systemd-coredump preferably dispatches coredump
          processing to the container itself, if it supports that. Only full-OS
          containers which run systemd inside will support this however, in
          other cases EnterNamespace= might be an suitable approach to acquire
          symbolized backtraces.)

        Special thanks to Nick Owens for bringing attention to and testing
        fixes for issue #34516.

        Contributions from: 12paper, A. Wilcox, Abderrahim Kitouni,
        Adrian Vovk, Alain Greppin, Allison Karlitskaya, Alyssa Ross,
        Anders Jonsson, Andika Triwidada, Andreas Schwab, Andres Beltran,
        Ani Sinha, Anouk Ceyssens, Anselm Schueler, Anton Golubev,
        Antonio Alvarez Feijoo, Arian van Putten, Arnaud Patard,
        Arthur Shau, Bastien Nocera, Benjamin ROBIN, Brenton Simpson,
        Bryan Gurney, ButterflyOfFire, Carlo Teubner, Celeste Liu,
        Chen Guanqiao, Chen Qi, Chengen Du, Christian Hesse,
        Christoph Anton Mitterer, Colin Foster, Collin L,
        Cristian Rodríguez, Daan De Meyer, Dan Nicholson, Daniel Dawson,
        Daniel Martinez, Daniel P. Berrangé, Daniel Rusek,
        Darsey Litzenberger, David Joaquín Shourabi Porcel,
        David Michael, David Rheinsberg, David Tardon, Davide Cavalca,
        Derek J. Clark, Diego Viola, Dimitrys Meliates, Diogo Ivo,
        Dmytro Markevych, DocNITE, Dominique Martinet,
        Dr. David Alan Gilbert, Edson Juliano Drosdeck, Erik Sjölund,
        Etienne Champetier, Etienne Cordonnier, Ettore Atalan,
        Eugeny Shcheglov, Excited-bore, Fabian Vogt, Federico Giovanardi,
        Filip Lewiński, Florian Schmaus, Franck Bui, Frantisek Sumsal,
        Fábio Rodrigues Ribeiro, Gabriel Elyas, Gaël PORTAY,
        Geraldo S. Simião Kutz, Giovanni Baratta, Greg Heartsfield,
        Gregor Herburger, Gregory Arenius, GwynBleidD, Göran Uddeborg,
        Hans de Goede, Helmut Grohne, Henry Chen, Ian Abbott, Integral,
        Ivan Kruglov, Ivan Shapovalov, James Coglan, James Hilliard,
        James Muir, Jason Yundt, Jeffrey Bosboom, Jian Zhang,
        Jiri Grönroos, Johannes Schneider, John A. Leuenhagen,
        Jose Ignacio Tornos Martinez, JoseskVolpe, Joshua Grisham,
        Jörg Behrmann, Kai-Chuan Hsieh, Kamil Szczęk, Karel Zak,
        Kornilios Kourtis, Kuntal Majumder, Lennart Poettering,
        Lidong Zhong, Luca Boccassi, Lucas Adriano Salles,
        Lucas Werkmeister, Ludwig Nussel, Luke T. Shumaker,
        Lukáš Nykrýn, Luna Jernberg, Léane GRASSER, Maanya Goenka,
        Mantas Mikulėnas, Marc Reisner, Marcel Hellwig, Marco Tomaschett,
        Marin Kresic, Marius Hoch, Martin Srebotnjak, Martin Wilck,
        Mary Strodl, Matteo Croce, Matthias Lisin, Matthias Schiffer,
        Matthieu Baerts (NGI0), Matthieu CHARETTE,
        Mauri de Souza Meneguzzo, Maximilian Wilhelm, Merlin Jehli,
        Michael Ferrari, Michal Koutný, Michal Sekletár, Michał Górny,
        Michele Dionisio, Michiel, Mickaël Salaün, Mike Gilbert,
        Mike Yuan, MkKvcs, Nick Cao, Nick Rosbrook, Nils K, Nova840,
        Oğuz Ersen, Pavel Borecki, PavlNekrasov, Peter Hutterer,
        Peter Rajnoha, Piotr Drąg, Raphaël Mélotte, Renan Guilherme,
        Renjaya Raga Zenta, Ricky Tigg, Riku, Robin Lee, Ronan Pigott,
        Ryan Wilson, Sam James, Sascha Mester, Sean Rhodes,
        Sebastian Gross, Septatrix, Sergey A, ShreyasMahangade,
        Simon Pilkington, Skye Chappelle, Steve Traylen, Stuart Hayhurst,
        SuhailAhmedVelorum, Susant Sahani, Takeo Kondo, Temuri Doghonadze,
        Thomas Blume, Thorsten Kukuk, Thorsten Scherer, Tobias Fleig,
        Tobias Zimmermann, Tom Coldrick, Tom Yan, Tomas Bzatek,
        Topi Miettinen, Tristan F.-R., Uday Shankar, Valentin David,
        Vasiliy Kovalev, Vitaly Kuznetsov, Vito Caputo, Vladimir Panteleev,
        Vursc, Will Fancher, WilliButz, Winterhuman, Xeonacid, Xuanjun Wen,
        Yanqing Jing, Yaron Shahrabani, Yu Watanabe, Yuri Chornoivan,
        ZHANG Yuntian, Zbigniew Jędrzejewski-Szmek, Zhou Qiankang,
        andre4ik3, anonymix007, bryango, chayleaf, chenjiayi, csp5me, cvlc12,
        fwfy, gerblesh, hugo303, jan@neighbourhood.ie, jauge-technica,
        lumingzh, maia x., marginaldev, migleeson, nerdopolis, oldherl,
        pyfisch, q66, rajmohan r, reDBo0n, rhellstrom, rindeal, samuelvw01,
        sinus-x, tfg13, vdovhanych, xujing, Łukasz Stelmach,
        Štěpán Němec, Дамјан Георгиевски, 白一百

        — Edinburgh, 2024-12-10

CHANGES WITH 256:

        Announcements of Future Feature Removals and Incompatible Changes:

        * Support for automatic flushing of the nscd user/group database caches
          will be dropped in a future release.

        * Support for cgroup v1 ('legacy' and 'hybrid' hierarchies) is now
          considered obsolete and systemd by default will refuse to boot under
          it. To forcibly reenable cgroup v1 support,
          SYSTEMD_CGROUP_ENABLE_LEGACY_FORCE=1 must be set on kernel command
          line. The meson option '-Ddefault-hierarchy=' is also deprecated, and
          only cgroup v2 ('unified' hierarchy) can be selected as the build-time
          default.

        * Support for System V service scripts is deprecated and will be
          removed in a future release. Please make sure to update your software
          *now* to include a native systemd unit file instead of a legacy
          System V script to retain compatibility with future systemd releases.

        * Support for the SystemdOptions EFI variable is deprecated.
          'bootctl systemd-efi-options' will emit a warning when used. It seems
          that this feature is little-used and it is better to use alternative
          approaches like credentials and confexts. The plan is to drop support
          altogether at a later point, but this might be revisited based on
          user feedback.

        * systemd-run's switch --expand-environment= which currently is disabled
          by default when combined with --scope, will be changed in a future
          release to be enabled by default.

        * Previously, systemd-networkd did not explicitly remove any bridge
          VLAN IDs assigned on bridge master and ports. Since version 256, if a
          .network file for an interface has at least one valid setting in the
          [BridgeVLAN] section, then all assigned VLAN IDs on the interface
          that are not configured in the .network file are removed.

        * IPForward= setting in .network file is deprecated and replaced with
          IPv4Forwarding= and IPv6Forwarding= settings. These new settings are
          supported both in .network file and networkd.conf. If specified in a
          .network file, they control corresponding per-link settings. If
          specified in networkd.conf, they control corresponding global
          settings. Note, previously IPv6SendRA= and IPMasquerade= implied
          IPForward=, but now they imply the new per-link settings. One of the
          simplest ways to migrate configurations, that worked as a router with
          the previous version, is enabling both IPv4Forwarding= and
          IPv6Forwarding= in networkd.conf. See systemd.network(5) and
          networkd.conf(5) for more details.

        * systemd-gpt-auto-generator will stop generating units for ESP or
          XBOOTLDR partitions if it finds mount entries for or below the /boot/
          or /efi/ hierarchies in /etc/fstab. This is to prevent the generator
          from interfering with systems where the ESP is explicitly configured
          to be mounted at some path, for example /boot/efi/ (this type of
          setup is obsolete, but still commonly found).

        * The behavior of systemd-sleep and systemd-homed has been updated to
          freeze user sessions when entering the various sleep modes or when
          locking a homed-managed home area. This is known to cause issues with
          the proprietary NVIDIA drivers. Packagers of the NVIDIA proprietary
          drivers may want to add drop-in configuration files that set
          SYSTEMD_SLEEP_FREEZE_USER_SESSIONS=false for systemd-suspend.service
          and related services, and SYSTEMD_HOME_LOCK_FREEZE_SESSION=false for
          systemd-homed.service.

        * systemd-tmpfiles and systemd-sysusers, when given a relative
          configuration file path (with at least one directory separator '/'),
          will open the file directly, instead of searching for the given
          partial path in the standard locations. The old mode wasn't useful
          because tmpfiles.d/ and sysusers.d/ configuration has a flat
          structure with no subdirectories under the standard locations and
          this change makes it easier to work with local files with those
          tools.

        * systemd-tmpfiles now properly applies nested configuration to 'R' and
          'D' stanzas. For example, with the combination of 'R /foo' and 'x
          /foo/bar', /foo/bar will now be excluded from removal.

        * systemd.crash_reboot and related settings are deprecated in favor of
          systemd.crash_action=.

        * Stable releases for version v256 and newer will now be pushed in the
          main repository. The systemd-stable repository will be used for existing
          stable branches (v255-stable and lower), and when they reach EOL it will
          be archived.

        General Changes and New Features:

        * Various programs will now attempt to load the main configuration file
          from locations below /usr/lib/, /usr/local/lib/, and /run/, not just
          below /etc/. For example, systemd-logind will look for
          /etc/systemd/logind.conf, /run/systemd/logind.conf,
          /usr/local/lib/systemd/logind.conf, and /usr/lib/systemd/logind.conf,
          and use the first file that is found.  This means that the search
          logic for the main config file and for drop-ins is now the same.

          Similarly, kernel-install will look for the config files in
          /usr/lib/kernel/ and the other search locations, and now also
          supports drop-ins.

          systemd-udevd now supports drop-ins for udev.conf.

        * A new 'systemd-vpick' binary has been added. It implements the new
          vpick protocol, where a "*.v/" directory may contain multiple files
          which have versions (following the UAPI version format specification)
          embedded in the file name. The files are ordered by version and
          the newest one is selected.

          systemd-nspawn --image=/--directory=, systemd-dissect,
          systemd-portabled, and the RootDirectory=, RootImage=,
          ExtensionImages=, and ExtensionDirectories= settings for units now
          support the vpick protocol and allow the latest version to be
          selected automatically if a "*.v/" directory is specified as the
          source.

        * Encrypted service credentials can now be made accessible to
          unprivileged users. systemd-creds gained new options --user/--uid=
          for encrypting/decrypting a credential for a specific user.

        * New command-line tool 'importctl' to download, import, and export
          disk images via systemd-importd is added with the following verbs:
          pull-tar, pull-raw, import-tar, import-raw, import-fs, export-tar,
          export-raw, list-transfers, and cancel-transfer. This functionality
          was previously available in "machinectl", where it was used
          exclusively for machine images. The new "importctl" generalizes this
          for sysext, confext, and portable service images.

        * The systemd sources may now be compiled cleanly with all OpenSSL 3.0
          deprecations removed, including the OpenSSL engine logic turned off.

        Service Management:

        * New system manager setting ProtectSystem= has been added. It is
          analogous to the unit setting, but applies to the whole system. It is
          enabled by default in the initrd.

          Note that this means that code executed in the initrd cannot naively
          expect to be able to write to /usr/ during boot. This affects
          dracut <= 101, which wrote "hooks" to /lib/dracut/hooks/. See
          https://github.com/dracut-ng/dracut-ng/commit/a45048b80c27ee5a45a380.

        * New unit setting WantsMountsFor= has been added. It is analogous to
          RequiresMountsFor=, but creates a Wants= dependency instead of
          Requires=. This new logic is now used in various places where mounts
          were added as dependencies for other settings (WorkingDirectory=-…,
          PrivateTmp=yes, cryptsetup lines with 'nofail').

        * New unit setting MemoryZSwapWriteback= can be used to control the new
          memory.zswap.writeback cgroup knob added in kernel 6.8.

        * The manager gained a org.freedesktop.systemd1.StartAuxiliaryScope()
          D-Bus method to devolve some processes from a service into a new
          scope. This new scope will remain running, even when the original
          service unit is restarted or stopped. This allows a service unit to
          split out some worker processes which need to continue running.
          Control group properties of the new scope are copied from the
          originating unit, so various limits are retained.

        * Units now expose properties EffectiveMemoryMax=,
          EffectiveMemoryHigh=, and EffectiveTasksMax=, which report the
          most stringent limit systemd is aware of for the given unit.

        * A new unit file specifier %D expands to $XDG_DATA_HOME (for user
          services) or /usr/share/ (for system services).

        * AllowedCPUs= now supports specifier expansion.

        * What= setting in .mount and .swap units now accepts fstab-style
          identifiers, for example UUID=… or LABEL=….

        * RestrictNetworkInterfaces= now supports alternative network interface
          names.

        * PAMName= now implies SetLoginEnvironment=yes.

        * systemd.firstboot=no can be used on the kernel command-line to
          disable interactive queries, but allow other first boot configuration
          to happen based on credentials.

        * The system's hostname can be configured via the systemd.hostname
          system credential.

        * The systemd binary will no longer chainload sysvinit's "telinit"
          binary when called under the init/telinit name on a system that isn't
          booted with systemd. This previously has been supported to make sure
          a distribution that has both init systems installed can reasonably
          switch from one to the other via a simple reboot. Distributions
          apparently have lost interest in this, and the functionality has not
          been supported on the primary distribution this was still intended
          for a long time, and hence has been removed now.

        * A new concept called "capsules" has been introduced. "Capsules" wrap
          additional per-user service managers, whose users are transient and
          are only defined as long as the service manager is running. (This is
          implemented via DynamicUser=1), allowing a user manager to be used to
          manage a group of processes without needing to create an actual user
          account. These service managers run with home directories of
          /var/lib/capsules/<capsule-name> and can contain regular services and
          other units. A capsule is started via a simple "systemctl start
          capsule@<name>.service". See the capsule@.service(5) man page for
          further details.

          Various systemd tools (including, and most importantly, systemctl and
          systemd-run) have been updated to interact with capsules via the new
          "--capsule="/"-C" switch.

        * .socket units gained a new setting PassFileDescriptorsToExec=, taking
          a boolean value. If set to true the file descriptors the socket unit
          encapsulates are passed to the ExecStartPost=, ExecStopPre=,
          ExecStopPost= using the usual $LISTEN_FDS interface. This may be used
          for doing additional initializations on the sockets once they are
          allocated. (For example, to install an additional eBPF program on
          them).

        * The .socket setting MaxConnectionsPerSource= (which so far put a
          limit on concurrent connections per IP in Accept=yes socket units),
          now also has an effect on AF_UNIX sockets: it will put a limit on the
          number of simultaneous connections from the same source UID (as
          determined via SO_PEERCRED). This is useful for implementing IPC
          services in a simple Accept=yes mode.

        * The service manager will now maintain a counter of soft reboot cycles
          the system went through. It may be queried via the D-Bus APIs.

        * systemd's execution logic now supports the new pidfd_spawn() API
          introduced by glibc 2.39, which allows us to invoke a subprocess in a
          target cgroup and get a pidfd back in a single operation.

        * systemd/PID 1 will now send an additional sd_notify() message to its
          supervising VMM or container manager reporting the selected hostname
          ("X_SYSTEMD_HOSTNAME=") and machine ID ("X_SYSTEMD_MACHINE_ID=") at
          boot. Moreover, the service manager will send additional sd_notify()
          messages ("X_SYSTEMD_UNIT_ACTIVE=") whenever a target unit is
          reached. This can be used by VMMs/container managers to schedule
          access to the system precisely. For example, the moment a system
          reports "ssh-access.target" being reached a VMM/container manager
          knows it can now connect to the system via SSH. Finally, a new
          sd_notify() message ("X_SYSTEMD_SIGNALS_LEVEL=2") is sent the moment
          PID 1 has successfully completed installation of its various UNIX
          process signal handlers (i.e. the moment where SIGRTMIN+4 sent to
          PID 1 will start to have the effect of shutting down the system
          cleanly). X_SYSTEMD_SHUTDOWN= is sent shortly before the system shuts
          down, and carries a string identifying the type of shutdown,
          i.e. "poweroff", "halt", "reboot". X_SYSTEMD_REBOOT_PARAMETER= is
          sent at the same time and carries the string passed to "systemctl
          --reboot-argument=" if there was one.

        * New D-Bus properties ExecMainHandoffTimestamp and
          ExecMainHandoffTimestampMonotonic are now published by services
          units. This timestamp is taken as the very last operation before
          handing off control to invoked binaries. This information is
          available for other unit types that fork off processes (i.e. mount,
          swap, socket units), but currently only via "systemd-analyze dump".

        * An additional timestamp is now taken by the service manager when a
          system shutdown operation is initiated. It can be queried via D-Bus
          during the shutdown phase. It's passed to the following service
          manager invocation on soft reboots, which will then use it to log the
          overall "grey-out" time of the soft reboot operation, i.e. the time
          when the shutdown began until the system is fully up again.

        * "systemctl status" will now display the invocation ID in its usual
          output, i.e. the 128bit ID uniquely assigned to the current runtime
          cycle of the unit. The ID has been supported for a long time, but is
          now more prominently displayed, as it is a very useful handle to a
          specific invocation of a service.

        * systemd now generates a new "taint" string "unmerged-bin" for systems
          that have /usr/bin/ and /usr/sbin/ separate. It's generally
          recommended to make the latter a symlink to the former these days.

        * A new systemd.crash_action= kernel command line option has been added
          that configures what to do after the system manager (PID 1) crashes.
          This can also be configured through CrashAction= in systemd.conf.

        * "systemctl kill" now supports --wait which will make the command wait
          until the signalled services terminate.

        Journal:

        * systemd-journald can now forward journal entries to a socket
          (AF_INET, AF_INET6, AF_UNIX, or AF_VSOCK). The socket can be
          specified in journald.conf via a new option ForwardToSocket= or via
          the 'journald.forward_to_socket' credential. Log records are sent in
          the Journal Export Format. A related setting MaxLevelSocket= has been
          added to control the maximum log levels for the messages sent to this
          socket.

        * systemd-journald now also reads the journal.storage credential when
          determining where to store journal files.

        * systemd-vmspawn gained a new --forward-journal= option to forward the
          virtual machine's journal entries to the host. This is done over a
          AF_VSOCK socket, i.e. it does not require networking in the guest.

        * journalctl gained option '-i' as a shortcut for --file=.

        * journalctl gained a new -T/--exclude-identifier= option to filter
          out certain syslog identifiers.

        * journalctl gained a new --list-namespaces option.

        * systemd-journal-remote now also accepts AF_VSOCK and AF_UNIX sockets
          (so it can be used to receive entries forwarded by systemd-journald).

        * systemd-journal-gatewayd allows restricting the time range of
          retrieved entries with a new "realtime=[<since>]:[<until>]" URL
          parameter.

        * systemd-cat gained a new option --namespace= to specify the target
          journal namespace to which the output shall be connected.

        * systemd-bsod gained a new option --tty= to specify the output TTY

        Device Management:

        * /dev/ now contains symlinks that combine by-path and by-{label,uuid}
          information:

              /dev/disk/by-path/<path>/by-<label|uuid|…>/<label|uuid|…>

          This allows distinguishing partitions with identical contents on
          multiple storage devices. This is useful, for example, when copying
          raw disk contents between devices.

        * systemd-udevd now creates persistent /dev/media/by-path/ symlinks for
          media controllers. For example, the uvcvideo driver may create
          /dev/media0 which will be linked as
          /dev/media/by-path/pci-0000:04:00.3-usb-0:1:1.0-media-controller.

        * A new unit systemd-udev-load-credentials.service has been added
          to pick up udev.conf drop-ins and udev rules from credentials.

        * 'udevadm test' and 'udevadm test-builtin' commands now do not change
          any settings; sysfs attributes, sysctls, udev database and so on.
          E.g. 'udevadm test-builtin net_setup_link /sys/class/net/INTERFACE'
          does not change any interface settings, but only prints which .link
          file matches the interface. So, even privileged users can safely
          invoke the commands.

        * An allowlist/denylist may be specified to filter which sysfs
          attributes are used when crafting network interface names. Those
          lists are stored as hwdb entries
            ID_NET_NAME_ALLOW_<sysfsattr>=0|1
          and
            ID_NET_NAME_ALLOW=0|1.

          The goal is to avoid unexpected changes to interface names when the
          kernel is updated and new sysfs attributes become visible.

        * A new unit tpm2.target has been added to provide a synchronization
          point for units which expect the TPM hardware to be available. A new
          generator "systemd-tpm2-generator" has been added that will insert
          this target whenever it detects that the firmware has initialized a
          TPM, but Linux hasn't loaded a driver for it yet.

        * systemd-backlight now properly supports numbered devices which the
          kernel creates to avoid collisions in the leds subsystem.

        * systemd-hwdb update operation can be disabled with a new environment
          variable SYSTEMD_HWDB_UPDATE_BYPASS=1.

        systemd-hostnamed:

        * systemd-hostnamed now exposes the machine ID and boot ID via
          D-Bus. It also exposes the hosts AF_VSOCK CID, if available.

        * systemd-hostnamed now provides a basic Varlink interface.

        * systemd-hostnamed exports the full data in os-release(5) and
          machine-info(5) via D-Bus and Varlink.

        * hostnamectl now shows the system's product UUID and hardware serial
          number if known.

        Network Management:

        * systemd-networkd now provides a basic Varlink interface.

        * systemd-networkd's ARP proxy support gained a new option to configure
          a private VLAN variant of the proxy ARP supported by the kernel under
          the name IPv4ProxyARPPrivateVLAN=.

        * systemd-networkd now exports the NamespaceId and NamespaceNSID
          properties via D-Bus and Varlink. (which expose the inode and NSID of
          the network namespace the networkd instance manages)

        * systemd-networkd now supports IPv6RetransmissionTimeSec= and
          UseRetransmissionTime= settings in .network files to configure
          retransmission time for IPv6 neighbor solicitation messages.

        * networkctl gained new verbs 'mask' and 'unmask' for masking networkd
          configuration files such as .network files.

        * 'networkctl edit --runtime' allows editing volatile configuration
          under /run/systemd/network/.

        * The implementation behind TTLPropagate= network setting has been
          removed and the setting is now ignored.

        * systemd-network-generator will now pick up .netdev/.link/.network/
          networkd.conf configuration from system credentials.

        * systemd-networkd will now pick up wireguard secrets from
          credentials.

        * systemd-networkd's Varlink API now supports enumerating LLDP peers.

        * .link files now support new Property=, ImportProperty=,
          UnsetProperty= fields for setting udev properties on a link.

        * The various .link files that systemd ships for interfaces that are
          supposed to be managed by systemd-networkd only now carry a
          ID_NET_MANAGED_BY=io.systemd.Network udev property ensuring that
          other network management solutions honouring this udev property do
          not come into conflict with networkd, trying to manage these
          interfaces.

        * .link files now support a new ReceivePacketSteeringCPUMask= setting
          for configuring which CPUs to steer incoming packets to.

        * The [Network] section in .network files gained a new setting
          UseDomains=, which is a single generic knob for controlling the
          settings of the same name in the [DHCPv4], [DHCPv6] and
          [IPv6AcceptRA].

        * The 99-default.link file we ship by default (that defines the policy
          for all network devices to which no other .link file applies) now
          lists "mac" among AlternativeNamesPolicy=. This means that network
          interfaces will now by default gain an additional MAC-address based
          alternative device name. (i.e. enx…)

        systemd-nspawn:

        * systemd-nspawn now provides a /run/systemd/nspawn/unix-export/
          directory where the container payload can expose AF_UNIX sockets to
          allow them to be accessed from outside.

        * systemd-nspawn will tint the terminal background for containers in a
          blueish color. This can be controller with the new --background=
          switch or the new $SYSTEMD_TINT_BACKGROUND environment variable.

        * systemd-nspawn gained support for the 'owneridmap' option for --bind=
          mounts to map the target directory owner from inside the container to
          the owner of the directory bound from the host filesystem.

        * systemd-nspawn now supports moving Wi-Fi network devices into a
          container, just like other network interfaces.

        systemd-resolved:

        * systemd-resolved now reads RFC 8914 EDE error codes provided by
          upstream DNS services.

        * systemd-resolved and resolvectl now support RFC 9460 SVCB and HTTPS
          records, as well as RFC 2915 NAPTR records.

        * resolvectl gained a new option --relax-single-label= to allow
          querying single-label hostnames via unicast DNS on a per-query basis.

        * systemd-resolved's Varlink IPC interface now supports resolving
          DNS-SD services as well as an API for resolving raw DNS RRs.

        * systemd-resolved's .dnssd DNS_SD service description files now
          support DNS-SD "subtypes" via the new SubType= setting.

        * systemd-resolved's configuration may now be reloaded without
          restarting the service. (i.e. "systemctl reload systemd-resolved" is
          now supported)

        SSH Integration:

        * An sshd_config drop-in to allow ssh keys acquired via userdbctl (for
          example expose by homed accounts) to be used for authorization of
          incoming SSH connections. This uses the AuthorizedKeysCommand stanza
          of sshd_config. Note that sshd only allows a single command to be
          configured this way, hence this drop-in might conflict with other
          uses of the logic. It is possible to chainload another, similar tool
          of another subsystem via the --chain switch of userdbctl, to support
          both in parallel. See the "INTEGRATION WITH SSH" section in
          userdbctl(1) for details on this. Our recommendation how to combine
          other subsystem's use of the SSH authorized keys logic with systemd's
          userbctl functionality however is to implement the APIs described
          here: https://systemd.io/USER_GROUP_API – in that case this newly
          added sshd_config integration would just work and do the right thing
          for all backends.

        * A small new unit generator "systemd-ssh-generator" has been added. It
          checks if the sshd binary is installed. If so, it binds it via
          per-connection socket activation to various sockets depending on the
          execution context:

            • If the system is run in a VM providing AF_VSOCK support, it
              automatically binds sshd to AF_VSOCK port 22.

            • If the system is invoked as a full-OS container and the container
              manager pre-mounts a directory /run/host/unix-export/, it will
              bind sshd to an AF_UNIX socket /run/host/unix-export/ssh. The
              idea is the container manager bind mounts the directory to an
              appropriate place on the host as well, so that the AF_UNIX socket
              may be used to easily connect from the host to the container.

            • sshd is also bound to an AF_UNIX socket
              /run/ssh-unix-local/socket, which may be to use ssh/sftp in a
              "sudo"-like fashion to access resources of other local users.

            • Via the kernel command line option "systemd.ssh_listen=" and the
              system credential "ssh.listen" sshd may be bound to additional,
              explicitly configured options, including AF_INET/AF_INET6 ports.

          In particular the first two mechanisms should make dealing with local
          VMs and full OS containers a lot easier, as SSH connections will
          *just* *work* from the host – even if no networking is available
          whatsoever.

          systemd-ssh-generator optionally generates a per-connection
          socket activation service file wrapping sshd. This is only done if
          the distribution does not provide one on its own under the name
          "sshd@.service". The generated unit only works correctly if the SSH
          privilege separation ("privsep") directory exists. Unfortunately
          distributions vary wildly where they place this directory. An
          incomprehensive list:

            • /usr/share/empty.sshd/  (new fedora)
            • /var/empty/
            • /var/empty/sshd/
            • /run/sshd/              (debian/ubuntu?)

          If the SSH privsep directory is placed below /var/ or /run/ care
          needs to be taken that the directory is created automatically at boot
          if needed, since these directories possibly or always come up
          empty. This can be done via a tmpfiles.d/ drop-in. You may use the
          "sshdprivsepdir" meson option provided by systemd to configure the
          directory, in case you want systemd to create the directory as needed
          automatically, if your distribution does not cover this natively.

          Recommendations to distributions, in order to make things just work:

            • Please provide a per-connection SSH service file under the name
              "sshd@.service".

            • Please move the SSH privsep dir into /usr/ (so that it is truly
              immutable on image-based operating systems, is strictly under
              package manager control, and never requires recreation if the
              system boots up with an empty /run/ or /var/).

            • As an extension of this: please consider following Fedora's lead
              here, and use /usr/share/empty.sshd/ to minimize needless
              differences between distributions.

            • If your distribution insists on placing the directory in /var/ or
              /run/ then please at least provide a tmpfiles.d/ drop-in to
              recreate it automatically at boot, so that the sshd binary just
              works, regardless in which context it is called.

        * A small tool "systemd-ssh-proxy" has been added, which is supposed to
          act as counterpart to "systemd-ssh-generator". It's a small plug-in
          for the SSH client (via ProxyCommand/ProxyUseFdpass) to allow it to
          connect to AF_VSOCK or AF_UNIX sockets. Example: "ssh vsock/4711"
          connects to a local VM with cid 4711, or "ssh
          unix/run/ssh-unix-local/socket" to connect to the local host via the
          AF_UNIX socket /run/ssh-unix-local/socket.

        systemd-boot and systemd-stub and Related Tools:

        * TPM 1.2 PCR measurement support has been removed from systemd-stub.
          TPM 1.2 is obsolete and – due to the (by today's standards) weak
          cryptographic algorithms it only supports – does not actually provide
          the security benefits it's supposed to provide. Given that the rest
          of systemd's codebase never supported TPM 1.2, the support has now
          been removed from systemd-stub as well.

        * systemd-stub will now measure its payload via the new EFI
          Confidential Computing APIs (CC), in addition to the pre-existing
          measurements to TPM.

        * confexts are loaded by systemd-stub from the ESP as well.

        * kernel-install gained support for --root= for the 'list' verb.

        * bootctl now provides a basic Varlink interface and can be run as a
          daemon via a template unit.

        * systemd-measure gained new options --certificate=, --private-key=,
          and --private-key-source= to allow using OpenSSL's "engines" or
          "providers" as the signing mechanism to use when creating signed
          TPM2 PCR measurement values.

        * ukify gained support for signing of PCR signatures via OpenSSL's
          engines and providers.

        * ukify now supports zboot kernels.

        * systemd-boot now supports passing additional kernel command line
          switches to invoked kernels via an SMBIOS Type #11 string
          "io.systemd.boot.kernel-cmdline-extra". This is similar to the
          pre-existing support for this in systemd-stub, but also applies to
          Type #1 Boot Loader Specification Entries.

        * systemd-boot's automatic SecureBoot enrollment support gained support
          for enrolling "dbx" too (Previously, only db/KEK/PK enrollment was
          supported). It also now supports UEFI "Custom" and "Audit" modes.

        * The pcrlock policy is saved in an unencrypted credential file
          "pcrlock.<entry-token>.cred" under XBOOTLDR/ESP in the
          /loader/credentials/ directory. It will be picked up at boot by
          systemd-stub and passed to the initrd, where it can be used to unlock
          the root file system.

        * systemd-pcrlock gained an --entry-token= option to configure the
          entry-token.

        * systemd-pcrlock now provides a basic Varlink interface and can be run
          as a daemon via a template unit.

        * systemd-pcrlock's TPM nvindex access policy has been modified, this
          means that previous pcrlock policies stored in nvindexes are
          invalidated. They must be removed (systemd-pcrlock remove-policy) and
          recreated (systemd-pcrlock make-policy). For the time being
          systemd-pcrlock remains an experimental feature, but it is expected
          to become stable in the next release, i.e. v257.

        * systemd-pcrlock's --recovery-pin= switch now takes three values:
          "hide", "show", "query". If "show" is selected the automatically
          generated recovery PIN is shown to the user. If "query" is selected
          then the PIN is queried from the user.

        * sd-stub gained support for the new ".ucode" PE section in UKIs, that
          may contain CPU microcode data. When control is handed over to the
          Linux kernel this data is prepended to the set of initrds passed.

        systemd-run/run0:

        * systemd-run is now a multi-call binary. When invoked as 'run0', it
          provides as interface similar to 'sudo', with all arguments starting
          at the first non-option parameter being treated the command to invoke
          as root. Unlike 'sudo' and similar tools, it does not make use of
          setuid binaries or other privilege escalation methods, but instead
          runs the specified command as a transient unit, which is started by
          the system service manager, so privileges are dropped, rather than
          gained, thus implementing a much more robust and safe security
          model. As usual, authorization is managed via Polkit.

        * systemd-run/run0 will now tint the terminal background on supported
          terminals: in a reddish tone when invoking a root service, in a
          yellowish tone otherwise. This may be controlled and turned off via
          the new --background= switch or the new $SYSTEMD_TINT_BACKGROUND
          environment variable.

        * systemd-run gained a new option '--ignore-failure' to suppress
          command failures.

        Command-line tools:

        * 'systemctl edit --stdin' allows creation of unit files and drop-ins
          with contents supplied via standard input. This is useful when creating
          configuration programmatically; the tool takes care of figuring out
          the file name, creating any directories, and reloading the manager
          afterwards.

        * 'systemctl disable --now' and 'systemctl mask --now' now work
          correctly with template units.

        * 'systemd-analyze architectures' lists known CPU architectures.

        * 'systemd-analyze --json=…' is supported for 'architectures',
          'capability', 'exit-status'.

        * 'systemd-tmpfiles --purge' will purge (remove) all files and
          directories created via tmpfiles.d configuration.

        * systemd-id128 gained new options --no-pager, --no-legend, and
          -j/--json=.

        * hostnamectl gained '-j' as shortcut for '--json=pretty' or
          '--json=short'.

        * loginctl now supports -j/--json=.

        * resolvectl now supports -j/--json= for --type=.

        * systemd-tmpfiles gained a new option --dry-run to print what would be
          done without actually taking action.

        * varlinkctl gained a new --collect switch to collect all responses of
          a method call that supports multiple replies and turns it into a
          single JSON array.

        * systemd-dissect gained a new --make-archive option to generate an
          archive file (tar.gz and similar) from a disk image.

        systemd-vmspawn:

        * systemd-vmspawn gained a new --firmware= option to configure or list
          firmware definitions for Qemu, a new --tpm= option to enable or
          disable the use of a software TPM, a new --linux= option to specify a
          kernel binary for direct kernel boot, a new --initrd= option to
          specify an initrd for direct kernel boot, a new -D/--directory option
          to use a plain directory as the root file system, a new
          --private-users option similar to the one in systemd-nspawn, new
          options --bind= and --bind-ro= to bind part of the host's file system
          hierarchy into the guest, a new --extra-drive= option to attach
          additional storage, and -n/--network-tap/--network-user-mode to
          configure networking.

        * A new systemd-vmspawn@.service can be used to launch systemd-vmspawn
          as a service.

        * systemd-vmspawn gained the new --console= and --background= switches
          that control how to interact with the VM. As before, by default an
          interactive terminal interface is provided, but now with a background
          tinted with a greenish hue.

        * systemd-vmspawn can now register its VMs with systemd-machined,
          controlled via the --register= switch.

        * machinectl's start command (and related) can now invoke images either
          as containers via systemd-nspawn (specified as '--runner=nspawn', the
          default) or as VMs via systemd-vmspawn (specified as
          '--runner=vmspawn' or '-V').

        * systemd-vmspawn now supports two switches --pass-ssh-key= and
          --ssh-key-type= to optionally set up transient SSH keys to pass to the
          invoked VMs in order to be able to SSH into them once booted.

        * systemd-vmspawn will now enable various "HyperV enlightenments" and
          the "VM Generation ID" on the VMs.

        * A new environment variable $SYSTEMD_VMSPAWN_QEMU_EXTRA may carry
          additional qemu command line options to pass to qemu.

        * systemd-machined gained a new GetMachineSSHInfo() D-Bus method that is
          used by systemd-vmspawn to fetch the information needed to ssh into the
          machine.

        * systemd-machined gained a new Varlink interface that is used by
          systemd-vmspawn to register machines with additional information and
          metadata.

        systemd-repart:

        * systemd-repart gained new options --generate-fstab= and
          --generate-crypttab= to write out fstab and crypttab files matching the
          generated partitions.

        * systemd-repart gained a new option --private-key-source= to allow
          using OpenSSL's "engines" or "providers" as the signing mechanism to
          use when creating verity signature partitions.

        * systemd-repart gained a new DefaultSubvolume= setting in repart.d/
          drop-ins that allow configuring the default btrfs subvolume for newly
          formatted btrfs file systems.

        Libraries:

        * libsystemd gained new call sd_bus_creds_new_from_pidfd() to get a
          credentials object for a pidfd and sd_bus_creds_get_pidfd_dup() to
          retrieve the pidfd from a credentials object.

        * sd-bus' credentials logic will now also acquire peer's UNIX group
          lists and peer's pidfd if supported and requested.

        * RPM macro %_kernel_install_dir has been added with the path
          to the directory for kernel-install plugins.

        * The liblz4, libzstd, liblzma, libkmod, libgcrypt dependencies have
          been changed from regular shared library dependencies into dlopen()
          based ones.

          Note that this means that those libraries might not be automatically
          pulled in when ELF dependencies are resolved. In particular lack of
          libkmod might cause problems with boot. This affects dracut <= 101,
          see https://github.com/dracut-ng/dracut-ng/commit/04b362d713235459cf.

        * systemd ELF binaries that use libraries via dlopen() are now built with
          a new ELF header note section, following a new specification defined at
          docs/ELF_DLOPEN_METADATA.md, that provides information about which
          sonames are loaded and used if found at runtime. This allows tools and
          packagers to programmatically discover the list of optional
          dependencies used by all systemd ELF binaries. A parser with packaging
          integration tools is available at
          https://github.com/systemd/package-notes

        * The sd-journal API gained a new call
          sd_journal_stream_fd_with_namespace() which is just like
          sd_journal_stream_fd() but creates a log stream targeted at a
          specific log namespace.

        * The sd-id128 API gained a new API call
          sd_id128_get_invocation_app_specific() for acquiring an app-specific
          ID that is derived from the service invocation ID.

        * The sd-event API gained a new API call
          sd_event_source_get_inotify_path() that returns the file system path
          an inotify event source was created for.

        systemd-cryptsetup/systemd-cryptenroll:

        * The device node argument to systemd-cryptenroll is now optional. If
          omitted it will be derived automatically from the backing block
          device of /var/ (which quite likely is the same as the root file
          system, hence effectively means if you don't specify things otherwise
          the tool will now default to enrolling a key into the root file
          system's LUKS device).

        * systemd-cryptenroll can now enroll directly with a PKCS11 public key
          (instead of a certificate).

        * systemd-cryptsetup/systemd-cryptenroll now may lock a disk against a
          PKCS#11 provided EC key (before it only supported RSA).

        * systemd-cryptsetup gained support for crypttab option
          link-volume-key= to link the volume key into the kernel keyring when
          the volume is opened.

        * systemd-cryptenroll will no longer enable Dictionary Attack
          Protection (i.e. turn on NO_DA) for TPM enrollments that do not
          involve a PIN. DA should not be necessary in that case (since key
          entropy is high enough to make this unnecessary), but risks
          accidental lock-out in case of unexpected PCR changes.

        * systemd-cryptenroll now supports enrolling a new slot while unlocking
          the old slot via TPM2 (previously unlocking only worked via password
          or FIDO2).

        Documentation:

        * The remaining documentation that was on
          https://freedesktop.org/wiki/Software/systemd/ has been moved to
          https://systemd.io/.

        * A new text describing the VM integration interfaces of systemd has
          been added:

          https://systemd.io/VM_INTERFACE

        * The sd_notify() man page has gained examples with C and Python code
          that shows how to implement the interface in those languages without
          involving libsystemd.

        systemd-homed, systemd-logind, systemd-userdbd:

        * systemd-homed now supports unlocking of home directories when logging
          in via SSH. Previously home directories needed to be unlocked before
          an SSH login is attempted.

        * JSON User Records have been extended with a separate public storage
          area called "User Record Blob Directories". This is intended to store
          the user's background image, avatar picture, and other similar items
          which are too large to fit into the User Record itself.

          systemd-homed, userdbctl, and homectl gained support for blob
          directories. homectl gained --avatar= and --login-background= to
          control two specific items of the blob directories.

        * A new "additionalLanguages" field has been added to JSON user records
          (as supported by systemd-homed and systemd-userdbd), which is closely
          related to the pre-existing "preferredLanguage", and allows
          specifying multiple additional languages for the user account. It is
          used to initialize the $LANGUAGES environment variable when used.

        * A new pair of "preferredSessionType" and "preferredSessionLauncher"
          fields have been added to JSON user records, that may be used to
          control which kind of desktop session to preferable activate on
          logins of the user.

        * homectl gained a new verb 'firstboot', and a new
          systemd-homed-firstboot.service unit uses this verb to create users
          in a first boot environment, either from system credentials or by
          querying interactively.

        * systemd-logind now supports a new "background-light" session class
          which does not pull in the user@.service unit. This is intended in
          particular for lighter weight per-user cron jobs which do require any
          per-user service manager to be around.

        * The per-user service manager will now be tracked as a distinct "manager"
          session type among logind sessions of each user.

        * homectl now supports an --offline mode, by which certain account
          properties can be changed without unlocking the home directory.

        * systemd-logind gained a new
          org.freedesktop.login1.Manager.ListSessionsEx() method that provides
          additional metadata compared to ListSessions(). loginctl makes use of
          this to list additional fields in list-sessions.

        * systemd-logind gained a new org.freedesktop.login1.Manager.Sleep()
          method that automatically redirects to SuspendThenHibernate(),
          Suspend(), HybridSleep(), or Hibernate(), depending on what is
          supported and configured, a new configuration setting SleepOperation=,
          and an accompanying helper method
          org.freedesktop.login1.Manager.CanSleep() and property
          org.freedesktop.login1.Manager.SleepOperation.

          'systemctl sleep' calls the new method to automatically put the
          machine to sleep in the most appropriate way.

        Credential Management:

        * systemd-creds now provides a Varlink IPC API for encrypting and
          decrypting credentials.

        * systemd-creds' "tpm2-absent" key selection has been renamed to
          "null", since that's what it actually does: "encrypt" and "sign"
          with a fixed null key. --with-key=null should only be used in very
          specific cases, as it provides zero integrity or confidentiality
          protections. (i.e. it's only safe to use as fallback in environments
          lacking both a TPM and access to the root fs to use the host
          encryption key, or when integrity is provided some other way.)

        * systemd-creds gained a new switch --allow-null. If specified, the
          "decrypt" verb will decode encrypted credentials that use the "null"
          key (by default this is refused, since using the "null" key defeats
          the authenticated encryption normally done).

        Suspend & Hibernate:

        * The sleep.conf configuration file gained a new MemorySleepMode=
          setting for configuring the sleep mode in more detail.

        * A tiny new service systemd-hibernate-clear.service has been added
          which clears hibernation information from the HibernateLocation EFI
          variable, in case the resume device is gone. Normally, this variable
          is supposed to be cleaned up by the code that initiates the resume
          from hibernation image. But when the device is missing and that code
          doesn't run, this service will now do the necessary work, ensuring
          that no outdated hibernation image information remains on subsequent
          boots.

        Unprivileged User Namespaces & Mounts:

        * A small new service systemd-nsresourced.service has been added. It
          provides a Varlink IPC API that assigns a free, transiently allocated
          64K UID/GID range to an uninitialized user namespace a client
          provides. It may be used to implement unprivileged container managers
          and other programs that need dynamic user ID ranges. It also provides
          interfaces to then delegate mount file descriptors, control groups
          and network interfaces to user namespaces set up this way.

        * A small new service systemd-mountfsd.service has been added. It
          provides a Varlink IPC API for mounting DDI images, and returning a set
          of mount file descriptors for it. If a user namespace fd is provided
          as input, then the mounts are registered with the user namespace. To
          ensure trust in the image it must provide Verity information (or
          alternatively interactive polkit authentication is required).

        * The systemd-dissect tool now can access DDIs fully unprivileged by
          using systemd-nsresourced/systemd-mountfsd.

        * If the service manager runs unprivileged (i.e. systemd --user) it now
          supports RootImage= for accessing DDI images, also implemented via
          the systemd-nsresourced/systemd-mountfsd.

        * systemd-nspawn may now operate without privileges, if a suitable DDI
          is provided via --image=, again implemented via
          systemd-nsresourced/systemd-mountfsd.

        Other:

        * timedatectl and machinectl gained option '-P', an alias for
          '--value --property=…'.

        * Various tools that pretty-print config files will now highlight
          configuration directives.

        * varlinkctl gained support for the "ssh:" transport. This requires
          OpenSSH 9.4 or newer.

        * systemd-sysext gained support for enabling system extensions in
          mutable fashion, where a writeable upperdir is stored under
          /var/lib/extensions.mutable/, and a new --mutable= option to
          configure this behaviour. An "ephemeral" mode is not also supported
          where the mutable layer is configured to be a tmpfs that is
          automatically released when the system extensions are reattached.

        * Coredumps are now retained for two weeks by default (instead of three
          days, as before).

        * portablectl --copy= parameter gained a new 'mixed' argument, that will
          result in resources owned by the OS (e.g.: portable profiles) to be linked
          but resources owned by the portable image (e.g.: the unit files and the
          images themselves) to be copied.

        * systemd will now register MIME types for various of its file types
          (e.g. journal files, DDIs, encrypted credentials …) via the XDG
          shared-mime-info infrastructure. (Files of these types will thus be
          recognized as their own thing in desktop file managers such as GNOME
          Files.)

        * systemd-dissect will now show the detected sector size of a given DDI
          in its default output.

        * systemd-portabled now generates recognizable structured log messages
          whenever a portable service is attached or detached.

        * Verity signature checking in userspace (i.e. checking against
          /etc/verity.d/ keys) when activating DDIs can now be turned on/off
          via a kernel command line option systemd.allow_userspace_verity= and
          an environment variable SYSTEMD_ALLOW_USERSPACE_VERITY=.

        * ext4/xfs file system quota handling has been reworked, so that
          quotacheck and quotaon are now invoked as per-file-system templated
          services (as opposed to single system-wide singletons), similar in
          style to the fsck, growfs, pcrfs logic. This means file systems with
          quota enabled can now be reasonably enabled at runtime of the system,
          not just at boot.

        * "systemd-analyze dot" will now also show BindsTo= dependencies.

        * systemd-debug-generator gained the ability add in arbitrary units
          based on them being passed in via system credentials.

        * A new kernel command-line option systemd.default_debug_tty= can be
          used to specify the TTY for the debug shell, independently of
          enabling or disabling it.

        * portablectl gained a new --clean switch that clears a portable
          service's data (cache, logs, state, runtime, fdstore) when detaching
          it.

        Contributions from: A S Alam, AKHIL KUMAR,
        Abraham Samuel Adekunle, Adrian Vovk, Adrian Wannenmacher,
        Alan Liang, Alberto Planas, Alexander Zavyalov, Anders Jonsson,
        Andika Triwidada, Andres Beltran, Andrew Sayers,
        Antonio Alvarez Feijoo, Arian van Putten, Arthur Zamarin,
        Artur Pak, AtariDreams, Benjamin Franzke, Bernhard M. Wiedemann,
        Black-Hole1, Bryan Jacobs, Burak Gerz, Carlos Garnacho,
        Chandra Pratap, Chris Hofstaedtler, Chris Packham, Chris Simons,
        Christian Göttsche, Christian Wesselhoeft, Clayton Craft,
        Colin Geniet, Colin Walters, Colin Watson, Costa Tsaousis,
        Cristian Rodríguez, Daan De Meyer, Damien Challet, Dan Streetman,
        Daniel Winzen, Daniele Medri, David Seifert, David Tardon,
        David Venhoek, Diego Viola, Dionna Amalie Glaze,
        Dmitry Konishchev, Dmitry V. Levin, Edson Juliano Drosdeck,
        Eisuke Kawashima, Eli Schwartz, Emanuele Giuseppe Esposito,
        Eric Daigle, Evgeny Vereshchagin, Felix Riemann,
        Fernando Fernandez Mancera, Florian Fainelli, Florian Schmaus,
        Franck Bui, Frantisek Sumsal, Friedrich Altheide,
        Gabríel Arthúr Pétursson, Gaël Donval, Georges Basile Stavracas Neto,
        Gerd Hoffmann, GNOME Foundation, Guido Leenders,
        Guilhem Lettron, Göran Uddeborg, Hans de Goede, Harald Brinkmann,
        Heinrich Schuchardt, Helmut Grohne, Henry Li, Heran Yang,
        Holger Assmann, Ivan Kruglov, Ivan Shapovalov, Jakub Sitnicki,
        James Muir, Jan Engelhardt, Jan Macku, Jarne Förster, Jeff King,
        Jian-Hong Pan, JmbFountain, Joakim Nohlgård, Jonathan Conder,
        Julius Alexandre, Jörg Behrmann, Kai Lueke, Kamil Szczęk,
        KayJay7, Keian, Kirk, Kristian Klausen, Krzesimir Nowak,
        Lain "Fearyncess" Yang, Lars Ellenberg, Lennart Poettering,
        Leonard, Luca Boccassi, Lucas Salles, Ludwig Nussel,
        Lukáš Nykrýn, Luna Jernberg, Luxiter, Maanya Goenka,
        Maciej S. Szmigiero, Mariano Giménez, Markus Merklinger,
        Martin Ivicic, Martin Srebotnjak, Martin Trigaux, Martin Wilck,
        Mathias Lang, Matt Layher, Matt Muggeridge, Matteo Croce,
        Matthias Lisin, Max Gautier, Max Staudt, MaxHearnden,
        Michael Biebl, Michal Koutný, Michal Sekletár, Michał Kopeć,
        Mike Gilbert, Mike Yuan, Mikko Ylinen, MkfsSion, Moritz Sanft,
        MrSmör, Nandakumar Raghavan, Nicholas Little, Nick Cao,
        Nick Rosbrook, Nicolas Bouchinet, Norbert Lange,
        Ole Peder Brandtzæg, Ondrej Kozina, Oğuz Ersen,
        Pablo Méndez Hernández, Pierre GRASSER, Piotr Drąg, QuonXF,
        Radoslav Kolev, Rafaël Kooi, Raito Bezarius, Rasmus Villemoes,
        Reid Wahl, Renjaya Raga Zenta, Richard Maw, Roland Hieber,
        Ronan Pigott, Rose, Ross Burton, Saliba-san, Sam Leonard,
        Samuel BF, Sarvajith Adyanthaya, Scrambled 777,
        Sebastian Pucilowski, Sergei Zhmylev, Sergey A, Shulhan,
        SidhuRupinder, Simon Fowler, Skia, Sludge, Stuart Hayhurst,
        Susant Sahani, Takashi Sakamoto, Temuri Doghonadze, Thayne McCombs,
        Thilo Fromm, Thomas Blume, Tiago Rocha Cunha, Timo Rothenpieler,
        TobiPeterG, Tobias Fleig, Tomáš Pecka, Topi Miettinen,
        Tycho Andersen, Unique-Usman, Usman Akinyemi, Vasiliy Kovalev,
        Vasiliy Stelmachenok, Victor Berchet, Vishal Chillara Srinivas,
        Vitaly Kuznetsov, Vito Caputo, Vladimir Stoiakin, Werner Sembach,
        Will Springer, Winterhuman, Xiaotian Wu, Yu Watanabe,
        Yuri Chornoivan, Zbigniew Jędrzejewski-Szmek, Zmyeir, anphir,
        aslepykh, chenjiayi, cpackham-atlnz, cunshunxia, djantti, drewbug,
        hanjinpeng, hfavisado, hulkoba, hydrargyrum, ksaleem, mburucuyapy,
        medusalix, mille-feuille, mkubiak, mooo, msizanoen, networkException,
        nl6720, r-vdp, runiq, sam-leonard-ct, samuelvw01, sharad3001, spdfnet,
        sushmbha, wangyuhang, zeroskyx, zzywysm, İ. Ensar Gülşen,
        Łukasz Stelmach, Štěpán Němec, 我超厉害, 김인수

        — Edinburgh, 2024-06-11

CHANGES WITH 255:

        Announcements of Future Feature Removals and Incompatible Changes:

        * Support for split-usr (/usr/ mounted separately during late boot,
          instead of being mounted by the initrd before switching to the rootfs)
          and unmerged-usr (parallel directories /bin/ and /usr/bin/, /lib/ and
          /usr/lib/, …) has been removed. For more details, see:
          https://lists.freedesktop.org/archives/systemd-devel/2022-September/048352.html

        * We intend to remove cgroup v1 support from a systemd release after
          the end of 2023. If you run services that make explicit use of
          cgroup v1 features (i.e. the "legacy hierarchy" with separate
          hierarchies for each controller), please implement compatibility with
          cgroup v2 (i.e. the "unified hierarchy") sooner rather than later.
          Most of Linux userspace has been ported over already.

        * Support for System V service scripts is now deprecated and will be
          removed in a future release. Please make sure to update your software
          *now* to include a native systemd unit file instead of a legacy
          System V script to retain compatibility with future systemd releases.

        * Support for the SystemdOptions EFI variable is deprecated.
          'bootctl systemd-efi-options' will emit a warning when used. It seems
          that this feature is little-used and it is better to use alternative
          approaches like credentials and confexts. The plan is to drop support
          altogether at a later point, but this might be revisited based on
          user feedback.

        * systemd-run's switch --expand-environment= which currently is disabled
          by default when combined with --scope, will be changed in a future
          release to be enabled by default.

        * "systemctl switch-root" is now restricted to initrd transitions only.

          Transitions between real systems should be done with
          "systemctl soft-reboot" instead.

        * The "ip=off" and "ip=none" kernel command line options interpreted by
          systemd-network-generator will now result in IPv6RA + link-local
          addressing being disabled, too. Previously DHCP was turned off, but
          IPv6RA and IPv6 link-local addressing was left enabled.

        * The NAMING_BRIDGE_MULTIFUNCTION_SLOT naming scheme has been deprecated
          and is now disabled.

        * SuspendMode=, HibernateState= and HybridSleepState= in the [Sleep]
          section of systemd-sleep.conf are now deprecated and have no effect.
          They did not (and could not) take any value other than the respective
          default. HybridSleepMode= is also deprecated, and will now always use
          the 'suspend' disk mode.

        Service Manager:

        * The way services are spawned has been overhauled. Previously, a
          process was forked that shared all of the manager's memory (via
          copy-on-write) while doing all the required setup (e.g.: mount
          namespaces, CGroup configuration, etc.) before exec'ing the target
          executable. This was problematic for various reasons: several glibc
          APIs were called that are not supposed to be used after a fork but
          before an exec, copy-on-write meant that if either process (the
          manager or the child) touched a memory page a copy was triggered, and
          also the memory footprint of the child process was that of the
          manager, but with the memory limits of the service. From this version
          onward, the new process is spawned using CLONE_VM and CLONE_VFORK
          semantics via posix_spawn(3), and it immediately execs a new internal
          binary, systemd-executor, that receives the configuration to apply
          via memfd, and sets up the process before exec'ing the target
          executable. The systemd-executor binary is pinned by file descriptor
          by each manager instance (system and users), and the reference is
          updated on daemon-reexec - it is thus important to reexec all running
          manager instances when the systemd-executor and/or libsystemd*
          libraries are updated on the filesystem.

        * Most of the internal process tracking is being changed to use PIDFDs
          instead of PIDs when the kernel supports it, to improve robustness
          and reliability.

        * A new option SurviveFinalKillSignal= can be used to configure the
          unit to be skipped in the final SIGTERM/SIGKILL spree on shutdown.
          This is part of the required configuration to let a unit's processes
          survive a soft-reboot operation.

        * System extension images (sysext) can now set
          EXTENSION_RELOAD_MANAGER=1 in their extension-release files to
          automatically reload the service manager (PID 1) when
          merging/refreshing/unmerging on boot. Generally, while this can be
          used to ship services in system extension images it's recommended to
          do that via portable services instead.

        * The ExtensionImages= and ExtensionDirectories= options now support
          confexts images/directories.

        * A new option CoredumpReceive= can be set for service and scope units,
          together with Delegate=yes, to make systemd-coredump on the host
          forward core files from processes crashing inside the delegated
          CGroup subtree to systemd-coredump running in the container. This new
          option is by default used by systemd-nspawn containers that use the
          "--boot" switch.

        * A new ConditionSecurity=measured-uki option is now available, to ensure
          a unit can only run when the system has been booted from a measured UKI.

        * MemoryAvailable= now considers physical memory if there are no CGroup
          memory limits set anywhere in the tree.

        * The $USER environment variable is now always set for services, while
          previously it was only set if User= was specified. A new option
          SetLoginEnvironment= is now supported to determine whether to also set
          $HOME, $LOGNAME, and $SHELL.

        * Socket units now support a new pair of
          PollLimitBurst=/PollLimitInterval= options to configure a limit on
          how often polling events on the file descriptors backing this unit
          will be considered within a time window.

        * Scope units can now be created using PIDFDs instead of PIDs to select
          the processes they should include.

        * Sending SIGRTMIN+18 with 0x500 as sigqueue() value will now cause the
          manager to dump the list of currently pending jobs.

        * If the kernel supports MOVE_MOUNT_BENEATH, the systemctl and
          machinectl bind and mount-image verbs will now cause the new mount to
          replace the old mount (if any), instead of overmounting it.

        * Units now have MemoryPeak, MemorySwapPeak, MemorySwapCurrent and
          MemoryZSwapCurrent properties, which respectively contain the values
          of the cgroup v2's memory.peak, memory.swap.peak, memory.swap.current
          and memory.zswap.current properties. This information is also shown in
          "systemctl status" output, if available.

        TPM2 Support + Disk Encryption & Authentication:

        * systemd-cryptenroll now allows specifying a PCR bank and explicit hash
          value in the --tpm2-pcrs= option.

        * systemd-cryptenroll now allows specifying a TPM2 key handle (nv
          index) to be used instead of the default SRK via the new
          --tpm2-seal-key-handle= option.

        * systemd-cryptenroll now allows TPM2 enrollment using only a TPM2
          public key (in TPM2B_PUBLIC format) – without access to the TPM2
          device itself – which enables offline sealing of LUKS images for a
          specific TPM2 chip, as long as the SRK public key is known. Pass the
          public to the tool via the new --tpm2-device-key= switch.

        * systemd-cryptsetup is now installed in /usr/bin/ and is no longer an
          internal-only executable.

        * The TPM2 Storage Root Key will now be set up, if not already present,
          by a new systemd-tpm2-setup.service early boot service. The SRK will
          be stored in PEM format and TPM2_PUBLIC format (the latter is useful
          for systemd-cryptenroll --tpm2-device-key=, as mentioned above) for
          easier access. A new "srk" verb has been added to systemd-analyze to
          allow extracting it on demand if it is already set up.

        * The internal systemd-pcrphase executable has been renamed to
          systemd-pcrextend.

        * The systemd-pcrextend tool gained a new --pcr= switch to override
          which PCR to measure into.

        * systemd-pcrextend now exposes a Varlink interface at
          io.systemd.PCRExtend that can be used to do measurements and event
          logging on demand.

        * TPM measurements are now also written to an event log at
          /run/log/systemd/tpm2-measure.log, using a derivative of the TCG
          Canonical Event Log format. Previously we'd only log them to the
          journal, where they however were subject to rotation and similar.

        * A new component "systemd-pcrlock" has been added that allows managing
          local TPM2 PCR policies for PCRs 0-7 and similar, which are hard to
          predict by the OS vendor because of the inherently local nature of
          what measurements they contain, such as firmware versions of the
          system and extension cards and suchlike. pcrlock can predict PCR
          measurements ahead of time based on various inputs, such as the local
          TPM2 event log, GPT partition tables, PE binaries, UKI kernels, and
          various other things. It can then pre-calculate a TPM2 policy from
          this, which it stores in an TPM2 NV index. TPM2 objects (such as disk
          encryption keys) can be locked against this NV index, so that they
          are locked against a specific combination of system firmware and
          state. Alternatives for each component are supported to allowlist
          multiple kernel versions or boot loader version simultaneously
          without losing access to the disk encryption keys. The tool can also
          be used to analyze and validate the local TPM2 event log.
          systemd-cryptsetup, systemd-cryptenroll, systemd-repart have all been
          updated to support such policies. There's currently no support for
          locking the system's root disk against a pcrlock policy, this will be
          added soon. Moreover, it is currently not possible to combine a
          pcrlock policy with a signed PCR policy. This component is
          experimental and its public interface is subject to change.

        systemd-boot, systemd-stub, ukify, bootctl, kernel-install:

        * bootctl will now show whether the system was booted from a UKI in its
          status output.

        * systemd-boot and systemd-stub now use different project keys in their
          respective SBAT sections, so that they can be revoked individually if
          needed.

        * systemd-boot will no longer load unverified DeviceTree blobs when UEFI
          SecureBoot is enabled. For more details see:
          https://github.com/systemd/systemd/security/advisories/GHSA-6m6p-rjcq-334c

        * systemd-boot gained new hotkeys to reboot and power off the system
          from the boot menu ("B" and "O"). If the "auto-poweroff" and
          "auto-reboot" options in loader.conf are set these entries are also
          shown as menu items (which is useful on devices lacking a regular
          keyboard).

        * systemd-boot gained a new configuration value "menu-disabled" for the
          set-timeout option, to allow completely disabling the boot menu,
          including the hotkey.

        * systemd-boot will now measure the content of loader.conf in TPM2
          PCR 5.

        * systemd-stub will now concatenate the content of all kernel
          command-line addons before measuring them in TPM2 PCR 12, in a single
          measurement, instead of measuring them individually.

        * systemd-stub will now measure and load DeviceTree Blob addons, which
          are searched and loaded following the same model as the existing
          kernel command-line addons.

        * systemd-stub will now ignore unauthenticated kernel command line options
          passed from systemd-boot when running inside Confidential VMs with UEFI
          SecureBoot enabled.

        * systemd-stub will now load a DeviceTree blob even if the firmware did
          not load any beforehand (e.g.: for ACPI systems).

        * ukify is no longer considered experimental, and now ships in /usr/bin/.

        * ukify gained a new verb inspect to describe the sections of a UKI and
          print the contents of the well-known sections.

        * ukify gained a new verb genkey to generate a set of key pairs for
          signing UKIs and their PCR data.

        * The 90-loaderentry kernel-install hook now supports installing device
          trees.

        * kernel-install now supports the --json=, --root=, --image=, and
          --image-policy= options for the inspect verb.

        * kernel-install now supports new list and add-all verbs. The former
          lists all installed kernel images (if those are available in
          /usr/lib/modules/). The latter will install all the kernels it can
          find to the ESP.

        systemd-repart:

        * A new option --copy-from= has been added that synthesizes partition
          definitions from the given image, which are then applied by the
          systemd-repart algorithm.

        * A new option --copy-source= has been added, which can be used to specify
          a directory to which CopyFiles= is considered relative to.

        * New --make-ddi=confext, --make-ddi=sysext, and --make-ddi=portable
          options have been added to make it easier to generate these types of
          DDIs, without having to provide repart.d definitions for them.

        * The dm-verity salt and UUID will now be derived from the specified
          seed value.

        * New VerityDataBlockSizeBytes= and VerityHashBlockSizeBytes= can now be
          configured in repart.d/ configuration files.

        * A new Subvolumes= setting is now supported in repart.d/ configuration
          files, to indicate which directories in the target partition should be
          btrfs subvolumes.

        * A new --tpm2-device-key= option can be used to lock a disk against a
          specific TPM2 public key. This matches the same switch the
          systemd-cryptenroll tool now supports (see above).

        Journal:

        * The journalctl --lines= parameter now accepts +N to show the oldest N
          entries instead of the newest.

        * journald now ensures that sealing happens once per epoch, and sets a
          new compatibility flag to distinguish old journal files that were
          created before this change, for backward compatibility.

        Device Management:

        * udev will now create symlinks to loopback block devices in the
          /dev/disk/by-loop-ref/ directory that are based on the .lo_file_name
          string field selected during allocation. The systemd-dissect tool and
          the util-linux losetup command now supports a complementing new switch
          --loop-ref= for selecting the string. This means a loopback block
          device may now be allocated under a caller-chosen reference and can
          subsequently be referenced without first having to look up the block
          device name the caller ended up with.

        * udev also creates symlinks to loopback block devices in the
          /dev/disk/by-loop-inode/ directory based on the .st_dev/st_ino fields
          of the inode attached to the loopback block device. This means that
          attaching a file to a loopback device will implicitly make a handle
          available to be found via that file's inode information.

        * udevadm info gained support for JSON output via a new --json= flag, and
          for filtering output using the same mechanism that udevadm trigger
          already implements.

        * The predictable network interface naming logic is extended to include
          the SR-IOV-R "representor" information in network interface names.
          This feature was intended for v254, but even though the code was
          merged, the part that actually enabled the feature was forgotten.
          It is now enabled by default and is part of the new "v255" naming
          scheme.

        * A new hwdb/rules file has been added that sets the
          ID_NET_AUTO_LINK_LOCAL_ONLY=1 udev property on all network interfaces
          that should usually only be configured with link-local addressing
          (IPv4LL + IPv6LL), i.e. for PC-to-PC cables ("laplink") or
          Thunderbolt networking. systemd-networkd and NetworkManager (soon)
          will make use of this information to apply an appropriate network
          configuration by default.

        * The ID_NET_DRIVER property on network interfaces is now set
          relatively early in the udev rule set so that other rules may rely on
          its use. This is implemented in a new "net-driver" udev built-in.

        Network Management:

        * The "duid-only" option for DHCPv4 client's ClientIdentifier= setting
          is now dropped, as it never worked, hence it should not be used by
          anyone.

        * The 'prefixstable' ipv6 address generation mode now considers the SSID
          when generating stable addresses, so that a different stable address
          is used when roaming between wireless networks. If you already use
          'prefixstable' addresses with wireless networks, the stable address
          will be changed by the update.

        * The DHCPv4 client gained a RapidCommit option, true by default, which
          enables RFC4039 Rapid Commit behavior to obtain a lease in a
          simplified 2-message exchange instead of the typical 4-message
          exchange, if also supported by the DHCP server.

        * The DHCPv4 client gained new InitialCongestionWindow= and
          InitialAdvertisedReceiveWindow= options for route configurations.

        * The DHCPv4 client gained a new RequestAddress= option that allows
          to send a preferred IP address in the initial DHCPDISCOVER message.

        * The DHCPv4 server and client gained support for IPv6-only mode
          (RFC8925).

        * The SendHostname= and Hostname= options are now available for the
          DHCPv6 client, independently of the DHCPv4= option, so that these
          configuration values can be set independently for each client.

        * The DHCPv4 and DHCPv6 client state can now be queried via D-Bus,
          including lease information.

        * The DHCPv6 client can now be configured to use a custom DUID type.

        * .network files gained a new IPv4ReversePathFilter= setting in the
          [Network] section, to control sysctl's rp_filter setting.

        * .network files gaiend a new HopLimit= setting in the [Route] section,
          to configure a per-route hop limit.

        * .network files gained a new TCPRetransmissionTimeoutSec= setting in
          the [Route] section, to configure a per-route TCP retransmission
          timeout.

        * A new directive NFTSet= provides a method for integrating network
          configuration into firewall rules with NFT sets. The benefit of using
          this setting is that static network configuration or dynamically
          obtained network addresses can be used in firewall rules with the
          indirection of NFT set types.

        * The [IPv6AcceptRA] section supports the following new options:
          UsePREF64=, UseHopLimit=, UseICMP6RateLimit=, and NFTSet=.

        * The [IPv6SendRA] section supports the following new options:
          RetransmitSec=, HopLimit=, HomeAgent=, HomeAgentLifetimeSec=, and
          HomeAgentPreference=.

        * A new [IPv6PREF64Prefix] set of options, containing Prefix= and
          LifetimeSec=, has been introduced to append pref64 options in router
          advertisements (RFC8781).

        * The network generator now configures the interfaces with only
          link-local addressing if "ip=link-local" is specified on the kernel
          command line.

        * The prefix of the configuration files generated by the network
          generator from the kernel command line is now prefixed with '70-',
          to make them have higher precedence over the default configuration
          files.

        * Added a new -Ddefault-network=BOOL meson option, that causes more
          .network files to be installed as enabled by default. These configuration
          files will which match generic setups, e.g. 89-ethernet.network matches
          all Ethernet interfaces and enables both DHCPv4 and DHCPv6 clients.

        * If a ID_NET_MANAGED_BY= udev property is set on a network device and
          it is any other string than "io.systemd.Network" then networkd will
          not manage this device. This may be used to allow multiple network
          management services to run in parallel and assign ownership of
          specific devices explicitly. NetworkManager will soon implement a
          similar logic.

        * .network files gained a new MulticastIGMPVersion= setting in the
          [Network] section, to control sysctl's
          /proc/sys/net/ipv4/conf/INTERFACE/force_igmp_version setting.

        systemctl:

        * systemctl is-failed now checks the system state if no unit is
          specified.

        * systemctl will now automatically soft-reboot if a new root file system
          is found under /run/nextroot/ when a reboot operation is invoked.

        Login management:

        * Wall messages now work even when utmp support is disabled, using
          systemd-logind to query the necessary information.

        * systemd-logind now sends a new PrepareForShutdownWithMetadata D-Bus
          signal before shutdown/reboot/soft-reboot that includes additional
          information compared to the PrepareForShutdown signal. Currently the
          additional information is the type of operation that is about to be
          executed.

        Hibernation & Suspend:

        * The kernel and OS versions will no longer be checked on resume from
          hibernation.

        * Hibernation into swap files backed by btrfs is now supported.
          (Previously this was supported only for other file systems.)

        Other:

        * A new systemd-vmspawn tool has been added, that aims to provide for VMs
          the same interfaces and functionality that systemd-nspawn provides for
          containers. For now it supports QEMU as a backend, and exposes some of
          its options to the user. This component is experimental and its public
          interface is subject to change.

        * "systemd-analyze plot" has gained tooltips on each unit name with
          related-unit information in its svg output, such as Before=,
          Requires=, and similar properties.

        * A new varlinkctl tool has been added to allow interfacing with
          Varlink services, and introspection has been added to all such
          services. This component is experimental and its public interface is
          subject to change.

        * systemd-sysext and systemd-confext now expose a Varlink service
          at io.systemd.sysext.

        * portable services now accept confexts as extensions.

        * systemd-sysupdate now accepts directories in the MatchPattern= option.

        * systemd-run will now output the invocation ID of the launched
          transient unit and its peak memory usage.

        * systemd-analyze, systemd-tmpfiles, systemd-sysusers, systemd-sysctl,
          and systemd-binfmt gained a new --tldr option that can be used instead
          of --cat-config to suppress uninteresting configuration lines, such as
          comments and whitespace.

        * resolvectl gained a new "show-server-state" command that shows
          current statistics of the resolver. This is backed by a new
          DumpStatistics() Varlink method provided by systemd-resolved.

        * systemd-timesyncd will now emit a D-Bus signal when the LinkNTPServers
          property changes.

        * vconsole now supports KEYMAP=@kernel for preserving the kernel keymap
          as-is.

        * seccomp now supports the LoongArch64 architecture.

        * seccomp may now be enabled for services running as a non-root User=
          without NoNewPrivileges=yes.

        * systemd-id128 now supports a new -P option to show only values. The
          combination of -P and --app options is also supported.

        * A new pam_systemd_loadkey.so PAM module is now available, which will
          automatically fetch the passphrase used by cryptsetup to unlock the
          root file system and set it as the PAM authtok. This enables, among
          other things, configuring auto-unlock of the GNOME Keyring / KDE
          Wallet when autologin is configured.

        * Many meson options now use the 'feature' type, which means they
          take enabled/disabled/auto as values.

        * A new meson option -Dconfigfiledir= can be used to change where
          configuration files with default values are installed to.

        * Options and verbs in man pages are now tagged with the version they
          were first introduced in.

        * A new component "systemd-storagetm" has been added, which exposes all
          local block devices as NVMe-TCP devices, fully automatically. It's
          hooked into a new target unit storage-target-mode.target that is
          supposed to be booted into via
          rd.systemd.unit=storage-target-mode.target on the kernel command
          line. This is intended to be used for installers and debugging to
          quickly get access to the local disk. It's inspired by MacOS "target
          disk mode". This component is experimental and its public interface is
          subject to change.

        * A new component "systemd-bsod" has been added, which can show logged
          error messages full screen, if they have a log level of LOG_EMERG log
          level. This component is experimental and its public interface is
          subject to change.

        * The systemd-dissect tool's --with command will now set the
          $SYSTEMD_DISSECT_DEVICE environment variable to the block device it
          operates on for the invoked process.

        * The systemd-mount tool gained a new --tmpfs switch for mounting a new
          'tmpfs' instance. This is useful since it does so via .mount units
          and thus can be executed remotely or in containers.

        * The various tools in systemd that take "verbs" (such as systemctl,
          loginctl, machinectl, …) now will suggest a close verb name in case
          the user specified an unrecognized one.

        * libsystemd now exports a new function sd_id128_get_app_specific()
          that generates "app-specific" 128bit IDs from any ID. It's similar to
          sd_id128_get_machine_app_specific() and
          sd_id128_get_boot_app_specific() but takes the ID to base calculation
          on as input. This new functionality is also exposed in the
          systemd-id128 tool where you can now combine --app= with 'show'.

        * All tools that parse timestamps now can also parse RFC3339 style
          timestamps that include the "T" and Z" characters.

        * New documentation has been added:

          https://systemd.io/FILE_DESCRIPTOR_STORE
          https://systemd.io/TPM2_PCR_MEASUREMENTS
          https://systemd.io/MOUNT_REQUIREMENTS

        * The codebase now recognizes the suffix .confext.raw and .sysext.raw
          as alternative to the .raw suffix generally accepted for DDIs. It is
          recommended to name configuration extensions and system extensions
          with such suffixes, to indicate their purpose in the name.

        * The sd-device API gained a new function
          sd_device_enumerator_add_match_property_required() which allows
          configuring matches on properties that are strictly required. This is
          different from the existing sd_device_enumerator_add_match_property()
          matches of which one needs to apply.

        * The MAC address the veth side of an nspawn container shall get
          assigned may now be controlled via the $SYSTEMD_NSPAWN_NETWORK_MAC
          environment variable.

        * The libiptc dependency is now implemented via dlopen(), so that tools
          such as networkd and nspawn no longer have a hard dependency on the
          shared library when compiled with support for libiptc.

        * New rpm macros have been added: %systemd_user_daemon_reexec does
          daemon-reexec for all user managers, and %systemd_postun_with_reload
          and %systemd_user_postun_with_reload do a reload for system and user
          units on upgrades.

        * coredumpctl now propagates SIGTERM to the debugger process.

        Contributions from: 김인수, Abderrahim Kitouni, Adam Goldman,
        Adam Williamson, Alexandre Peixoto Ferreira, Alex Hudspith,
        Alvin Alvarado, André Paiusco, Antonio Alvarez Feijoo,
        Anton Lundin, Arian van Putten, Arseny Maslennikov, Arthur Shau,
        Balázs Úr, beh_10257, Benjamin Peterson, Bertrand Jacquin,
        Brian Norris, Charles Lee, Cheng-Chia Tseng, Chris Patterson,
        Christian Hergert, Christian Hesse, Christian Kirbach,
        Clayton Craft, commondservice, cunshunxia, Curtis Klein, cvlc12,
        Daan De Meyer, Daniele Medri, Daniel P. Berrangé, Daniel Rusek,
        Daniel Thompson, Dan Nicholson, Dan Streetman, David Rheinsberg,
        David Santamaría Rogado, David Tardon, dependabot[bot],
        Diego Viola, Dmitry V. Levin, Emanuele Giuseppe Esposito,
        Emil Renner Berthing, Emil Velikov, Etienne Dechamps, Fabian Vogt,
        felixdoerre, Felix Dörre, Florian Schmaus, Franck Bui,
        Frantisek Sumsal, G2-Games, Gioele Barabucci, Hugo Carvalho,
        huyubiao, Iago López Galeiras, IllusionMan1212, Jade Lovelace,
        janana, Jan Janssen, Jan Kuparinen, Jan Macku, Jeremy Fleischman,
        Jin Liu, jjimbo137, Joerg Behrmann, Johannes Segitz, Jordan Rome,
        Jordan Williams, Julien Malka, Juno Computers, Khem Raj, khm,
        Kingbom Dou, Kiran Vemula, Krzesimir Nowak, Laszlo Gombos,
        Lennart Poettering, linuxlion, Luca Boccassi, Lucas Adriano Salles,
        Lukas, Lukáš Nykrýn, Maanya Goenka, Maarten, Malte Poll,
        Marc Pervaz Boocha, Martin Beneš, Martin Joerg, Martin Wilck,
        Mathieu Tortuyaux, Matthias Schiffer, Maxim Mikityanskiy,
        Max Kellermann, Michael A Cassaniti, Michael Biebl, Michael Kuhn,
        Michael Vasseur, Michal Koutný, Michal Sekletár, Mike Yuan,
        Milton D. Miller II, mordner, msizanoen, NAHO, Nandakumar Raghavan,
        Neil Wilson, Nick Rosbrook, Nils K, NRK, Oğuz Ersen,
        Omojola Joshua, onenowy, Paul Meyer, Paymon MARANDI, pelaufer,
        Peter Hutterer, PhylLu, Pierre GRASSER, Piotr Drąg, Priit Laes,
        Rahil Bhimjiani, Raito Bezarius, Raul Cheleguini, Reto Schneider,
        Richard Maw, Robby Red, RoepLuke, Roland Hieber, Roland Singer,
        Ronan Pigott, Sam James, Sam Leonard, Sergey A, Susant Sahani,
        Sven Joachim, Tad Fisher, Takashi Sakamoto, Thorsten Kukuk, Tj,
        Tomasz Świątek, Topi Miettinen, Valentin David,
        Valentin Lefebvre, Victor Westerhuis, Vincent Haupert,
        Vishal Chillara Srinivas, Vito Caputo, Warren, Weblate,
        Xiaotian Wu, xinpeng wang, Yaron Shahrabani, Yo-Jung Lin,
        Yu Watanabe, Zbigniew Jędrzejewski-Szmek, zeroskyx,
        Дамјан Георгиевски, наб

        — Edinburgh, 2023-12-06

CHANGES WITH 254:

        Announcements of Future Feature Removals and Incompatible Changes:

        * The next release (v255) will remove support for split-usr (/usr/
          mounted separately during late boot, instead of being mounted by the
          initrd before switching to the rootfs) and unmerged-usr (parallel
          directories /bin/ and /usr/bin/, /lib/ and /usr/lib/, …). For more
          details, see:
          https://lists.freedesktop.org/archives/systemd-devel/2022-September/048352.html

        * We intend to remove cgroup v1 support from a systemd release after
          the end of 2023. If you run services that make explicit use of
          cgroup v1 features (i.e. the "legacy hierarchy" with separate
          hierarchies for each controller), please implement compatibility with
          cgroup v2 (i.e. the "unified hierarchy") sooner rather than later.
          Most of Linux userspace has been ported over already.

        * Support for System V service scripts is now deprecated and will be
          removed in a future release. Please make sure to update your software
          *now* to include a native systemd unit file instead of a legacy
          System V script to retain compatibility with future systemd releases.

        * Support for the SystemdOptions EFI variable is deprecated.
          'bootctl systemd-efi-options' will emit a warning when used. It seems
          that this feature is little-used and it is better to use alternative
          approaches like credentials and confexts. The plan is to drop support
          altogether at a later point, but this might be revisited based on
          user feedback.

        * EnvironmentFile= now treats the line following a comment line
          trailing with escape as a non comment line. For details, see:
          https://github.com/systemd/systemd/issues/27975

        * PrivateNetwork=yes and NetworkNamespacePath= now imply
          PrivateMounts=yes unless PrivateMounts=no is explicitly specified.

        * Behaviour of sandboxing options for the per-user service manager
          units has changed. They now imply PrivateUsers=yes, which means user
          namespaces will be implicitly enabled when a sandboxing option is
          enabled in a user unit. Enabling user namespaces has the drawback
          that system users will no longer be visible (and processes/files will
          appear as owned by 'nobody') in the user unit.

          By definition a sandboxed user unit should run with reduced
          privileges, so impact should be small. This will remove a great
          source of confusion that has been reported by users over the years,
          due to how these options require an extra setting to be manually
          enabled when used in the per-user service manager, which is not
          needed in the system service manager. For more details, see:
          https://lists.freedesktop.org/archives/systemd-devel/2022-December/048682.html

        * systemd-run's switch --expand-environment= which currently is disabled
          by default when combined with --scope, will be changed in a future
          release to be enabled by default.

        Security Relevant Changes:

        * pam_systemd will now by default pass the CAP_WAKE_ALARM ambient
          process capability to invoked session processes of regular users on
          local seats (as well as to systemd --user), unless configured
          otherwise via data from JSON user records, or via the PAM module's
          parameter list. This is useful in order allow desktop tools such as
          GNOME's Alarm Clock application to set a timer for
          CLOCK_REALTIME_ALARM that wakes up the system when it elapses. A
          per-user service unit file may thus use AmbientCapability= to pass
          the capability to invoked processes. Note that this capability is
          relatively narrow in focus (in particular compared to other process
          capabilities such as CAP_SYS_ADMIN) and we already — by default —
          permit more impactful operations such as system suspend to local
          users.

        Service Manager:

        * Memory limits that apply while the unit is activating are now
          supported. Previously IO and CPU settings were already supported via
          StartupCPUWeight= and similar. The same logic has been added for the
          various manager and unit memory settings (DefaultStartupMemoryLow=,
          StartupMemoryLow=, StartupMemoryHigh=, StartupMemoryMax=,
          StartupMemorySwapMax=, StartupMemoryZSwapMax=).

        * The service manager gained support for enqueuing POSIX signals to
          services that carry an additional integer value, exposing the
          sigqueue() system call. This is accessible via new D-Bus calls
          org.freedesktop.systemd1.Manager.QueueSignalUnit() and
          org.freedesktop.systemd1.Unit.QueueSignal(), as well as in systemctl
          via the new --kill-value= option.

        * systemctl gained a new "list-paths" verb, which shows all currently
          active .path units, similarly to how "systemctl list-timers" shows
          active timers, and "systemctl list-sockets" shows active sockets.

        * systemctl gained a new --when= switch which is honoured by the various
          forms of shutdown (i.e. reboot, kexec, poweroff, halt) and allows
          scheduling these operations by time, similar in fashion to how this
          has been supported by SysV shutdown.

        * If MemoryDenyWriteExecute= is enabled for a service and the kernel
          supports the new PR_SET_MDWE prctl() call, it is used instead of the
          seccomp()-based system call filter to achieve the same effect.

        * A new set of kernel command line options is now understood:
          systemd.tty.term.<name>=, systemd.tty.rows.<name>=,
          systemd.tty.columns.<name>= allow configuring the TTY type and
          dimensions for the tty specified via <name>. When systemd invokes a
          service on a tty (via TTYName=) it will look for these and configure
          the TTY accordingly. This is particularly useful in VM environments
          to propagate host terminal settings into the appropriate TTYs of the
          guest.

        * A new RootEphemeral= setting is now understood in service units. It
          takes a boolean argument. If enabled for services that use RootImage=
          or RootDirectory= an ephemeral copy of the disk image or directory
          tree is made when the service is started. It is removed automatically
          when the service is stopped. That ephemeral copy is made using
          btrfs/xfs reflinks or btrfs snapshots, if available.

        * The service activation logic gained new settings RestartSteps= and
          RestartMaxDelaySec= which allow exponentially-growing restart
          intervals for Restart=.

        * The service activation logic gained a new setting RestartMode= which
          can be set to 'direct' to skip the inactive/failed states when
          restarting, so that dependent units are not notified until the service
          converges to a final (successful or failed) state. For example, this
          means that OnSuccess=/OnFailure= units will not be triggered until the
          service state has converged.

        * PID 1 will now automatically load the virtio_console kernel module
          during early initialization if running in a suitable VM. This is done
          so that early-boot logging can be written to the console if available.

        * Similarly, virtio-vsock support is loaded early in suitable VM
          environments. PID 1 will send sd_notify() notifications via AF_VSOCK
          to the VMM if configured, thus loading this early is beneficial.

        * A new verb "fdstore" has been added to systemd-analyze to show the
          current contents of the file descriptor store of a unit. This is
          backed by a new D-Bus call DumpUnitFileDescriptorStore() provided by
          the service manager.

        * The service manager will now set a new $FDSTORE environment variable
          when invoking processes for services that have the file descriptor
          store enabled.

        * A new service option FileDescriptorStorePreserve= has been added that
          allows tuning the lifecycle of the per-service file descriptor store.
          If set to "yes", the entries in the fd store are retained even after
          the service has been fully stopped.

        * The "systemctl clean" command may now be used to clear the fdstore of
          a service.

        * Unit *.preset files gained a new directive "ignore", in addition to
          the existing "enable" and "disable". As the name suggests, matching
          units are left unchanged, i.e. neither enabled nor disabled.

        * Service units gained a new setting DelegateSubgroup=. It takes the
          name of a sub-cgroup to place any processes the service manager forks
          off in. Previously, the service manager would place all service
          processes directly in the top-level cgroup it created for the
          service. This usually meant that main process in a service with
          delegation enabled would first have to create a subgroup and move
          itself down into it, in order to not conflict with the "no processes
          in inner cgroups" rule of cgroup v2. With this option, this step is
          now handled by PID 1.

        * The service manager will now look for .upholds/ directories,
          similarly to the existing support for .wants/ and .requires/
          directories. Symlinks in this directory result in Upholds=
          dependencies.

          The [Install] section of unit files gained support for a new
          UpheldBy= directive to generate .upholds/ symlinks automatically when
          a unit is enabled.

        * The service manager now supports a new kernel command line option
          systemd.default_device_timeout_sec=, which may be used to override
          the default timeout for .device units.

        * A new "soft-reboot" mechanism has been added to the service manager.
          A "soft reboot" is similar to a regular reboot, except that it
          affects userspace only: the service manager shuts down any running
          services and other units, then optionally switches into a new root
          file system (mounted to /run/nextroot/), and then passes control to a
          systemd instance in the new file system which then starts the system
          up again. The kernel is not rebooted and neither is the hardware,
          firmware or boot loader. This provides a fast, lightweight mechanism
          to quickly reset or update userspace, without the latency that a full
          system reset involves. Moreover, open file descriptors may be passed
          across the soft reboot into the new system where they will be passed
          back to the originating services. This allows pinning resources
          across the reboot, thus minimizing grey-out time further. This new
          reboot mechanism is accessible via the new "systemctl soft-reboot"
          command.

        * Services using RootDirectory= or RootImage= will now have read-only
          access to a copy of the host's os-release file under
          /run/host/os-release, which will be kept up-to-date on 'soft-reboot'.
          This was already the case for Portable Services, and the feature has
          now been extended to all services that do not run off the host's
          root filesystem.

        * A new service setting MemoryKSM= has been added to enable kernel
          same-page merging individually for services.

        * A new service setting ImportCredentials= has been added that augments
          LoadCredential= and LoadCredentialEncrypted= and searches for
          credentials to import from the system, and supports globbing.

        * A new job mode "restart-dependencies" has been added to the service
          manager (exposed via systemctl --job-mode=). It is only valid when
          used with "start" jobs, and has the effect that the "start" job will
          be propagated as "restart" jobs to currently running units that have
          a BindsTo= or Requires= dependency on the started unit.

        * A new verb "whoami" has been added to "systemctl" which determines as
          part of which unit the command is being invoked. It writes the unit
          name to standard output. If one or more PIDs are specified reports
          the unit names the processes referenced by the PIDs belong to.

        * The system and service credential logic has been improved: there's
          now a clearly defined place where system provisioning tools running
          in the initrd can place credentials that will be imported into the
          system's set of credentials during the initrd → host transition: the
          /run/credentials/@initrd/ directory. Once the credentials placed
          there are imported into the system credential set they are deleted
          from this directory, and the directory itself is deleted afterwards
          too.

        * A new kernel command line option systemd.set_credential_binary= has
          been added, that is similar to the pre-existing
          systemd.set_credential= but accepts arbitrary binary credential data,
          encoded in Base64. Note that the kernel command line is not a
          recommend way to transfer credentials into a system, since it is
          world-readable from userspace.

        * The default machine ID to use may now be configured via the
          system.machine_id system credential. It will only be used if no
          machine ID was set yet on the host.

        * On Linux kernel 6.4 and newer system and service credentials will now
          be placed in a tmpfs instance that has the "noswap" mount option
          set. Previously, a "ramfs" instance was used. By switching to tmpfs
          ACL support and overall size limits can now be enforced, without
          compromising on security, as the memory is never paged out either
          way.

        * The service manager now can detect when it is running in a
          'Confidential Virtual Machine', and a corresponding 'cvm' value is now
          accepted by ConditionSecurity= for units that want to conditionalize
          themselves on this. systemd-detect-virt gained new 'cvm' and
          '--list-cvm' switches to respectively perform the detection or list
          all known flavours of confidential VM, depending on the vendor. The
          manager will publish a 'ConfidentialVirtualization' D-Bus property,
          and will also set a SYSTEMD_CONFIDENTIAL_VIRTUALIZATION= environment
          variable for unit generators. Finally, udev rules can match on a new
          'cvm' key that will be set when in a confidential VM.
          Additionally, when running in a 'Confidential Virtual Machine', SMBIOS
          strings and QEMU's fw_cfg protocol will not be used to import
          credentials and kernel command line parameters by the system manager,
          systemd-boot and systemd-stub, because the hypervisor is considered
          untrusted in this particular setting.

        Journal:

        * The sd-journal API gained a new call sd_journal_get_seqnum() to
          retrieve the current log record's sequence number and sequence number
          ID, which allows applications to order records the same way as
          journal does internally. The sequence number is now also exported in
          the JSON and "export" output of the journal.

        * journalctl gained a new switch --truncate-newline. If specified
          multi-line log records will be truncated at the first newline,
          i.e. only the first line of each log message will be shown.

        * systemd-journal-upload gained support for --namespace=, similar to
          the switch of the same name of journalctl.

        systemd-repart:

        * systemd-repart's drop-in files gained a new ExcludeFiles= option which
          may be used to exclude certain files from the effect of CopyFiles=.

        * systemd-repart's Verity support now implements the Minimize= setting
          to minimize the size of the resulting partition.

        * systemd-repart gained a new --offline= switch, which may be used to
          control whether images shall be built "online" or "offline",
          i.e. whether to make use of kernel facilities such as loopback block
          devices and device mapper or not.

        * If systemd-repart is told to populate a newly created ESP or XBOOTLDR
          partition with some files, it will now default to VFAT rather than
          ext4.

        * systemd-repart gained a new --architecture= switch. If specified, the
          per-architecture GPT partition types (i.e. the root and /usr/
          partitions) configured in the partition drop-in files are
          automatically adjusted to match the specified CPU architecture, in
          order to simplify cross-architecture DDI building.

        * systemd-repart will now default to a minimum size of 300MB for XFS
          filesystems if no size parameter is specified. This matches what the
          XFS tools (xfsprogs) can support.

        systemd-boot, systemd-stub, ukify, bootctl, kernel-install:

        * gnu-efi is no longer required to build systemd-boot and systemd-stub.
          Instead, pyelftools is now needed, and it will be used to perform the
          ELF -> PE relocations at build time.

        * bootctl gained a new switch --print-root-device/-R that prints the
          block device the root file system is backed by. If specified twice,
          it returns the whole disk block device (as opposed to partition block
          device) the root file system is on. It's useful for invocations such
          as "cfdisk $(bootctl -RR)" to quickly show the partition table of the
          running OS.

        * systemd-stub will now look for the SMBIOS Type 1 field
          "io.systemd.stub.kernel-cmdline-extra" and append its value to the
          kernel command line it invokes. This is useful for VMMs such as qemu
          to pass additional kernel command lines into the system even when
          booting via full UEFI. The contents of the field are measured into
          TPM PCR 12.

        * The KERNEL_INSTALL_LAYOUT= setting for kernel-install gained a new
          value "auto". With this value, a kernel will be automatically
          analyzed, and if it qualifies as UKI, it will be installed as if the
          setting was to set to "uki", otherwise as "bls".

        * systemd-stub can now optionally load UEFI PE "add-on" images that may
          contain additional kernel command line information. These "add-ons"
          superficially look like a regular UEFI executable, and are expected
          to be signed via SecureBoot/shim. However, they do not actually
          contain code, but instead a subset of the PE sections that UKIs
          support. They are supposed to provide a way to extend UKIs with
          additional resources in a secure and authenticated way. Currently,
          only the .cmdline PE section may be used in add-ons, in which case
          any specified string is appended to the command line embedded into
          the UKI itself. A new 'addon<EFI-ARCH>.efi.stub' is now provided that
          can be used to trivially create addons, via 'ukify' or 'objcopy'. In
          the future we expect other sections to be made extensible like this as
          well.

        * ukify has been updated to allow building these UEFI PE "add-on"
          images, using the new 'addon<EFI-ARCH>.efi.stub'.

        * ukify now accepts SBAT information to place in the .sbat PE section
          of UKIs and addons. If a UKI is built the SBAT information from the
          inner kernel is merged with any SBAT information associated with
          systemd-stub and the SBAT data specified on the ukify command line.

        * The kernel-install script has been rewritten in C, and reuses much of
          the infrastructure of existing tools such as bootctl. It also gained
          --esp-path= and --boot-path= options to override the path to the ESP,
          and the $BOOT partition. Options --make-entry-directory= and
          --entry-token= have been added as well, similar to bootctl's options
          of the same name.

        * A new kernel-install plugin 60-ukify has been added which will
          combine kernel/initrd locally into a UKI and optionally sign them
          with a local key. This may be used to switch to UKI mode even on
          systems where a local kernel or initrd is used. (Typically UKIs are
          built and signed by the vendor.)

        * The ukify tool now supports "pesign" in addition to the pre-existing
          "sbsign" for signing UKIs.

        * systemd-measure and systemd-stub now look for the .uname PE section
          that should contain the kernel's "uname -r" string.

        * systemd-measure and ukify now calculate expected PCR hashes for a UKI
          "offline", i.e. without access to a TPM (physical or
          software-emulated).

        Memory Pressure & Control:

        * The sd-event API gained new calls sd_event_add_memory_pressure(),
          sd_event_source_set_memory_pressure_type(),
          sd_event_source_set_memory_pressure_period() to create and configure
          an event source that is called whenever the OS signals memory
          pressure. Another call sd_event_trim_memory() is provided that
          compacts the process' memory use by releasing allocated but unused
          malloc() memory back to the kernel. Services can also provide their
          own custom callback to do memory trimming. This should improve system
          behaviour under memory pressure, as on Linux traditionally provided
          no mechanism to return process memory back to the kernel if the
          kernel was under memory pressure. This makes use of the kernel's PSI
          interface. Most long-running services in systemd have been hooked up
          with this, and in particular systems with low memory should benefit
          from this.

        * Service units gained new settings MemoryPressureWatch= and
          MemoryPressureThresholdSec= to configure the PSI memory pressure
          logic individually. If these options are used, the
          $MEMORY_PRESSURE_WATCH and $MEMORY_PRESSURE_WRITE environment
          variables will be set for the invoked processes to inform them about
          the requested memory pressure behaviour. (This is used by the
          aforementioned sd-events API additions, if set.)

        * systemd-analyze gained a new "malloc" verb that shows the output
          generated by glibc's malloc_info() on services that support it. Right
          now, only the service manager has been updated accordingly. This
          call requires privileges.

        User & Session Management:

        * The sd-login API gained a new call sd_session_get_username() to
          return the user name of the owner of a login session. It also gained
          a new call sd_session_get_start_time() to retrieve the time the login
          session started. A new call sd_session_get_leader() has been added to
          return the PID of the "leader" process of a session. A new call
          sd_uid_get_login_time() returns the time since the specified user has
          most recently been continuously logged in with at least one session.

        * JSON user records gained a new set of fields capabilityAmbientSet and
          capabilityBoundingSet which contain a list of POSIX capabilities to
          set for the logged in users in the ambient and bounding sets,
          respectively. homectl gained the ability to configure these two sets
          for users via --capability-bounding-set=/--capability-ambient-set=.

        * pam_systemd learnt two new module options
          default-capability-bounding-set= and default-capability-ambient-set=,
          which configure the default bounding sets for users as they are
          logging in, if the JSON user record doesn't specify this explicitly
          (see above). The built-in default for the ambient set now contains
          the CAP_WAKE_ALARM, thus allowing regular users who may log in
          locally to resume from a system suspend via a timer.

        * The Session D-Bus objects systemd-logind gained a new SetTTY() method
          call to update the TTY of a session after it has been allocated. This
          is useful for SSH sessions which are typically allocated first, and
          for which a TTY is added later.

        * The sd-login API gained a new call sd_pid_notifyf_with_fds() which
          combines the various other sd_pid_notify() flavours into one: takes a
          format string, an overriding PID, and a set of file descriptors to
          send. It also gained a new call sd_pid_notify_barrier() call which is
          equivalent to sd_notify_barrier() but allows the originating PID to
          be specified.

        * "loginctl list-users" and "loginctl list-sessions" will now show the
          state of each logged in user/session in their tabular output. It will
          also show the current idle state of sessions.

        DDIs:

        * systemd-dissect will now show the intended CPU architecture of an
          inspected DDI.

        * systemd-dissect will now install itself as mount helper for the "ddi"
          pseudo-file system type. This means you may now mount DDIs directly
          via /bin/mount or /etc/fstab, making full use of embedded Verity
          information and all other DDI features.

          Example: mount -t ddi myimage.raw /some/where

        * The systemd-dissect tool gained the new switches --attach/--detach to
          attach/detach a DDI to a loopback block device without mounting it.
          It will automatically derive the right sector size from the image
          and set up Verity and similar, but not mount the file systems in it.

        * When systemd-gpt-auto-generator or the DDI mounting logic mount an
          ESP or XBOOTLDR partition the MS_NOSYMFOLLOW mount option is now
          implied. Given that these file systems are typically untrusted, this
          should make mounting them automatically have less of a security
          impact.

        * All tools that parse DDIs (such as systemd-nspawn, systemd-dissect,
          systemd-tmpfiles, …) now understand a new switch --image-policy= which
          takes a string encoding image dissection policy. With this mechanism
          automatic discovery and use of specific partition types and the
          cryptographic requirements on the partitions (Verity, LUKS, …) can be
          restricted, permitting better control of the exposed attack surfaces
          when mounting disk images. systemd-gpt-auto-generator will honour such
          an image policy too, configurable via the systemd.image_policy= kernel
          command line option. Unit files gained the RootImagePolicy=,
          MountImagePolicy= and ExtensionImagePolicy= to configure the same for
          disk images a service runs off.

        * systemd-analyze gained a new verb "image-policy" to validate and
          parse image policy strings.

        * systemd-dissect gained support for a new --validate switch to
          superficially validate DDI structure, and check whether a specific
          image policy allows the DDI.

        * systemd-dissect gained support for a new --mtree-hash switch to
          optionally disable calculating mtree hashes, which can be slow on
          large images.

        * systemd-dissect --copy-to, --copy-from, --list and --mtree switches
          are now able to operate on directories too, other than images.

        Network Management:

        * networkd's GENEVE support as gained a new .network option
          InheritInnerProtocol=.

        * The [Tunnel] section in .netdev files has gained a new setting
          IgnoreDontFragment for controlling the IPv4 "DF" flag of datagrams.

        * A new global IPv6PrivacyExtensions= setting has been added that
          selects the default value of the per-network setting of the same
          name.

        * The predictable network interface naming logic was extended to
          include SR-IOV-R "representor" information in network interface
          names. Unfortunately, this feature was not enabled by default and can
          only be enabled at compilation time by setting
          -Ddefault-net-naming-scheme=v254.

        * The DHCPv4 + DHCPv6 + IPv6 RA logic in networkd gained support for
          the RFC8910 captive portal option.

        Device Management:

        * udevadm gained the new "verify" verb for validating udev rules files
          offline.

        * udev gained a new tool "iocost" that can be used to configure QoS IO
          cost data based on hwdb information onto suitable block devices. Also
          see https://github.com/iocost-benchmark/iocost-benchmarks.

        TPM2 Support + Disk Encryption & Authentication:

        * systemd-cryptenroll/systemd-cryptsetup will now install a TPM2 SRK
          ("Storage Root Key") as first step in the TPM2, and then use that
          for binding FDE to, if TPM2 support is used. This matches
          recommendations of TCG (see
          https://trustedcomputinggroup.org/wp-content/uploads/TCG-TPM-v2.0-Provisioning-Guidance-Published-v1r1.pdf)

        * systemd-cryptenroll and other tools that take TPM2 PCR parameters now
          understand textual identifiers for these PCRs.

        * systemd-veritysetup + /etc/veritytab gained support for a series of
          new options: hash-offset=, superblock=, format=, data-block-size=,
          hash-block-size=, data-blocks=, salt=, uuid=, hash=, fec-device=,
          fec-offset=, fec-roots= to configure various aspects of a Verity
          volume.

        * systemd-cryptsetup + /etc/crypttab gained support for a new
          veracrypt-pim= option for setting the Personal Iteration Multiplier
          of veracrypt volumes.

        * systemd-integritysetup + /etc/integritytab gained support for a new
          mode= setting for controlling the dm-integrity mode (journal, bitmap,
          direct) for the volume.

        * systemd-analyze gained a new verb "pcrs" that shows the known TPM PCR
          registers, their symbolic names and current values.

        systemd-tmpfiles:

        * The ACL support in tmpfiles.d/ has been updated: if an uppercase "X"
          access right is specified this is equivalent to "x" but only if the
          inode in question already has the executable bit set for at least
          some user/group. Otherwise the "x" bit will be turned off.

        * tmpfiles.d/'s C line type now understands a new modifier "+": a line
          with C+ will result in a "merge" copy, i.e. all files of the source
          tree are copied into the target tree, even if that tree already
          exists, resulting in a combined tree of files already present in the
          target tree and those copied in.

        * systemd-tmpfiles gained a new --graceful switch. If specified lines
          with unknown users/groups will silently be skipped.

        systemd-notify:

        * systemd-notify gained two new options --fd= and --fdname= for sending
          arbitrary file descriptors to the service manager (while specifying an
          explicit name for it).

        * systemd-notify gained a new --exec switch, which makes it execute the
          specified command line after sending the requested messages. This is
          useful for sending out READY=1 first, and then continuing invocation
          without changing process ID, so that the tool can be nicely used
          within an ExecStart= line of a unit file that uses Type=notify.

        sd-event + sd-bus APIs:

        * The sd-event API gained a new call sd_event_source_leave_ratelimit()
          which may be used to explicitly end a rate-limit state an event
          source might be in, resetting all rate limiting counters.

        * When the sd-bus library is used to make connections to AF_UNIX D-Bus
          sockets, it will now encode the "description" set via
          sd_bus_set_description() into the source socket address. It will also
          look for this information when accepting a connection. This is useful
          to track individual D-Bus connections on a D-Bus broker for debug
          purposes.

        systemd-resolved:

        * systemd-resolved gained a new resolved.conf setting
          StateRetentionSec= which may be used to retain cached DNS records
          even after their nominal TTL, and use them in case upstream DNS
          servers cannot be reached. This can be used to make name resolution
          more resilient in case of network problems.

        * resolvectl gained a new verb "show-cache" to show the current cache
          contents of systemd-resolved. This verb communicates with the
          systemd-resolved daemon and requires privileges.

        Other:

        * Meson >= 0.60.0 is now required to build systemd.

        * The default keymap to apply may now be chosen at build-time via the
          new -Ddefault-keymap= meson option.

        * Most of systemd's long-running services now have a generic handler of
          the SIGRTMIN+18 signal handler which executes various operations
          depending on the sigqueue() parameter sent along. For example, values
          0x100…0x107 allow changing the maximum log level of such
          services. 0x200…0x203 allow changing the log target of such
          services. 0x300 make the services trim their memory similarly to the
          automatic PSI-triggered action, see above. 0x301 make the services
          output their malloc_info() data to the logs.

        * machinectl gained new "edit" and "cat" verbs for editing .nspawn
          files, inspired by systemctl's verbs of the same name which edit unit
          files. Similarly, networkctl gained the same verbs for editing
          .network, .netdev, .link files.

        * A new syscall filter group "@sandbox" has been added that contains
          syscalls for sandboxing system calls such as those for seccomp and
          Landlock.

        * New documentation has been added:

          https://systemd.io/COREDUMP
          https://systemd.io/MEMORY_PRESSURE
          smbios-type-11(7)

        * systemd-firstboot gained a new --reset option. If specified, the
          settings in /etc/ it knows how to initialize are reset.

        * systemd-sysext is now a multi-call binary and is also installed under
          the systemd-confext alias name (via a symlink). When invoked that way
          it will operate on /etc/ instead of /usr/ + /opt/. It thus becomes a
          powerful, atomic, secure configuration management of sorts, that
          locally can merge configuration from multiple confext configuration
          images into a single immutable tree.

        * The --network-macvlan=, --network-ipvlan=, --network-interface=
          switches of systemd-nspawn may now optionally take the intended
          network interface inside the container.

        * All our programs will now send an sd_notify() message with their exit
          status in the EXIT_STATUS= field when exiting, using the usual
          protocol, including PID 1. This is useful for VMMs and container
          managers to collect an exit status from a system as it shuts down, as
          set via "systemctl exit …". This is particularly useful in test cases
          and similar, as invocations via a VM can now nicely propagate an exit
          status to the host, similar to local processes.

        * systemd-run gained a new switch --expand-environment=no to disable
          server-side environment variable expansion in specified command
          lines. Expansion defaults to enabled for all execution types except
          --scope, where it defaults to off (and prints a warning) for backward
          compatibility reasons. --scope will be flipped to enabled by default
          too in a future release. If you are using --scope and passing a '$'
          character in the payload you should start explicitly using
          --expand-environment=yes/no according to the use case.

        * The systemd-system-update-generator has been updated to also look for
          the special flag file /etc/system-update in addition to the existing
          support for /system-update to decide whether to enter system update
          mode.

        * The /dev/hugepages/ file system is now mounted with nosuid + nodev
          mount options by default.

        * systemd-fstab-generator now understands two new kernel command line
          options systemd.mount-extra= and systemd.swap-extra=, which configure
          additional mounts or swaps in a format similar to /etc/fstab. 'fsck'
          will be ran on these block devices, like it already happens for
          'root='. It also now supports the new fstab.extra and
          fstab.extra.initrd credentials that may contain additional /etc/fstab
          lines to apply at boot.

        * systemd-getty-generator now understands two new credentials
          getty.ttys.container and getty.ttys.serial. These credentials may
          contain a list of TTY devices – one per line – to instantiate
          container-getty@.service and serial-getty@.service on.

        * The getty/serial-getty/container-getty units now import the 'agetty.*'
          and 'login.*' credentials, which are consumed by the 'login' and
          'agetty' programs starting from util-linux v2.40.

        * systemd-sysupdate's sysupdate.d/ drop-ins gained a new setting
          PathRelativeTo=, which can be set to "esp", "xbootldr", "boot", in
          which case the Path= setting is taken relative to the ESP or XBOOTLDR
          partitions, rather than the system's root directory /. The relevant
          directories are automatically discovered.

        * The systemd-ac-power tool gained a new switch --low, which reports
          whether the battery charge is considered "low", similar to how the
          s2h suspend logic checks this state to decide whether to enter system
          suspend or hibernation.

        * The /etc/os-release file can now have two new optional fields
          VENDOR_NAME= and VENDOR_URL= to carry information about the vendor of
          the OS.

        * When the system hibernates, information about the device and offset
          used is now written to a non-volatile EFI variable. On next boot the
          system will attempt to resume from the location indicated in this EFI
          variable. This should make hibernation a lot more robust, while
          requiring no manual configuration of the resume location.

        * The $XDG_STATE_HOME environment variable (added in more recent
          versions of the XDG basedir specification) is now honoured to
          implement the StateDirectory= setting in user services.

        * A new component "systemd-battery-check" has been added. It may run
          during early boot (usually in the initrd), and checks the battery
          charge level of the system. In case the charge level is very low the
          user is notified (graphically via Plymouth – if available – as well
          as in text form on the console), and the system is turned off after a
          10s delay. The feature can be disabled by passing
          systemd.battery_check=0 through the kernel command line.

        * The 'passwdqc' library is now supported as an alternative to the
          'pwquality' library and can be selected at build time.

        Contributions from: 김인수, 07416, Addison Snelling, Adrian Vovk,
        Aidan Dang, Alexander Krabler, Alfred Klomp, Anatoli Babenia,
        Andrei Stepanov, Andrew Baxter, Antonio Alvarez Feijoo,
        Arian van Putten, Arthur Shau, A S Alam,
        Asier Sarasua Garmendia, Balló György, Bastien Nocera,
        Benjamin Herrenschmidt, Benjamin Raison, Bill Peterson,
        Brad Fitzpatrick, Brett Holman, bri, Chen Qi, Chitoku,
        Christian Hesse, Christoph Anton Mitterer, Christopher Gurnee,
        Colin Walters, Cornelius Hoffmann, Cristian Rodríguez, cunshunxia,
        cvlc12, Cyril Roelandt, Daan De Meyer, Daniele Medri,
        Daniel P. Berrangé, Daniel Rusek, Dan Streetman, David Edmundson,
        David Schroeder, David Tardon, dependabot[bot],
        Dimitri John Ledkov, Dmitrii Fomchenkov, Dmitry V. Levin, dmkUK,
        Dominique Martinet, don bright, drosdeck, Edson Juliano Drosdeck,
        Egor Ignatov, EinBaum, Emanuele Giuseppe Esposito, Eric Curtin,
        Erik Sjölund, Evgeny Vereshchagin, Florian Klink, Franck Bui,
        François Rigault, Fran Diéguez, Franklin Yu, Frantisek Sumsal,
        Fuminobu TAKEYAMA, Gaël PORTAY, Gerd Hoffmann, Gertalitec,
        Gibeom Gwon, Gustavo Noronha Silva, Hannu Lounento,
        Hans de Goede, Haochen Tong, HATAYAMA Daisuke, Henrik Holst,
        Hoe Hao Cheng, Igor Tsiglyar, Ivan Vecera, James Hilliard,
        Jan Engelhardt, Jan Janssen, Jan Luebbe, Jan Macku, Janne Sirén,
        jcg, Jeidnx, Joan Bruguera, Joerg Behrmann, jonathanmetzman,
        Jordan Rome, Josef Miegl, Joshua Goins, Joyce, Joyce Brum,
        Juno Computers, Kai Lueke, Kevin P. Fleming, Kiran Vemula, Klaus,
        Klaus Zipfel, Lawrence Thorpe, Lennart Poettering, licunlong,
        Lily Foster, Luca Boccassi, Ludwig Nussel, Luna Jernberg,
        maanyagoenka, Maanya Goenka, Maksim Kliazovich, Malte Poll,
        Marko Korhonen, Masatake YAMATO, Mateusz Poliwczak, Matt Johnston,
        Miao Wang, Micah Abbott, Michael A Cassaniti, Michal Koutný,
        Michal Sekletár, Mike Yuan, mooo, Morten Linderud, msizanoen,
        Nick Rosbrook, nikstur, Olivier Gayot, Omojola Joshua,
        Paolo Velati, Paul Barker, Pavel Borecki, Petr Menšík,
        Philipp Kern, Philip Withnall, Piotr Drąg, Quintin Hill,
        Rene Hollander, Richard Phibel, Robert Meijers, Robert Scheck,
        Roger Gammans, Romain Geissler, Ronan Pigott, Russell Harmon,
        saikat0511, Samanta Navarro, Sam James, Sam Morris,
        Simon Braunschmidt, Sjoerd Simons, Sorah Fukumori,
        Stanislaw Gruszka, Stefan Roesch, Steven Luo, Steve Ramage,
        Susant Sahani, taniishkaaa, Tanishka, Temuri Doghonadze,
        Thierry Martin, Thomas Blume, Thomas Genty, Thomas Weißschuh,
        Thorsten Kukuk, Times-Z, Tobias Powalowski, tofylion,
        Topi Miettinen, Uwe Kleine-König, Velislav Ivanov,
        Vitaly Kuznetsov, Vít Zikmund, Weblate, Will Fancher,
        William Roberts, Winterhuman, Wolfgang Müller, Xeonacid,
        Xiaotian Wu, Xi Ruoyao, Yuri Chornoivan, Yu Watanabe, Yuxiang Zhu,
        Zbigniew Jędrzejewski-Szmek, zhmylove, ZjYwMj,
        Дамјан Георгиевски, наб

        — Edinburgh, 2023-07-28

CHANGES WITH 253:

        Announcements of Future Feature Removals and Incompatible Changes:

        * We intend to remove cgroup v1 support from systemd release after the
          end of 2023. If you run services that make explicit use of cgroup v1
          features (i.e. the "legacy hierarchy" with separate hierarchies for
          each controller), please implement compatibility with cgroup v2 (i.e.
          the "unified hierarchy") sooner rather than later. Most of Linux
          userspace has been ported over already.

        * We intend to remove support for split-usr (/usr mounted separately
          during boot) and unmerged-usr (parallel directories /bin and
          /usr/bin, /lib and /usr/lib, etc). This will happen in the second
          half of 2023, in the first release that falls into that time window.
          For more details, see:
          https://lists.freedesktop.org/archives/systemd-devel/2022-September/048352.html

        * We intend to change behaviour w.r.t. units of the per-user service
          manager and sandboxing options, so that they work without having to
          manually enable PrivateUsers= as well, which is not required for
          system units. To make this work, we will implicitly enable user
          namespaces (PrivateUsers=yes) when a sandboxing option is enabled in a
          user unit. The drawback is that system users will no longer be visible
          (and appear as 'nobody') to the user unit when a sandboxing option is
          enabled. By definition a sandboxed user unit should run with reduced
          privileges, so impact should be small. This will remove a great source
          of confusion that has been reported by users over the years, due to
          how these options require an extra setting to be manually enabled when
          used in the per-user service manager, as opposed as to the system
          service manager. We plan to enable this change in the next release
          later this year. For more details, see:
          https://lists.freedesktop.org/archives/systemd-devel/2022-December/048682.html

        Deprecations and incompatible changes:

        * systemctl will now warn when invoked without /proc/ mounted
          (e.g. when invoked after chroot() into an directory tree without the
          API mount points like /proc/ being set up.)  Operation in such an
          environment is not fully supported.

        * The return value of 'systemctl is-active|is-enabled|is-failed' for
          unknown units is changed: previously 1 or 3 were returned, but now 4
          (EXIT_PROGRAM_OR_SERVICES_STATUS_UNKNOWN) is used as documented.

        * 'udevadm hwdb' subcommand is deprecated and will emit a warning.
          systemd-hwdb (added in 2014) should be used instead.

        * 'bootctl --json' now outputs a single JSON array, instead of a stream
          of newline-separated JSON objects.

        * Udev rules in 60-evdev.rules have been changed to load hwdb
          properties for all modalias patterns. Previously only the first
          matching pattern was used. This could change what properties are
          assigned if the user has more and less specific patterns that could
          match the same device, but it is expected that the change will have
          no effect for most users.

        * systemd-networkd-wait-online exits successfully when all interfaces
          are ready or unmanaged. Previously, if neither '--any' nor
          '--interface=' options were used, at least one interface had to be in
          configured state. This change allows the case where systemd-networkd
          is enabled, but no interfaces are configured, to be handled
          gracefully. It may occur in particular when a different network
          manager is also enabled and used.

        * Some compatibility helpers were dropped: EmergencyAction= in the user
          manager, as well as measuring kernel command line into PCR 8 in
          systemd-stub, along with the -Defi-tpm-pcr-compat compile-time
          option.

        * The '-Dupdate-helper-user-timeout=' build-time option has been
          renamed to '-Dupdate-helper-user-timeout-sec=', and now takes an
          integer as parameter instead of a string.

        * The DDI image dissection logic (which backs RootImage= in service
          unit files, the --image= switch in various tools such as
          systemd-nspawn, as well as systemd-dissect) will now only mount file
          systems of types btrfs, ext4, xfs, erofs, squashfs, vfat. This list
          can be overridden via the $SYSTEMD_DISSECT_FILE_SYSTEMS environment
          variable. These file systems are fairly well supported and maintained
          in current kernels, while others are usually more niche, exotic or
          legacy and thus typically do not receive the same level of security
          support and fixes.

        * The default per-link multicast DNS mode is changed to "yes"
          (that was previously "no"). As the default global multicast DNS mode
          has been "yes" (but can be changed by the build option), now the
          multicast DNS is enabled on all links by default. You can disable the
          multicast DNS on all links by setting MulticastDNS= in resolved.conf,
          or on an interface by calling "resolvectl mdns INTERFACE no".

        New components:

        * A tool 'ukify' tool to build, measure, and sign Unified Kernel Images
          (UKIs) has been added. This replaces functionality provided by
          'dracut --uefi' and extends it with automatic calculation of PE file
          offsets, insertion of signed PCR policies generated by
          systemd-measure, support for initrd concatenation, signing of the
          embedded Linux image and the combined image with sbsign, and
          heuristics to autodetect the kernel uname and verify the splash
          image.

        Changes in systemd and units:

        * A new service type Type=notify-reload is defined. When such a unit is
          reloaded a UNIX process signal (typically SIGHUP) is sent to the main
          service process. The manager will then wait until it receives a
          "RELOADING=1" followed by a "READY=1" notification from the unit as
          response (via sd_notify()). Otherwise, this type is the same as
          Type=notify. A new setting ReloadSignal= may be used to change the
          signal to send from the default of SIGHUP.

          user@.service, systemd-networkd.service, systemd-udevd.service, and
          systemd-logind have been updated to this type.

        * Initrd environments which are not on a pure memory file system (e.g.
          overlayfs combination as opposed to tmpfs) are now supported. With
          this change, during the initrd → host transition ("switch root")
          systemd will erase all files of the initrd only when the initrd is
          backed by a memory file system such as tmpfs.

        * New per-unit MemoryZSwapMax= option has been added to configure
          memory.zswap.max cgroup properties (the maximum amount of zswap
          used).

        * A new LogFilterPatterns= option has been added for units. It may be
          used to specify accept/deny regular expressions for log messages
          generated by the unit, that shall be enforced by systemd-journald.
          Rejected messages are neither stored in the journal nor forwarded.
          This option may be used to suppress noisy or uninteresting messages
          from units.

        * The manager has a new
          org.freedesktop.systemd1.Manager.GetUnitByPIDFD() D-Bus method to
          query process ownership via a PIDFD, which is more resilient against
          PID recycling issues.

        * Scope units now support OOMPolicy=. Login session scopes default to
          OOMPolicy=continue, allowing login scopes to survive the OOM killer
          terminating some processes in the scope.

        * systemd-fstab-generator now supports x-systemd.makefs option for
          /sysroot/ (in the initrd).

        * The maximum rate at which daemon reloads are executed can now be
          limited with the new ReloadLimitIntervalSec=/ReloadLimitBurst=
          options. (Or the equivalent on the kernel command line:
          systemd.reload_limit_interval_sec=/systemd.reload_limit_burst=). In
          addition, systemd now logs the originating unit and PID when a reload
          request is received over D-Bus.

        * When enabling a swap device systemd will now reinitialize the device
          when the page size of the swap space does not match the page size of
          the running kernel. Note that this requires the 'swapon' utility to
          provide the '--fixpgsz' option, as implemented by util-linux, and it
          is not supported by busybox at the time of writing.

        * systemd now executes generator programs in a mount namespace
          "sandbox" with most of the file system read-only and write access
          restricted to the output directories, and with a temporary /tmp/
          mount provided. This provides a safeguard against programming errors
          in the generators, but also fixes here-docs in shells, which
          previously didn't work in early boot when /tmp/ wasn't available
          yet. (This feature has no security implications, because the code is
          still privileged and can trivially exit the sandbox.)

        * The system manager will now parse a new "vmm.notify_socket"
          system credential, which may be supplied to a VM via SMBIOS. If
          found, the manager will send a "READY=1" notification on the
          specified socket after boot is complete. This allows readiness
          notification to be sent from a VM guest to the VM host over a VSOCK
          socket.

        * The sample PAM configuration file for systemd-user@.service now
          includes a call to pam_namespace. This puts children of user@.service
          in the expected namespace. (Many distributions replace their file
          with something custom, so this change has limited effect.)

        * A new environment variable $SYSTEMD_DEFAULT_MOUNT_RATE_LIMIT_BURST
          can be used to override the mount units burst late limit for
          parsing '/proc/self/mountinfo', which was introduced in v249.
          Defaults to 5.

        * Drop-ins for init.scope changing control group resource limits are
          now applied, while they were previously ignored.

        * New build-time configuration options '-Ddefault-timeout-sec=' and
          '-Ddefault-user-timeout-sec=' have been added, to let distributions
          choose the default timeout for starting/stopping/aborting system and
          user units respectively.

        * Service units gained a new setting OpenFile= which may be used to
          open arbitrary files in the file system (or connect to arbitrary
          AF_UNIX sockets in the file system), and pass the open file
          descriptor to the invoked process via the usual file descriptor
          passing protocol. This is useful to give unprivileged services access
          to select files which have restrictive access modes that would
          normally not allow this. It's also useful in case RootDirectory= or
          RootImage= is used to allow access to files from the host environment
          (which is after all not visible from the service if these two options
          are used.)

        Changes in udev:

        * The new net naming scheme "v253" has been introduced. In the new
          scheme, ID_NET_NAME_PATH is also set for USB devices not connected via
          a PCI bus. This extends the coverage of predictable interface names
          in some embedded systems.

          The "amba" bus path is now included in ID_NET_NAME_PATH, resulting in
          a more informative path on some embedded systems.

        * Partition block devices will now also get symlinks in
          /dev/disk/by-diskseq/<seq>-part<n>, which may be used to reference
          block device nodes via the kernel's "diskseq" value. Previously those
          symlinks were only created for the main block device.

        * A new operator '-=' is supported for SYMLINK variables. This allows
          symlinks to be unconfigured even if an earlier rule added them.

        * 'udevadm --trigger --settle' now also works for network devices
          that are being renamed.

        Changes in sd-boot, bootctl, and the Boot Loader Specification:

        * systemd-boot now passes its random seed directly to the kernel's RNG
          via the LINUX_EFI_RANDOM_SEED_TABLE_GUID configuration table, which
          means the RNG gets seeded very early in boot before userspace has
          started.

        * systemd-boot will pass a disk-backed random seed – even when secure
          boot is enabled – if it can additionally get a random seed from EFI
          itself (via EFI's RNG protocol), or a prior seed in
          LINUX_EFI_RANDOM_SEED_TABLE_GUID from a preceding bootloader.

        * systemd-boot-system-token.service was renamed to
          systemd-boot-random-seed.service and extended to always save a random
          seed to ESP on every boot when a compatible boot loader is used. This
          allows a refreshed random seed to be used in the boot loader.

        * systemd-boot handles various seed inputs using a domain- and
          field-separated hashing scheme.

        * systemd-boot's 'random-seed-mode' option has been removed. A system
          token is now always required to be present for random seeds to be
          used.

        * systemd-boot now supports being loaded from other locations than the
          ESP, for example for direct kernel boot under QEMU or when embedded
          into the firmware.

        * systemd-boot now parses SMBIOS information to detect
          virtualization. This information is used to skip some warnings which
          are not useful in a VM and to conditionalize other aspects of
          behaviour.

        * systemd-boot now supports a new 'if-safe' mode that will perform UEFI
          Secure Boot automated certificate enrollment from the ESP only if it
          is considered 'safe' to do so. At the moment 'safe' means running in
          a virtual machine.

        * systemd-stub now processes random seeds in the same way as
          systemd-boot already does, in case a unified kernel image is being
          used from a different bootloader than systemd-boot, or without any
          boot load at all.

        * bootctl will now generate a system token on all EFI systems, even
          virtualized ones, and is activated in the case that the system token
          is missing from either sd-boot and sd-stub booted systems.

        * bootctl now implements two new verbs: 'kernel-identify' prints the
          type of a kernel image file, and 'kernel-inspect' provides
          information about the embedded command line and kernel version of
          UKIs.

        * bootctl now honours $KERNEL_INSTALL_CONF_ROOT with the same meaning
          as for kernel-install.

        * The JSON output of "bootctl list" will now contain two more fields:
          isDefault and isSelected are boolean fields set to true on the
          default and currently booted boot menu entries.

        * bootctl gained a new verb "unlink" for removing a boot loader entry
          type #1 file from disk in a safe and robust way.

        * bootctl also gained a new verb "cleanup" that automatically removes
          all files from the ESP's and XBOOTLDR's "entry-token" directory, that
          is not referenced anymore by any installed Type #1 boot loader
          specification entry. This is particularly useful in environments where
          a large number of entries reference the same or partly the same
          resources (for example, for snapshot-based setups).

        Changes in kernel-install:

        * A new "installation layout" can be configured as layout=uki. With
          this setting, a Boot Loader Specification Type#1 entry will not be
          created. Instead, a new kernel-install plugin 90-uki-copy.install
          will copy any .efi files from the staging area into the boot
          partition. A plugin to generate the UKI .efi file must be provided
          separately.

        Changes in systemctl:

        * 'systemctl reboot' has dropped support for accepting a positional
          argument as the argument to the reboot(2) syscall. Please use the
          --reboot-argument= option instead.

        * 'systemctl disable' will now warn when called on units without
          install information. A new --no-warn option has been added that
          silences this warning.

        * New option '--drop-in=' can be used to tell 'systemctl edit' the name
          of the drop-in to edit. (Previously, 'override.conf' was always
          used.)

        * 'systemctl list-dependencies' now respects --type= and --state=.

        * 'systemctl kexec' now supports XEN VMM environments.

        * 'systemctl edit' will now tell the invoked editor to jump into the
          first line with actual unit file data, skipping over synthesized
          comments.

        Changes in systemd-networkd and related tools:

        * The [DHCPv4] section in .network file gained new SocketPriority=
          setting that assigns the Linux socket priority used by the DHCPv4 raw
          socket. This may be used in conjunction with the
          EgressQOSMaps=setting in [VLAN] section of .netdev file to send the
          desired ethernet 802.1Q frame priority for DHCPv4 initial
          packets. This cannot be achieved with netfilter mangle tables because
          of the raw socket bypass.

        * The [DHCPv4] and [IPv6AcceptRA] sections in .network file gained a
          new QuickAck= boolean setting that enables the TCP quick ACK mode for
          the routes configured by the acquired DHCPv4 lease or received router
          advertisements (RAs).

        * The RouteMetric= option (for DHCPv4, DHCPv6, and IPv6 advertised
          routes) now accepts three values, for high, medium, and low preference
          of the router (which can be set with the RouterPreference=) setting.

        * systemd-networkd-wait-online now supports matching via alternative
          interface names.

        * The [DHCPv6] section in .network file gained new SendRelease=
          setting which enables the DHCPv6 client to send release when
          it stops. This is the analog of the [DHCPv4] SendRelease= setting.
          It is enabled by default.

        * If the Address= setting in [Network] or [Address] sections in .network
          specified without its prefix length, then now systemd-networkd assumes
          /32 for IPv4 or /128 for IPv6 addresses.

        * networkctl shows network and link file dropins in status output.

        Changes in systemd-dissect:

        * systemd-dissect gained a new option --list, to print the paths of
          all files and directories in a DDI.

        * systemd-dissect gained a new option --mtree, to generate a file
          manifest compatible with BSD mtree(5) of a DDI

        * systemd-dissect gained a new option --with, to execute a command with
          the specified DDI temporarily mounted and used as working
          directory. This is for example useful to convert a DDI to "tar"
          simply by running it within a "systemd-dissect --with" invocation.

        * systemd-dissect gained a new option --discover, to search for
          Discoverable Disk Images (DDIs) in well-known directories of the
          system. This will list machine, portable service and system extension
          disk images.

        * systemd-dissect now understands 2nd stage initrd images stored as a
          Discoverable Disk Image (DDI).

        * systemd-dissect will now display the main UUID of GPT DDIs (i.e. the
          disk UUID stored in the GPT header) among the other data it can show.

        * systemd-dissect gained a new --in-memory switch to operate on an
          in-memory copy of the specified DDI file. This is useful to access a
          DDI with write access without persisting any changes. It's also
          useful for accessing a DDI without keeping the originating file
          system busy.

        * The DDI dissection logic will now automatically detect the intended
          sector size of disk images stored in files, based on the GPT
          partition table arrangement. Loopback block devices for such DDIs
          will then be configured automatically for the right sector size. This
          is useful to make dealing with modern 4K sector size DDIs fully
          automatic. The systemd-dissect tool will now show the detected sector
          size among the other DDI information in its output.

        Changes in systemd-repart:

        * systemd-repart gained new options --include-partitions= and
          --exclude-partitions= to filter operation on partitions by type UUID.
          This allows systemd-repart to be used to build images in which the
          type of one partition is set based on the contents of another
          partition (for example when the boot partition shall include a verity
          hash of the root partition).

        * systemd-repart also gained a --defer-partitions= option that is
          similar to --exclude-partitions=, but the size of the partition is
          still taken into account when sizing partitions, but without
          populating it.

        * systemd-repart gained a new --sector-size= option to specify what
          sector size should be used when an image is created.

        * systemd-repart now supports generating erofs file systems via
          CopyFiles= (a read-only file system similar to squashfs).

        * The Minimize= option was extended to accept "best" (which means the
          most minimal image possible, but may require multiple attempts) and
          "guess" (which means a reasonably small image).

        * The systemd-growfs binary now comes with a regular unit file template
          systemd-growfs@.service which can be instantiated directly for any
          desired file system. (Previously, the unit was generated dynamically
          by various generators, but no regular unit file template was
          available.)

        Changes in journal tools:

        * Various systemd tools will append extra fields to log messages when
          in debug mode, or when SYSTEMD_ENABLE_LOG_CONTEXT=1 is set. Currently
          this includes information about D-Bus messages when sd-bus is used,
          e.g. DBUS_SENDER=, DBUS_DESTINATION=, and DBUS_PATH=, and information
          about devices when sd-device is used, e.g. DEVNAME= and DRIVER=.
          Details of what is logged and when are subject to change.

        * The systemd-journald-audit.socket can now be disabled via the usual
          "systemctl disable" mechanism to stop collection of audit
          messages. Please note that it is not enabled statically anymore and
          must be handled by the preset/enablement logic in package
          installation scripts.

        * New options MaxUse=, KeepFree=, MaxFileSize=, and MaxFiles= can
          be used to curtail disk use by systemd-journal-remote. This is
          similar to the options supported by systemd-journald.

        Changes in systemd-cryptenroll, systemd-cryptsetup, and related
        components:

        * When enrolling new keys systemd-cryptenroll now supports unlocking
          via FIDO2 tokens (option --unlock-fido2-device=). Previously, a
          password was strictly required to be specified.

        * systemd-cryptsetup now supports pre-flight requests for FIDO2 tokens
          (except for tokens with user verification, UV) to identify tokens
          before authentication. Multiple FIDO2 tokens can now be enrolled at
          the same time, and systemd-cryptsetup will automatically select one
          that corresponds to one of the available LUKS key slots.

        * systemd-cryptsetup now supports new options tpm2-measure-bank= and
          tpm2-measure-pcr= in crypttab(5). These allow specifying the TPM2 PCR
          bank and number into which the volume key should be measured. This is
          automatically enabled for the encrypted root volume discovered and
          activated by systemd-gpt-auto-generator.

        * systemd-gpt-auto-generator mounts the ESP and XBOOTLDR partitions with
          "noexec,nosuid,nodev".

        * systemd-gpt-auto-generator will now honour the rootfstype= and
          rootflags= kernel command line switches for root file systems it
          discovers, to match behaviour in case an explicit root fs is
          specified via root=.

        * systemd-pcrphase gained new options --machine-id and --file-system=
          to measure the machine-id and mount point information into PCR 15.
          New service unit files systemd-pcrmachine.service and
          systemd-pcrfs@.service have been added that invoke the tool with
          these switches during early boot.

        * systemd-pcrphase gained a --graceful switch will make it exit cleanly
          with a success exit code even if no TPM device is detected.

        * systemd-cryptenroll now stores the user-supplied PIN with a salt,
          making it harder to brute-force.

        Changes in other tools:

        * systemd-homed gained support for luksPbkdfForceIterations (the
          intended number of iterations for the PBKDF operation on LUKS).

        * Environment variables $SYSTEMD_HOME_MKFS_OPTIONS_BTRFS,
          $SYSTEMD_HOME_MKFS_OPTIONS_EXT4, and $SYSTEMD_HOME_MKFS_OPTIONS_XFS
          may now be used to specify additional arguments for mkfs when
          systemd-homed formats a file system.

        * systemd-hostnamed now exports the contents of
          /sys/class/dmi/id/bios_vendor and /sys/class/dmi/id/bios_date via two
          new D-Bus properties: FirmwareVendor and FirmwareDate. This allows
          unprivileged code to access those values.

          systemd-hostnamed also exports the SUPPORT_END= field from
          os-release(5) as OperatingSystemSupportEnd. hostnamectl make uses of
          this to show the status of the installed system.

        * systemd-measure gained an --append= option to sign multiple phase
          paths with different signing keys. This allows secrets to be
          accessible only in certain parts of the boot sequence. Note that
          'ukify' provides similar functionality in a more accessible form.

        * systemd-timesyncd will now write a structured log message with
          MESSAGE_ID set to SD_MESSAGE_TIME_BUMP when it bumps the clock based
          on a on-disk timestamp, similarly to what it did when reaching
          synchronization via NTP.

        * systemd-timesyncd will now update the on-disk timestamp file on each
          boot at least once, making it more likely that the system time
          increases in subsequent boots.

        * systemd-vconsole-setup gained support for system/service credentials:
          vconsole.keymap/vconsole.keymap_toggle and
          vconsole.font/vconsole.font_map/vconsole.font_unimap are analogous
          the similarly-named options in vconsole.conf.

        * systemd-localed will now save the XKB keyboard configuration to
          /etc/vconsole.conf, and also read it from there with a higher
          preference than the /etc/X11/xorg.conf.d/00-keyboard.conf config
          file. Previously, this information was stored in the former file in
          converted form, and only in latter file in the original form. Tools
          which want to access keyboard configuration can now do so from a
          standard location.

        * systemd-resolved gained support for configuring the nameservers and
          search domains via kernel command line (nameserver=, domain=) and
          credentials (network.dns, network.search_domains).

        * systemd-resolved will now synthesize host names for the DNS stub
          addresses it supports. Specifically when "_localdnsstub" is resolved,
          127.0.0.53 is returned, and if "_localdnsproxy" is resolved
          127.0.0.54 is returned.

        * systemd-notify will now send a "RELOADING=1" notification when called
          with --reloading, and "STOPPING=1" when called with --stopping. This
          can be used to implement notifications from units where it's easier
          to call a program than to use the sd-daemon library.

        * systemd-analyze's 'plot' command can now output its information in
          JSON, controlled via the --json= switch. Also, new --table, and
          --no-legend options have been added.

        * 'machinectl enable' will now automatically enable machines.target
          unit in addition to adding the machine unit to the target.

          Similarly, 'machinectl start|stop' gained a --now option to enable or
          disable the machine unit when starting or stopping it.

        * systemd-sysusers will now create /etc/ if it is missing.

        * systemd-sleep 'HibernateDelaySec=' setting is changed back to
          pre-v252's behaviour, and a new 'SuspendEstimationSec=' setting is
          added to provide the new initial value for the new automated battery
          estimation functionality. If 'HibernateDelaySec=' is set to any value,
          the automated estimate (and thus the automated hibernation on low
          battery to avoid data loss) functionality will be disabled.

        * Default tmpfiles.d/ configuration will now automatically create
          credentials storage directory '/etc/credstore/' with the appropriate,
          secure permissions. If '/run/credstore/' exists, its permissions will
          be fixed too in case they are not correct.

        Changes in libsystemd and shared code:

        * sd-bus gained new convenience functions sd_bus_emit_signal_to(),
          sd_bus_emit_signal_tov(), and sd_bus_message_new_signal_to().

        * sd-id128 functions now return -EUCLEAN (instead of -EIO) when the
          128-bit ID in files such as /etc/machine-id has an invalid
          format. They also accept NULL as output parameter in more places,
          which is useful when the caller only wants to validate the inputs and
          does not need the output value.

        * sd-login gained new functions sd_pidfd_get_session(),
          sd_pidfd_get_owner_uid(), sd_pidfd_get_unit(),
          sd_pidfd_get_user_unit(), sd_pidfd_get_slice(),
          sd_pidfd_get_user_slice(), sd_pidfd_get_machine_name(), and
          sd_pidfd_get_cgroup(), that are analogous to sd_pid_get_*(),
          but accept a PIDFD instead of a PID.

        * sd-path (and systemd-path) now export four new paths:
          SD_PATH_SYSTEMD_SYSTEM_ENVIRONMENT_GENERATOR,
          SD_PATH_SYSTEMD_USER_ENVIRONMENT_GENERATOR,
          SD_PATH_SYSTEMD_SEARCH_SYSTEM_ENVIRONMENT_GENERATOR, and
          SD_PATH_SYSTEMD_SEARCH_USER_ENVIRONMENT_GENERATOR,

        * sd_notify() now supports AF_VSOCK as transport for notification
          messages (in addition to the existing AF_UNIX support). This is
          enabled if $NOTIFY_SOCKET is set in a "vsock:CID:port" format.

        * Detection of chroot() environments now works if /proc/ is not
          mounted. This affects systemd-detect-virt --chroot, but also means
          that systemd tools will silently skip various operations in such an
          environment.

        * "Lockheed Martin Hardened Security for Intel Processors" (HS SRE)
          virtualization is now detected.

        Changes in the build system:

        * Standalone variants of systemd-repart and systemd-shutdown may now be
          built (if -Dstandalone=true).

        * systemd-ac-power has been moved from /usr/lib/ to /usr/bin/, to, for
          example, allow scripts to conditionalize execution on AC power
          supply.

        * The libp11kit library is now loaded through dlopen(3).

        Changes in the documentation:

        * Specifications that are not closely tied to systemd have moved to
          https://uapi-group.org/specifications/: the Boot Loader Specification
          and the Discoverable Partitions Specification.

        Contributions from: 김인수, 13r0ck, Aidan Dang, Alberto Planas,
        Alvin Šipraga, Andika Triwidada, AndyChi, angus-p, Anita Zhang,
        Antonio Alvarez Feijoo, Arsen Arsenović, asavah, Benjamin Fogle,
        Benjamin Tissoires, berenddeschouwer, BerndAdameit,
        Bernd Steinhauser, blutch112, cake03, Callum Farmer, Carlo Teubner,
        Charles Hardin, chris, Christian Brauner, Christian Göttsche,
        Cristian Rodríguez, Daan De Meyer, Dan Streetman, DaPigGuy,
        Darrell Kavanagh, David Tardon, dependabot[bot], Dirk Su,
        Dmitry V. Levin, drosdeck, Edson Juliano Drosdeck, edupont,
        Eric DeVolder, Erik Moqvist, Evgeny Vereshchagin, Fabian Gurtner,
        Felix Riemann, Franck Bui, Frantisek Sumsal, Geert Lorang,
        Gerd Hoffmann, Gio, Hannoskaj, Hans de Goede, Hugo Carvalho,
        igo95862, Ilya Leoshkevich, Ivan Shapovalov, Jacek Migacz,
        Jade Lovelace, Jan Engelhardt, Jan Janssen, Jan Macku, January,
        Jason A. Donenfeld, jcg, Jean-Tiare Le Bigot, Jelle van der Waa,
        Jeremy Linton, Jian Zhang, Jiayi Chen, Jia Zhang, Joerg Behrmann,
        Jörg Thalheim, Joshua Goins, joshuazivkovic, Joshua Zivkovic,
        Kai-Chuan Hsieh, Khem Raj, Koba Ko, Lennart Poettering, lichao,
        Li kunyu, Luca Boccassi, Luca BRUNO, Ludwig Nussel,
        Łukasz Stelmach, Lycowolf, marcel151, Marcus Schäfer, Marek Vasut,
        Mark Laws, Michael Biebl, Michał Kotyla, Michal Koutný,
        Michal Sekletár, Mike Gilbert, Mike Yuan, MkfsSion, ml,
        msizanoen1, mvzlb, MVZ Ludwigsburg, Neil Moore, Nick Rosbrook,
        noodlejetski, Pasha Vorobyev, Peter Cai, p-fpv, Phaedrus Leeds,
        Philipp Jungkamp, Quentin Deslandes, Raul Tambre, Ray Strode,
        reuben olinsky, Richard E. van der Luit, Richard Phibel,
        Ricky Tigg, Robin Humble, rogg, Rudi Heitbaum, Sam James,
        Samuel Cabrero, Samuel Thibault, Siddhesh Poyarekar, Simon Brand,
        Space Meyer, Spindle Security, Steve Ramage, Takashi Sakamoto,
        Thomas Haller, Tonći Galić, Topi Miettinen, Torsten Hilbrich,
        Tuetuopay, uerdogan, Ulrich Ölmann, Valentin David,
        Vitaly Kuznetsov, Vito Caputo, Waltibaba, Will Fancher,
        William Roberts, wouter bolsterlee, Youfu Zhang, Yu Watanabe,
        Zbigniew Jędrzejewski-Szmek, Дамјан Георгиевски,
        наб

        — Warsaw, 2023-02-15

CHANGES WITH 252 🎃:

        Announcements of Future Feature Removals:

        * We intend to remove cgroup v1 support from systemd release after the
          end of 2023. If you run services that make explicit use of cgroup v1
          features (i.e. the "legacy hierarchy" with separate hierarchies for
          each controller), please implement compatibility with cgroup v2 (i.e.
          the "unified hierarchy") sooner rather than later. Most of Linux
          userspace has been ported over already.

        * We intend to remove support for split-usr (/usr mounted separately
          during boot) and unmerged-usr (parallel directories /bin and
          /usr/bin, /lib and /usr/lib, etc). This will happen in the second
          half of 2023, in the first release that falls into that time window.
          For more details, see:
          https://lists.freedesktop.org/archives/systemd-devel/2022-September/048352.html

        Compatibility Breaks:

        * ConditionKernelVersion= checks that use the '=' or '!=' operators
          will now do simple string comparisons (instead of version comparisons
          à la stverscmp()). Version comparisons are still done for the
          ordering operators '<', '>', '<=', '>='. Moreover, if no operator is
          specified, a shell-style glob match is now done. This creates a minor
          incompatibility compared to older systemd versions when the '*', '?',
          '[', ']' characters are used, as these will now match as shell globs
          instead of literally. Given that kernel version strings typically do
          not include these characters we expect little breakage through this
          change.

        * The service manager will now read the SELinux label used for SELinux
          access checks from the unit file at the time it loads the file.
          Previously, the label would be read at the moment of the access
          check, which was problematic since at that time the unit file might
          already have been updated or removed.

        New Features:

        * systemd-measure is a new tool for calculating and signing expected
          TPM2 PCR values for a given unified kernel image (UKI) booted via
          sd-stub. The public key used for the signature and the signed
          expected PCR information can be embedded inside the UKI. This
          information can be extracted from the UKI by external tools and code
          in the image itself and is made available to userspace in the booted
          kernel.

          systemd-cryptsetup, systemd-cryptenroll, and systemd-creds have been
          updated to make use of this information if available in the booted
          kernel: when locking an encrypted volume/credential to the TPM
          systemd-cryptenroll/systemd-creds will use the public key to bind the
          volume/credential to any kernel that carries PCR information signed
          by the same key pair. When unlocking such volumes/credentials
          systemd-cryptsetup/systemd-creds will use the signature embedded in
          the booted UKI to gain access.

          Binding TPM-based disk encryption to public keys/signatures of PCR
          values — instead of literal PCR values — addresses the inherent
          "brittleness" of traditional PCR-bound TPM disk encryption schemes:
          disks remain accessible even if the UKI is updated, without any TPM
          specific preparation during the OS update — as long as each UKI
          carries the necessary PCR signature information.

          Net effect: if you boot a properly prepared kernel, TPM-bound disk
          encryption now defaults to be locked to kernels which carry PCR
          signatures from the same key pair. Example: if a hypothetical distro
          FooOS prepares its UKIs like this, TPM-based disk encryption is now –
          by default – bound to only FooOS kernels, and encrypted volumes bound
          to the TPM cannot be unlocked on kernels from other sources. (But do
          note this behaviour requires preparation/enabling in the UKI, and of
          course users can always enroll non-TPM ways to unlock the volume.)

        * systemd-pcrphase is a new tool that is invoked at six places during
          system runtime, and measures additional words into TPM2 PCR 11, to
          mark milestones of the boot process. This allows binding access to
          specific TPM2-encrypted secrets to specific phases of the boot
          process. (Example: LUKS2 disk encryption key only accessible in the
          initrd, but not later.)

        Changes in systemd itself, i.e. the manager and units

        * The cpu controller is delegated to user manager units by default, and
          CPUWeight= settings are applied to the top-level user slice units
          (app.slice, background.slice, session.slice). This provides a degree
          of resource isolation between different user services competing for
          the CPU.

        * Systemd can optionally do a full preset in the "first boot" condition
          (instead of just enable-only). This behaviour is controlled by the
          compile-time option -Dfirst-boot-full-preset. Right now it defaults
          to 'false', but the plan is to switch it to 'true' for the subsequent
          release.

        * Drop-ins are now allowed for transient units too.

        * Systemd will set the taint flag 'support-ended' if it detects that
          the OS image is past its end-of-support date. This date is declared
          in a new /etc/os-release field SUPPORT_END= described below.

        * Two new settings ConditionCredential= and AssertCredential= can be
          used to skip or fail units if a certain system credential is not
          provided.

        * ConditionMemory= accepts size suffixes (K, M, G, T, …).

        * DefaultSmackProcessLabel= can be used in system.conf and user.conf to
          specify the SMACK security label to use when not specified in a unit
          file.

        * DefaultDeviceTimeoutSec= can be used in system.conf and user.conf to
          specify the default timeout when waiting for device units to
          activate.

        * C.UTF-8 is used as the default locale if nothing else has been
          configured.

        * [Condition|Assert]Firmware= have been extended to support certain
          SMBIOS fields. For example

            ConditionFirmware=smbios-field(board_name = "Custom Board")

          conditionalizes the unit to run only when
          /sys/class/dmi/id/board_name contains "Custom Board" (without the
          quotes).

        * ConditionFirstBoot= now correctly evaluates as true only during the
          boot phase of the first boot. A unit executed later, after booting
          has completed, will no longer evaluate this condition as true.

        * Socket units will now create sockets in the SELinuxContext= of the
          associated service unit, if any.

        * Boot phase transitions (start initrd → exit initrd → boot complete →
          shutdown) will be measured into TPM2 PCR 11, so that secrets can be
          bound to a specific runtime phase. E.g.: a LUKS encryption key can be
          unsealed only in the initrd.

        * Service credentials (i.e. SetCredential=/LoadCredential=/…) will now
          also be provided to ExecStartPre= processes.

        * Various units are now correctly ordered against
          initrd-switch-root.target where previously a conflict without
          ordering was configured. A stop job for those units would be queued,
          but without the ordering it could be executed only after
          initrd-switch-root.service, leading to units not being restarted in
          the host system as expected.

        * In order to fully support the IPMI watchdog driver, which has not yet
          been ported to the new common watchdog device interface,
          /dev/watchdog0 will be tried first and systemd will silently fallback
          to /dev/watchdog if it is not found.

        * New watchdog-related D-Bus properties are now published by systemd:
          WatchdogDevice, WatchdogLastPingTimestamp,
          WatchdogLastPingTimestampMonotonic.

        * At shutdown, API virtual files systems (proc, sys, etc.) will be
          unmounted lazily.

        * At shutdown, systemd will now log about processes blocking unmounting
          of file systems.

        * A new meson build option 'clock-valid-range-usec-max' was added to
          allow disabling system time correction if RTC returns a timestamp far
          in the future.

        * Propagated restart jobs will no longer be discarded while a unit is
          activating.

        * PID 1 will now import system credentials from SMBIOS Type 11 fields
          ("OEM vendor strings"), in addition to qemu_fwcfg. This provides a
          simple, fast and generic path for supplying credentials to a VM,
          without involving external tools such as cloud-init/ignition.

        * The CPUWeight= setting of unit files now accepts a new special value
          "idle", which configures "idle" level scheduling for the unit.

        * Service processes that are activated due to a .timer or .path unit
          triggering will now receive information about this via environment
          variables. Note that this is information is lossy, as activation
          might be coalesced and only one of the activating triggers will be
          reported. This is hence more suited for debugging or tracing rather
          than for behaviour decisions.

        * The riscv_flush_icache(2) system call has been added to the list of
          system calls allowed by default when SystemCallFilter= is used.

        * The selinux context derived from the target executable, instead of
          'init_t' used for the manager itself, is now used when creating
          listening sockets for units that specify SELinuxContextFromNet=yes.

        Changes in sd-boot, bootctl, and the Boot Loader Specification:

        * The Boot Loader Specification has been cleaned up and clarified.
          Various corner cases in version string comparisons have been fixed
          (e.g. comparisons for empty strings). Boot counting is now part of
          the main specification.

        * New PCRs measurements are performed during boot: PCR 11 for the
          kernel+initrd combo, PCR 13 for any sysext images. If a measurement
          took place this is now reported to userspace via the new
          StubPcrKernelImage and StubPcrInitRDSysExts EFI variables.

        * As before, systemd-stub will measure kernel parameters and system
          credentials into PCR 12. It will now report this fact via the
          StubPcrKernelParameters EFI variable to userspace.

        * The UEFI monotonic boot counter is now included in the updated random
          seed file maintained by sd-boot, providing some additional entropy.

        * sd-stub will use LoadImage/StartImage to execute the kernel, instead
          of arranging the image manually and jumping to the kernel entry
          point. sd-stub also installs a temporary UEFI SecurityOverride to
          allow the (unsigned) nested image to be booted. This is safe because
          the outer (signed) stub+kernel binary must have been verified before
          the stub was executed.

        * Booting in EFI mixed mode (a 64-bit kernel over 32-bit UEFI firmware)
          is now supported by sd-boot.

        * bootctl gained a bunch of new options: --all-architectures to install
          binaries for all supported EFI architectures, --root= and --image=
          options to operate on a directory or disk image, and
          --install-source= to specify the source for binaries to install,
          --efi-boot-option-description= to control the name of the boot entry.

        * The sd-boot stub exports a StubFeatures flag, which is used by
          bootctl to show features supported by the stub that was used to boot.

        * The PE section offsets that are used by tools that assemble unified
          kernel images have historically been hard-coded. This may lead to
          overlapping PE sections which may break on boot. The UKI will now try
          to detect and warn about this.

          Any tools that assemble UKIs must update to calculate these offsets
          dynamically. Future sd-stub versions may use offsets that will not
          work with the currently used set of hard-coded offsets!

        * sd-stub now accepts (and passes to the initrd and then to the full
          OS) new PE sections '.pcrsig' and '.pcrkey' that can be used to embed
          signatures of expected PCR values, to allow sealing secrets via the
          TPM2 against pre-calculated PCR measurements.

        Changes in the hardware database:

        * 'systemd-hwdb query' now supports the --root= option.

        Changes in systemctl:

        * systemctl now supports --state= and --type= options for the 'show'
          and 'status' verbs.

        * systemctl gained a new verb 'list-automounts' to list automount
          points.

        * systemctl gained support for a new --image= switch to be able to
          operate on the specified disk image (similar to the existing --root=
          which operates relative to some directory).

        Changes in systemd-networkd:

        * networkd can set Linux NetLabel labels for integration with the
          network control in security modules via a new NetLabel= option.

        * The RapidCommit= is (re-)introduced to enable faster configuration
          via DHCPv6 (RFC 3315).

        * networkd gained a new option TCPCongestionControlAlgorithm= that
          allows setting a per-route TCP algorithm.

        * networkd gained a new option KeepFileDescriptor= to allow keeping a
          reference (file descriptor) open on TUN/TAP interfaces, which is
          useful to avoid link flaps while the underlying service providing the
          interface is being serviced.

        * RouteTable= now also accepts route table names.

        Changes in systemd-nspawn:

        * The --bind= and --overlay= options now support relative paths.

        * The --bind= option now supports a 'rootidmap' value, which will
          use id-mapped mounts to map the root user inside the container to the
          owner of the mounted directory on the host.

        Changes in systemd-resolved:

        * systemd-resolved now persists DNSOverTLS in its state file too. This
          fixes a problem when used in combination with NetworkManager, which
          sends the setting only once, causing it to be lost if resolved was
          restarted at any point.

        * systemd-resolved now exposes a Varlink socket at
          /run/systemd/resolve/io.systemd.Resolve.Monitor, accessible only for
          root. Processed DNS requests in a JSON format will be published to
          any clients connected to this socket.

          resolvectl gained a 'monitor' verb to make use of this.

        * systemd-resolved now treats unsupported DNSSEC algorithms as INSECURE
          instead of returning SERVFAIL, as per RFC:
          https://datatracker.ietf.org/doc/html/rfc6840#section-5.2

        * OpenSSL is the default crypto backend for systemd-resolved. (gnutls
          is still supported.)

        Changes in libsystemd and other libraries:

        * libsystemd now exports sd_bus_error_setfv() (a convenience function
          for setting bus errors), sd_id128_string_equal (a convenience
          function for 128-bit ID string comparisons), and
          sd_bus_message_read_strv_extend() (a function to incrementally read
          string arrays).

        * libsystemd now exports sd_device_get_child_first()/_next() as a
          high-level interface for enumerating child devices. It also supports
          sd_device_new_child() for opening a child device given a device
          object.

        * libsystemd now exports sd_device_monitor_set()/get_description()
          which allow setting a custom description that will be used in log
          messages by sd_device_monitor*.

        * Private shared libraries (libsystemd-shared-nnn.so,
          libsystemd-core-nnn.so) are now installed into arch-specific
          directories to allow multi-arch installs.

        * A new sd-gpt.h header is now published, listing GUIDs from the
          Discoverable Partitions specification. For more details see:
          https://systemd.io/DISCOVERABLE_PARTITIONS/

        * A new function sd_hwdb_new_from_path() has been added to open a hwdb
          database given an explicit path to the file.

        * The signal number argument to sd_event_add_signal() now can now be
          ORed with the SD_EVENT_SIGNAL_PROCMASK flag, causing sigprocmask() to
          be automatically invoked to block the specified signal. This is
          useful to simplify invocations as the caller doesn't have to do this
          manually.

        * A new convenience call sd_event_set_signal_exit() has been added to
          sd-event to set up signal handling so that the event loop
          automatically terminates cleanly on SIGTERM/SIGINT.

        Changes in other components:

        * systemd-sysusers, systemd-tmpfiles, and systemd-sysctl configuration
          can now be provided via the credential mechanism.

        * systemd-analyze gained a new verb 'compare-versions' that implements
          comparisons for versions strings (similarly to 'rpmdev-vercmp' and
          'dpkg --compare-versions').

        * 'systemd-analyze dump' is extended to accept glob patterns for unit
          names to limit the output to matching units.

        * tmpfiles.d/ lines can read file contents to write from a credential.
          The new modifier char '^' is used to specify that the argument is a
          credential name. This mechanism is used to automatically populate
          /etc/motd, /etc/issue, and /etc/hosts from credentials.

        * tmpfiles.d/ may now be configured to avoid changing uid/gid/mode of
          an inode if the specification is prefixed with ':' and the inode
          already exists.

        * Default tmpfiles.d/ configuration now carries a line to automatically
          use an 'ssh.authorized_keys.root' credential if provided to set up
          the SSH authorized_keys file for the root user.

        * systemd-tmpfiles will now gracefully handle absent source of "C" copy
          lines.

        * tmpfiles.d/ F/w lines now optionally permit encoding of the payload
          in base64. This is useful to write arbitrary binary data into files.

        * The pkgconfig and rpm macros files now export the directory for user
          units as 'user_tmpfiles_dir' and '%_user_tmpfilesdir'.

        * Detection of Apple Virtualization and detection of Parallels and
          KubeVirt virtualization on non-x86 archs have been added.

        * os-release gained a new field SUPPORT_END=YYYY-MM-DD to inform the
          user when their system will become unsupported.

        * When performing suspend-then-hibernate, the system will estimate the
          discharge rate and use that to set the delay until hibernation and
          hibernate immediately instead of suspending when running from a
          battery and the capacity is below 5%.

        * systemd-sysctl gained a --strict option to fail when a sysctl
          setting is unknown to the kernel.

        * machinectl supports --force for the 'copy-to' and 'copy-from'
          verbs.

        * coredumpctl gained the --root and --image options to look for journal
          files under the specified root directory, image, or block device.

        * 'journalctl -o' and similar commands now implement a new output mode
          "short-delta". It is similar to "short-monotonic", but also shows the
          time delta between subsequent messages.

        * journalctl now respects the --quiet flag when verifying consistency
          of journal files.

        * Journal log messages gained a new implicit field _RUNTIME_SCOPE= that
          will indicate whether a message was logged in the 'initrd' phase or
          in the 'system' phase of the boot process.

        * Journal files gained a new compatibility flag
          'HEADER_INCOMPATIBLE_COMPACT'. Files with this flag implement changes
          to the storage format that allow reducing size on disk. As with other
          compatibility flags, older journalctl versions will not be able to
          read journal files using this new format. The environment variable
          'SYSTEMD_JOURNAL_COMPACT=0' can be passed to systemd-journald to
          disable this functionality. It is enabled by default.

        * systemd-run's --working-directory= switch now works when used in
          combination with --scope.

        * portablectl gained a --force flag to skip certain sanity checks. This
          is implemented using new flags accepted by systemd-portabled for the
          *WithExtensions() D-Bus methods: SD_SYSTEMD_PORTABLE_FORCE_ATTACH
          flag now means that the attach/detach checks whether the units are
          already present and running will be skipped. Similarly,
          SD_SYSTEMD_PORTABLE_FORCE_SYSEXT flag means that the check whether
          image name matches the name declared inside of the image will be
          skipped. Callers must be sure to do those checks themselves if
          appropriate.

        * systemd-portabled will now use the original filename to check
          extension-release.NAME for correctness, in case it is passed a
          symlink.

        * systemd-portabled now uses PrivateTmp=yes in the 'trusted' profile
          too.

        * sysext's extension-release files now support '_any' as a special
          value for the ID= field, to allow distribution-independent extensions
          (e.g.: fully statically compiled binaries, scripts). It also gained
          support for a new ARCHITECTURE= field that may be used to explicitly
          restrict an image to hosts of a specific architecture.

        * systemd-repart now supports creating squashfs partitions. This
          requires mksquashfs from squashfs-tools.

        * systemd-repart gained a --split flag to also generate split
          artifacts, i.e. a separate file for each partition. This is useful in
          conjunction with systemd-sysupdate or other tools, or to generate
          split dm-verity artifacts.

        * systemd-repart is now able to generate dm-verity partitions, including
          signatures.

        * systemd-repart can now set a partition UUID to zero, allowing it to
          be filled in later, such as when using verity partitions.

        * systemd-repart now supports drop-ins for its configuration files.

        * Package metadata logged by systemd-coredump in the system journal is
          now more compact.

        * xdg-autostart-service now expands 'tilde' characters in Exec lines.

        * systemd-oomd now automatically links against libatomic, if available.

        * systemd-oomd now sends out a 'Killed' D-Bus signal when a cgroup is
          killed.

        * scope units now also provide oom-kill status.

        * systemd-pstore will now try to load only the efi_pstore kernel module
          before running, ensuring that pstore can be used.

        * systemd-logind gained a new StopIdleSessionSec= option to stop an idle
          session after a preconfigure timeout.

        * systemd-homed will now wait up to 30 seconds for workers to terminate,
          rather than indefinitely.

        * homectl gained a new '--luks-sector-size=' flag that allows users to
          select the preferred LUKS sector size. Must be a power of 2 between 512
          and 4096. systemd-userdbd records gained a corresponding field.

        * systemd-sysusers will now respect the 'SOURCE_DATE_EPOCH' environment
          variable when generating the 'sp_lstchg' field, to ensure an image
          build can be reproducible.

        * 'udevadm wait' will now listen to kernel uevents too when called with
          --initialized=no.

        * When naming network devices udev will now consult the DeviceTree
          "alias" fields for the device.

        * systemd-udev will now create infiniband/by-path and
          infiniband/by-ibdev links for Infiniband verbs devices.

        * systemd-udev-trigger.service will now also prioritize input devices.

        * ConditionACPower= and systemd-ac-power will now assume the system is
          running on AC power if no battery can be found.

        * All features and tools using the TPM2 will now communicate with it
          using a bind key. Beforehand, the tpm2 support used encrypted sessions
          by creating a primary key that was used to encrypt traffic. This
          creates a problem as the key created for encrypting the traffic could
          be faked by an active interposer on the bus. In cases when a pin is
          used, a bind key will be used. The pin is used as the auth value for
          the seal key, aka the disk encryption key, and that auth value will be
          used in the session establishment. An attacker would need the pin
          value to create the secure session and thus an active interposer
          without the pin cannot interpose on TPM2 traffic.

        * systemd-growfs no longer requires udev to run.

        * systemd-backlight now will better support systems with multiple
          graphic cards.

        * systemd-cryptsetup's keyfile-timeout= option now also works when a
          device is used as a keyfile.

        * systemd-cryptenroll gained a new --unlock-key-file= option to get the
          unlocking key from a key file (instead of prompting the user). Note
          that this is the key for unlocking the volume in order to be able to
          enroll a new key, but it is not the key that is enrolled.

        * systemd-dissect gained a new --umount switch that will safely and
          synchronously unmount all partitions of an image previously mounted
          with 'systemd-dissect --mount'.

        * When using gcrypt, all systemd tools and services will now configure
          it to prefer the OS random number generator if present.

        * All example code shipped with documentation has been relicensed from CC0
          to MIT-0.

        * Unit tests will no longer fail when running on a system without
          /etc/machine-id.

        Experimental features:

        * BPF programs can now be compiled with bpf-gcc (requires libbpf >= 1.0
          and bpftool >= 7.0).

        * sd-boot can automatically enroll SecureBoot keys from files found on
          the ESP. This enrollment can be either automatic ('force' mode) or
          controlled by the user ('manual' mode). It is sufficient to place the
          SecureBoot keys in the right place in the ESP and they will be picked
          up by sd-boot and shown in the boot menu.

        * The mkosi config in systemd gained support for automatically
          compiling a kernel with the configuration appropriate for testing
          systemd. This may be useful when developing or testing systemd in
          tandem with the kernel.

        Contributions from: 김인수, Adam Williamson, adrian5, Aidan Dang,
        Akihiko Odaki, Alban Bedel, Albert Mikaelyan, Aleksey Vasenev,
        Alexander Graf, Alexander Shopov, Alexander Wilson,
        Alper Nebi Yasak, anarcat, Anders Jonsson, Andre Kalb,
        Andrew Stone, Andrey Albershteyn, Anita Zhang, Ansgar Burchardt,
        Antonio Alvarez Feijoo, Arnaud Ferraris, Aryan singh, asavah,
        Avamander, Avram Lubkin, Balázs Meskó, Bastien Nocera,
        Benjamin Franzke, BerndAdameit, bin456789, Celeste Liu,
        Chih-Hsuan Yen, Christian Brauner, Christian Göttsche,
        Christian Hesse, Clyde Byrd III, codefiles, Colin Walters,
        Cristian Rodríguez, Daan De Meyer, Daniel Braunwarth,
        Daniel Rusek, Dan Streetman, Darsey Litzenberger, David Edmundson,
        David Jaša, David Rheinsberg, David Seifert, David Tardon,
        dependabot[bot], Devendra Tewari, Dominique Martinet, drosdeck,
        Edson Juliano Drosdeck, Eduard Tolosa, eggfly, Einsler Lee,
        Elias Probst, Eli Schwartz, Evgeny Vereshchagin, exploide, Fei Li,
        Foster Snowhill, Franck Bui, Frank Dana, Frantisek Sumsal,
        Gerd Hoffmann, Gio, Goffredo Baroncelli, gtwang01,
        Guillaume W. Bres, H A, Hans de Goede, Heinrich Schuchardt,
        Hugo Carvalho, i-do-cpp, igo95862, j00512545, Jacek Migacz,
        Jade Bilkey, James Hilliard, Jan B, Janis Goldschmidt,
        Jan Janssen, Jan Kuparinen, Jan Luebbe, Jan Macku,
        Jason A. Donenfeld, Javkhlanbayar Khongorzul, Jeremy Soller,
        JeroenHD, jiangchuangang, João Loureiro,
        Joaquín Ignacio Aramendía, Jochen Sprickerhof,
        Johannes Schauer Marin Rodrigues, Jonas Kümmerlin,
        Jonas Witschel, Jonathan Kang, Jonathan Lebon, Joost Heitbrink,
        Jörg Thalheim, josh-gordon-fb, Joyce, Kai Lueke, lastkrick,
        Lennart Poettering, Leon M. George, licunlong, Li kunyu,
        LockBlock-dev, Loïc Collignon, Lubomir Rintel, Luca Boccassi,
        Luca BRUNO, Ludwig Nussel, Łukasz Stelmach, Maccraft123,
        Marc Kleine-Budde, Marius Vollmer, Martin Wilck, matoro,
        Matthias Lisin, Max Gautier, Maxim Mikityanskiy, Michael Biebl,
        Michal Koutný, Michal Sekletár, Michal Stanke, Mike Gilbert,
        Mitchell Freiderich, msizanoen1, Nick Rosbrook, nl6720, Oğuz Ersen,
        Oleg Solovyov, Olga Smirnova, Pablo Ceballos, Pavel Zhukov,
        Phaedrus Leeds, Philipp Gortan, Piotr Drąg, Pyfisch,
        Quentin Deslandes, Rahil Bhimjiani, Rene Hollander, Richard Huang,
        Richard Phibel, Rudi Heitbaum, Sam James, Sarah Brofeldt,
        Sean Anderson, Sebastian Scheibner, Shreenidhi Shedi,
        Sonali Srivastava, Steve Ramage, Suraj Krishnan, Swapnil Devesh,
        Takashi Sakamoto, Ted X. Toth, Temuri Doghonadze, Thomas Blume,
        Thomas Haller, Thomas Hebb, Tomáš Hnyk, Tomasz Paweł Gajc,
        Topi Miettinen, Ulrich Ölmann, undef, Uriel Corfa,
        Victor Westerhuis, Vincent Dagonneau, Vishal Chillara Srinivas,
        Vito Caputo, Weblate, Wenchao Hao, William Roberts, williamsumendap,
        wineway, xiaoyang, Yuri Chornoivan, Yu Watanabe,
        Zbigniew Jędrzejewski-Szmek, Zhaofeng Li, наб

        – The Great Beyond, 2022-10-31 👻

CHANGES WITH 251:

        Backwards-incompatible changes:

        * The minimum kernel version required has been bumped from 3.13 to 4.15,
          and CLOCK_BOOTTIME is now assumed to always exist.

        * C11 with GNU extensions (aka "gnu11") is now used to build our
          components. Public API headers are still restricted to ISO C89.

        * In v250, a systemd-networkd feature that automatically configures
          routes to addresses specified in AllowedIPs= was added and enabled by
          default. However, this causes network connectivity issues in many
          existing setups. Hence, it has been disabled by default since
          systemd-stable 250.3. The feature can still be used by explicitly
          configuring RouteTable= setting in .netdev files.

        * Jobs started via StartUnitWithFlags() will no longer return 'skipped'
          when a Condition*= check does not succeed, restoring the JobRemoved
          signal to the behaviour it had before v250.

        * The org.freedesktop.portable1 methods GetMetadataWithExtensions() and
          GetImageMetadataWithExtensions() have been fixed to provide an extra
          return parameter, containing the actual extension release metadata.
          The current implementation was judged to be broken and unusable, and
          thus the usual procedure of adding a new set of methods was skipped,
          and backward compatibility broken instead on the assumption that
          nobody can be affected given the current state of this interface.

        * All kernels supported by systemd mix bytes returned by RDRAND (or
          similar) into the entropy pool at early boot. This means that on
          those systems, even if /dev/urandom is not yet initialized, it still
          returns bytes that are of at least RDRAND quality. For that reason,
          we no longer have reason to invoke RDRAND from systemd itself, which
          has historically been a source of bugs. Furthermore, kernels ≥5.6
          provide the getrandom(GRND_INSECURE) interface for returning random
          bytes before the entropy pool is initialized without warning into
          kmsg, which is what we attempt to use if available. systemd's direct
          usage of RDRAND has been removed. x86 systems ≥Broadwell that are
          running an older kernel may experience kmsg warnings that were not
          seen with 250. For newer kernels, non-x86 systems, or older x86
          systems, there should be no visible changes.

        * sd-boot will now measure the kernel command line into TPM PCR 12
          rather than PCR 8. This improves usefulness of the measurements on
          systems where sd-boot is chainloaded from Grub. Grub measures all
          commands its executes into PCR 8, which makes it very hard to use
          reasonably, hence separate ourselves from that and use PCR 12
          instead, which is what certain Ubuntu editions already do. To retain
          compatibility with systems running older systemd systems a new meson
          option 'efi-tpm-pcr-compat' has been added (which defaults to false).
          If enabled, the measurement is done twice: into the new-style PCR 12
          *and* the old-style PCR 8. It's strongly advised to migrate all users
          to PCR 12 for this purpose in the long run, as we intend to remove
          this compatibility feature in two years' time.

        * busctl capture now writes output in the newer pcapng format instead
          of pcap.

        * A udev rule that imported hwdb matches for USB devices with lowercase
          hexadecimal vendor/product ID digits was added in systemd 250. This
          has been reverted, since uppercase hexadecimal digits are supposed to
          be used, and we already had a rule with the appropriate match.

          Users might need to adjust their local hwdb entries.

        * arch_prctl(2) has been moved to the @default set in the syscall filters
          (as exposed via the SystemCallFilter= setting in service unit files).
          It is apparently used by the linker now.

        * The tmpfiles entries that create the /run/systemd/netif directory and
          its subdirectories were moved from tmpfiles.d/systemd.conf to
          tmpfiles.d/systemd-network.conf.

          Users might need to adjust their files that override tmpfiles.d/systemd.conf
          to account for this change.

        * The requirement for Portable Services images to contain a well-formed
          os-release file (i.e.: contain at least an ID field) is now enforced.
          This applies to base images and extensions, and also to systemd-sysext.

        Changes in the Boot Loader Specification, kernel-install and sd-boot:

        * kernel-install's and bootctl's Boot Loader Specification Type #1
          entry generation logic has been reworked. The user may now pick
          explicitly by which "token" string to name the installation's boot
          entries, via the new /etc/kernel/entry-token file or the new
          --entry-token= switch to bootctl. By default — as before — the
          entries are named after the local machine ID. However, in "golden
          image" environments, where the machine ID shall be initialized on
          first boot (as opposed to at installation time before first boot) the
          machine ID will not be available at build time. In this case the
          --entry-token= switch to bootctl (or the /etc/kernel/entry-token
          file) may be used to override the "token" for the entries, for
          example the IMAGE_ID= or ID= fields from /etc/os-release. This will
          make the OS images independent of any machine ID, and ensure that the
          images will not carry any identifiable information before first boot,
          but on the other hand means that multiple parallel installations of
          the very same image on the same disk cannot be supported.

          Summary: if you are building golden images that shall acquire
          identity information exclusively on first boot, make sure to both
          remove /etc/machine-id *and* to write /etc/kernel/entry-token to the
          value of the IMAGE_ID= or ID= field of /etc/os-release or another
          suitable identifier before deploying the image.

        * The Boot Loader Specification has been extended with
          /loader/entries.srel file located in the EFI System Partition (ESP)
          that disambiguates the format of the entries in the /loader/entries/
          directory (in order to discern them from incompatible uses of this
          directory by other projects). For entries that follow the
          Specification, the string "type1" is stored in this file.

          bootctl will now write this file automatically when installing the
          systemd-boot boot loader.

        * kernel-install supports a new initrd_generator= setting in
          /etc/kernel/install.conf, that is exported as
          $KERNEL_INSTALL_INITRD_GENERATOR to kernel-install plugins. This
          allows choosing different initrd generators.

        * kernel-install will now create a "staging area" (an initially-empty
          directory to gather files for a Boot Loader Specification Type #1
          entry). The path to this directory is exported as
          $KERNEL_INSTALL_STAGING_AREA to kernel-install plugins, which should
          drop files there instead of writing them directly to the final
          location. kernel-install will move them when all files have been
          prepared successfully.

        * New option sort-key= has been added to the Boot Loader Specification
          to override the sorting order of the entries in the boot menu. It is
          read by sd-boot and bootctl, and will be written by kernel-install,
          with the default value of IMAGE_ID= or ID= fields from
          os-release. Together, this means that on multiboot installations,
          entries should be grouped and sorted in a predictable way.

        * The sort order of boot entries has been updated: entries which have
          the new field sort-key= are sorted by it first, and all entries
          without it are ordered later. After that, entries are sorted by
          version so that newest entries are towards the beginning of the list.

        * The kernel-install tool gained a new 'inspect' verb which shows the
          paths and other settings used.

        * sd-boot can now optionally beep when the menu is shown and menu
          entries are selected, which can be useful on machines without a
          working display. (Controllable via a loader.conf setting.)

        * The --make-machine-id-directory= switch to bootctl has been replaced
          by --make-entry-directory=, given that the entry directory is not
          necessarily named after the machine ID, but after some other suitable
          ID as selected via --entry-token= described above. The old name of
          the option is still understood to maximize compatibility.

        * 'bootctl list' gained support for a new --json= switch to output boot
          menu entries in JSON format.

        * 'bootctl is-installed' now supports the --graceful, and various verbs
          omit output with the new option --quiet.

        Changes in systemd-homed:

        * Starting with v250 systemd-homed uses UID/GID mapping on the mounts
          of activated home directories it manages (if the kernel and selected
          file systems support it). So far it mapped three UID ranges: the
          range from 0…60000, the user's own UID, and the range 60514…65534,
          leaving everything else unmapped (in other words, the 16-bit UID range
          is mapped almost fully, with the exception of the UID subrange used
          for systemd-homed users, with one exception: the user's own UID).
          Unmapped UIDs may not be used for file ownership in the home
          directory — any chown() attempts with them will fail. With this
          release a fourth range is added to these mappings:
          524288…1879048191. This range is the UID range intended for container
          uses, see:

                  https://systemd.io/UIDS-GIDS

          This range may be used for container managers that place container OS
          trees in the home directory (which is a questionable approach, for
          quota, permission, SUID handling and network file system
          compatibility reasons, but nonetheless apparently commonplace). Note
          that this mapping is mapped 1:1 in a pass-through fashion, i.e. the
          UID assignments from the range are not managed or mapped by
          systemd-homed, and must be managed with other mechanisms, in the
          context of the local system.

          Typically, a better approach to user namespacing in relevant
          container managers would be to leave container OS trees on disk at
          UID offset 0, but then map them to a dynamically allocated runtime
          UID range via another UID mount map at container invocation
          time. That way user namespace UID ranges become strictly a runtime
          concept, and do not leak into persistent file systems, persistent
          user databases or persistent configuration, thus greatly simplifying
          handling, and improving compatibility with home directories intended
          to be portable like the ones managed by systemd-homed.

        Changes in shared libraries:

        * A new libsystemd-core-<version>.so private shared library is
          installed under /usr/lib/systemd/system, mirroring the existing
          libsystemd-shared-<version>.so library. This allows the total
          installation size to be reduced by binary code reuse.

        * The <version> tag used in the name of libsystemd-shared.so and
          libsystemd-core.so can be configured via the meson option
          'shared-lib-tag'. Distributions may build subsequent versions of the
          systemd package with unique tags (e.g. the full package version),
          thus allowing multiple installations of those shared libraries to be
          available at the same time. This is intended to fix an issue where
          programs that link to those libraries would fail to execute because
          they were installed earlier or later than the appropriate version of
          the library.

        * The sd-id128 API gained a new call sd_id128_to_uuid_string() that is
          similar to sd_id128_to_string() but formats the ID in RFC 4122 UUID
          format instead of as a simple series of hex characters.

        * The sd-device API gained two new calls sd_device_new_from_devname()
          and sd_device_new_from_path() which permit allocating an sd_device
          object from a device node name or file system path.

        * sd-device also gained a new call sd_device_open() which will open the
          device node associated with a device for which an sd_device object
          has been allocated. The call is supposed to address races around
          device nodes being removed/recycled due to hotplug events, or media
          change events: the call checks internally whether the major/minor of
          the device node and the "diskseq" (in case of block devices) match
          with the metadata loaded in the sd_device object, thus ensuring that
          the device once opened really matches the provided sd_device object.

        Changes in PID1, systemctl, and systemd-oomd:

        * A new set of service monitor environment variables will be passed to
          OnFailure=/OnSuccess= handlers, but only if exactly one unit lists the
          handler unit as OnFailure=/OnSuccess=. The variables are:
          $MONITOR_SERVICE_RESULT, $MONITOR_EXIT_CODE, $MONITOR_EXIT_STATUS,
          $MONITOR_INVOCATION_ID and $MONITOR_UNIT. For cases when a single
          handler needs to watch multiple units, use a templated handler.

        * A new ExtensionDirectories= setting in service unit files allows
          system extensions to be loaded from a directory. (It is similar to
          ExtensionImages=, but takes paths to directories, instead of
          disk image files.)

          'portablectl attach --extension=' now also accepts directory paths.

        * The user.delegate and user.invocation_id extended attributes on
          cgroups are used in addition to trusted.delegate and
          trusted.invocation_id. The latter pair requires privileges to set,
          but the former doesn't and can be also set by the unprivileged user
          manager.

          (Only supported on kernels ≥5.6.)

        * Units that were killed by systemd-oomd will now have a service result
          of 'oom-kill'. The number of times a service was killed is tallied
          in the 'user.oomd_ooms' extended attribute.

          The OOMPolicy= unit file setting is now also honoured by
          systemd-oomd.

        * In unit files the new %y/%Y specifiers can be used to refer to
          normalized unit file path, which is particularly useful for symlinked
          unit files.

          The new %q specifier resolves to the pretty hostname
          (i.e. PRETTY_HOSTNAME= from /etc/machine-info).

          The new %d specifier resolves to the credentials directory of a
          service (same as $CREDENTIALS_DIRECTORY).

        * The RootDirectory=, MountAPIVFS=, ExtensionDirectories=,
          *Capabilities*=, ProtectHome=, *Directory=, TemporaryFileSystem=,
          PrivateTmp=, PrivateDevices=, PrivateNetwork=, NetworkNamespacePath=,
          PrivateIPC=, IPCNamespacePath=, PrivateUsers=, ProtectClock=,
          ProtectKernelTunables=, ProtectKernelModules=, ProtectKernelLogs=,
          MountFlags= service settings now also work in unprivileged user
          services, i.e. those run by the user's --user service manager, as long
          as user namespaces are enabled on the system.

        * Services with Restart=always and a failing ExecCondition= will no
          longer be restarted, to bring ExecCondition= behaviour in line with
          Condition*= settings.

        * LoadCredential= now accepts a directory as the argument; all files
          from the directory will be loaded as credentials.

        * A new D-Bus property ControlGroupId is now exposed on service units,
          that encapsulates the service's numeric cgroup ID that newer kernels
          assign to each cgroup.

        * PID 1 gained support for configuring the "pre-timeout" of watchdog
          devices and the associated governor, via the new
          RuntimeWatchdogPreSec= and RuntimeWatchdogPreGovernor= configuration
          options in /etc/systemd/system.conf.

        * systemctl's --timestamp= option gained a new choice "unix", to show
          timestamp as unix times, i.e. seconds since 1970, Jan 1st.

        * A new "taint" flag named "old-kernel" is introduced which is set when
          the kernel systemd runs on is older then the current baseline version
          (see above). The flag is shown in "systemctl status" output.

        * Two additional taint flags "short-uid-range" and "short-gid-range"
          have been added as well, which are set when systemd notices it is run
          within a userns namespace that does not define the full 0…65535 UID
          range

        * A new "unmerged-usr" taint flag has been added that is set whenever
          running on systems where /bin/ + /sbin/ are *not* symlinks to their
          counterparts in /usr/, i.e. on systems where the /usr/-merge has not
          been completed.

        * Generators invoked by PID 1 will now have a couple of useful
          environment variables set describing the execution context a
          bit. $SYSTEMD_SCOPE encodes whether the generator is called from the
          system service manager, or from the per-user service
          manager. $SYSTEMD_IN_INITRD encodes whether the generator is invoked
          in initrd context or on the host. $SYSTEMD_FIRST_BOOT encodes whether
          systemd considers the current boot to be a "first"
          boot. $SYSTEMD_VIRTUALIZATION encode whether virtualization is
          detected and which type of hypervisor/container
          manager. $SYSTEMD_ARCHITECTURE indicates which architecture the
          kernel is built for.

        * PID 1 will now automatically pick up system credentials from qemu's
          fw_cfg interface, thus allowing passing arbitrary data into VM
          systems similar to how this is already supported for passing them
          into systemd-nspawn containers. Credentials may now also be passed in
          via the new kernel command line option "systemd.set_credential="
          (note that kernel command line options are world-readable during
          runtime, and only useful for credentials that require no
          confidentiality). The credentials that can be passed to unified
          kernels that use the systemd-stub UEFI stub are now similarly
          picked up automatically. Automatic importing of system credentials
          this way can be turned off via the new
          "systemd.import_credentials=no" kernel command line option.

        * LoadCredential= will now automatically look for credentials in the
          /etc/credstore/, /run/credstore/, /usr/lib/credstore/ directories if
          the argument is not an absolute path. Similarly,
          LoadCredentialEncrypted= will check the same directories plus
          /etc/credstore.encrypted/, /run/credstore.encrypted/ and
          /usr/lib/credstore.encrypted/. The idea is to use those directories
          as the system-wide location for credentials that services should pick
          up automatically.

        * System and service credentials are described in great detail in a new
          document:

          https://systemd.io/CREDENTIALS

        Changes in systemd-journald:

        * The journal JSON export format has been added to listed of stable
          interfaces (https://systemd.io/PORTABILITY_AND_STABILITY/).

        * journalctl --list-boots now supports JSON output and the --reverse option.

        * Under docs/: JOURNAL_EXPORT_FORMATS was imported from the wiki and
          updated, BUILDING_IMAGES is new:

          https://systemd.io/JOURNAL_EXPORT_FORMATS
          https://systemd.io/BUILDING_IMAGES

        Changes in udev:

        * Two new hwdb files have been added. One lists "handhelds" (PDAs,
          calculators, etc.), the other AV production devices (DJ tables,
          keypads, etc.) that should accessible to the seat owner user by
          default.

        * udevadm trigger gained a new --prioritized-subsystem= option to
          process certain subsystems (and all their parent devices) earlier.

          systemd-udev-trigger.service now uses this new option to trigger
          block and TPM devices first, hopefully making the boot a bit faster.

        * udevadm trigger now implements --type=all, --initialized-match,
          --initialized-nomatch to trigger both subsystems and devices, only
          already-initialized devices, and only devices which haven't been
          initialized yet, respectively.

        * udevadm gained a new "wait" command for safely waiting for a specific
          device to show up in the udev device database. This is useful in
          scripts that asynchronously allocate a block device (e.g. through
          repartitioning, or allocating a loopback device or similar) and need
          to synchronize on the creation to complete.

        * udevadm gained a new "lock" command for locking one or more block
          devices while formatting it or writing a partition table to it. It is
          an implementation of https://systemd.io/BLOCK_DEVICE_LOCKING and
          usable in scripts dealing with block devices.

        * udevadm info will show a couple of additional device fields in its
          output, and will not apply a limited set of coloring to line types.

        * udevadm info --tree will now show a tree of objects (i.e. devices and
          suchlike) in the /sys/ hierarchy.

        * Block devices will now get a new set of device symlinks in
          /dev/disk/by-diskseq/<nr>, which may be used to reference block
          device nodes via the kernel's "diskseq" value. Note that this does
          not guarantee that opening a device by a symlink like this will
          guarantee that the opened device actually matches the specified
          diskseq value. To be safe against races, the actual diskseq value of
          the opened device (BLKGETDISKSEQ ioctl()) must still be compred with
          the one in the symlink path.

        * .link files gained support for setting MDI/MID-X on a link.

        * .link files gained support for [Match] Firmware= setting to match on
          the device firmware description string. By mistake, it was previously
          only supported in .network files.

        * .link files gained support for [Link] SR-IOVVirtualFunctions= setting
          and [SR-IOV] section to configure SR-IOV virtual functions.

        Changes in systemd-networkd:

        * The default scope for unicast routes configured through [Route]
          section is changed to "link", to make the behavior consistent with
          "ip route" command. The manual configuration of [Route] Scope= is
          still honored.

        * A new unit systemd-networkd-wait-online@<interface>.service has been
          added that can be used to wait for a specific network interface to be
          up.

        * systemd-networkd gained a new [Bridge] Isolated=true|false setting
          that configures the eponymous kernel attribute on the bridge.

        * .netdev files now can be used to create virtual WLAN devices, and
          configure various settings on them, via the [WLAN] section.

        * .link/.network files gained support for [Match] Kind= setting to match
          on device kind ("bond", "bridge", "gre", "tun", "veth", etc.)

          This value is also shown by 'networkctl status'.

        * The Local= setting in .netdev files for various virtual network
          devices gained support for specifying, in addition to the network
          address, the name of a local interface which must have the specified
          address.

        * systemd-networkd gained a new [Tunnel] External= setting in .netdev
          files, to configure tunnels in external mode (a.k.a. collect metadata
          mode).

        * [Network] L2TP= setting was removed. Please use interface specifier in
          Local= setting in .netdev files of corresponding L2TP interface.

        * New [DHCPServer] BootServerName=, BootServerAddress=, and
          BootFilename= settings can be used to configure the server address,
          server name, and file name sent in the DHCP packet (e.g. to configure
          PXE boot).

        Changes in systemd-resolved:

        * systemd-resolved is started earlier (in sysinit.target), so it
          available earlier and will also be started in the initrd if installed
          there.

        Changes in disk encryption:

        * systemd-cryptenroll can now control whether to require the user to
          enter a PIN when using TPM-based unlocking of a volume via the new
          --tpm2-with-pin= option.

          Option tpm2-pin= can be used in /etc/crypttab.

        * When unlocking devices via TPM, TPM2 parameter encryption is now
          used, to ensure that communication between CPU and discrete TPM chips
          cannot be eavesdropped to acquire disk encryption keys.

        * A new switch --fido2-credential-algorithm= has been added to
          systemd-cryptenroll allowing selection of the credential algorithm to
          use when binding encryption to FIDO2 tokens.

        Changes in systemd-hostnamed:

        * HARDWARE_VENDOR= and HARDWARE_MODEL= can be set in /etc/machine-info
          to override the values gleaned from the hwdb.

        * A ID_CHASSIS property can be set in the hwdb (for the DMI device
          /sys/class/dmi/id) to override the chassis that is reported by
          hostnamed.

        * hostnamed's D-Bus interface gained a new method GetHardwareSerial()
          for reading the hardware serial number, as reported by DMI. It also
          exposes a new method D-Bus property FirmwareVersion that encode the
          firmware version of the system.

        Changes in other components:

        * /etc/locale.conf is now populated through tmpfiles.d factory /etc/
          handling with the values that were configured during systemd build
          (if /etc/locale.conf has not been created through some other
          mechanism). This means that /etc/locale.conf should always have
          reasonable contents and we avoid a potential mismatch in defaults.

        * The userdbctl tool will now show UID range information as part of the
          list of known users.

        * A new build-time configuration setting default-user-shell= can be
          used to set the default shell for user records and nspawn shell
          invocations (instead of the default /bin/bash).

        * systemd-timesyncd now provides a D-Bus API for receiving NTP server
          information dynamically at runtime via IPC.

        * The systemd-creds tool gained a new "has-tpm2" verb, which reports
          whether a functioning TPM2 infrastructure is available, i.e. if
          firmware, kernel driver and systemd all have TPM2 support enabled and
          a device found.

        * The systemd-creds tool gained support for generating encrypted
          credentials that are using an empty encryption key. While this
          provides no integrity nor confidentiality it's useful to implement
          codeflows that work the same on TPM-ful and TPM2-less systems. The
          service manager will only accept credentials "encrypted" that way if
          a TPM2 device cannot be detected, to ensure that credentials
          "encrypted" like that cannot be used to trick TPM2 systems.

        * When deciding whether to colorize output, all systemd programs now
          also check $COLORTERM (in addition to $NO_COLOR, $SYSTEMD_COLORS, and
          $TERM).

        * Meson's new install_tag feature is now in use for several components,
          allowing to build and install select binaries only: pam, nss, devel
          (pkg-config files), systemd-boot, libsystemd, libudev. Example:
           $ meson build systemd-boot
           $ meson install --tags systemd-boot --no-rebuild
          https://mesonbuild.com/Installing.html#installation-tags

        * A new build configuration option has been added, to allow selecting the
          default compression algorithm used by systemd-journald and systemd-coredump.
          This allows to build-in support for decompressing all supported formats,
          but choose a specific one for compression. E.g.:
           $ meson -Ddefault-compression=xz

        Experimental features:

        * sd-boot gained a new *experimental* setting "reboot-for-bitlocker" in
          loader.conf that implements booting Microsoft Windows from the
          sd-boot in a way that first reboots the system, to reset the TPM
          PCRs. This improves compatibility with BitLocker's TPM use, as the
          PCRs will only record the Windows boot process, and not sd-boot
          itself, thus retaining the PCR measurements not involving sd-boot.
          Note that this feature is experimental for now, and is likely going
          to be generalized and renamed in a future release, without retaining
          compatibility with the current implementation.

        * A new systemd-sysupdate component has been added that automatically
          discovers, downloads, and installs A/B-style updates for the host
          installation itself, or container images, portable service images,
          and other assets. See the new systemd-sysupdate man page for updates.

        Contributions from: 4piu, Adam Williamson, adrian5, Albert Brox,
        AlexCatze, Alex Henrie, Alfonso Sánchez-Beato, Alice S,
        Alvin Šipraga, amarjargal, Amarjargal, Andrea Pappacoda,
        Andreas Rammhold, Andy Chi, Anita Zhang, Antonio Alvarez Feijoo,
        Arfrever Frehtes Taifersar Arahesis, ash, Bastien Nocera, Be,
        bearhoney, Ben Efros, Benjamin Berg, Benjamin Franzke,
        Brett Holman, Christian Brauner, Clyde Byrd III, Curtis Klein,
        Daan De Meyer, Daniele Medri, Daniel Mack, Danilo Krummrich,
        David, David Bond, Davide Cavalca, David Tardon, davijosw,
        dependabot[bot], Donald Chan, Dorian Clay, Eduard Tolosa,
        Elias Probst, Eli Schwartz, Erik Sjölund, Evgeny Vereshchagin,
        Federico Ceratto, Franck Bui, Frantisek Sumsal, Gaël PORTAY,
        Georges Basile Stavracas Neto, Gibeom Gwon, Goffredo Baroncelli,
        Grigori Goronzy, Hans de Goede, Heiko Becker, Hugo Carvalho,
        Jakob Lell, James Hilliard, Jan Janssen, Jason A. Donenfeld,
        Joan Bruguera, Joerie de Gram, Josh Triplett, Julia Kartseva,
        Kazuo Moriwaka, Khem Raj, ksa678491784, Lance, Lan Tian,
        Laura Barcziova, Lennart Poettering, Leviticoh, licunlong,
        Lidong Zhong, lincoln auster, Lubomir Rintel, Luca Boccassi,
        Luca BRUNO, lucagoc, Ludwig Nussel, Marcel Hellwig, march1993,
        Marco Scardovi, Mario Limonciello, Mariusz Tkaczyk,
        Markus Weippert, Martin, Martin Liska, Martin Wilck, Matija Skala,
        Matthew Blythe, Matthias Lisin, Matthijs van Duin, Matt Walton,
        Max Gautier, Michael Biebl, Michael Olbrich, Michal Koutný,
        Michal Sekletár, Mike Gilbert, MkfsSion, Morten Linderud,
        Nick Rosbrook, Nikolai Grigoriev, Nikolai Kostrigin,
        Nishal Kulkarni, Noel Kuntze, Pablo Ceballos, Peter Hutterer,
        Peter Morrow, Pigmy-penguin, Piotr Drąg, prumian, Richard Neill,
        Rike-Benjamin Schuppner, rodin-ia, Romain Naour, Ruben Kerkhof,
        Ryan Hendrickson, Santa Wiryaman, Sebastian Pucilowski, Seth Falco,
        Simon Ellmann, Sonali Srivastava, Stefan Seering,
        Stephen Hemminger, tawefogo, techtino, Temuri Doghonadze,
        Thomas Batten, Thomas Haller, Thomas Weißschuh, Tobias Stoeckmann,
        Tomasz Pala, Tyson Whitehead, Vishal Chillara Srinivas,
        Vivien Didelot, w30023233, wangyuhang, Weblate, Xiaotian Wu,
        yangmingtai, YmrDtnJu, Yonathan Randolph, Yutsuten, Yu Watanabe,
        Zbigniew Jędrzejewski-Szmek, наб

        — Edinburgh, 2022-05-21

CHANGES WITH 250:

        * Support for encrypted and authenticated credentials has been added.
          This extends the credential logic introduced with v247 to support
          non-interactive symmetric encryption and authentication, based on a
          key that is stored on the /var/ file system or in the TPM2 chip (if
          available), or the combination of both (by default if a TPM2 chip
          exists the combination is used, otherwise the /var/ key only). The
          credentials are automatically decrypted at the moment a service is
          started, and are made accessible to the service itself in unencrypted
          form. A new tool 'systemd-creds' encrypts credentials for this
          purpose, and two new service file settings LoadCredentialEncrypted=
          and SetCredentialEncrypted= configure such credentials.

          This feature is useful to store sensitive material such as SSL
          certificates, passwords and similar securely at rest and only decrypt
          them when needed, and in a way that is tied to the local OS
          installation or hardware.

        * systemd-gpt-auto-generator can now automatically set up discoverable
          LUKS2 encrypted swap partitions.

        * The GPT Discoverable Partitions Specification has been substantially
          extended with support for root and /usr/ partitions for the majority
          of architectures systemd supports. This includes platforms that do
          not natively support UEFI, because even though GPT is specified under
          UEFI umbrella, it is useful on other systems too. Specifically,
          systemd-nspawn, systemd-sysext, systemd-gpt-auto-generator and
          Portable Services use the concept without requiring UEFI.

        * The GPT Discoverable Partitions Specifications has been extended with
          a new set of partitions that may carry PKCS#7 signatures for Verity
          partitions, encoded in a simple JSON format. This implements a simple
          mechanism for building disk images that are fully authenticated and
          can be tested against a set of cryptographic certificates. This is
          now implemented for the various systemd tools that can operate with
          disk images, such as systemd-nspawn, systemd-sysext, systemd-dissect,
          Portable services/RootImage=, systemd-tmpfiles, and systemd-sysusers.
          The PKCS#7 signatures are passed to the kernel (where they are
          checked against certificates from the kernel keyring), or can be
          verified against certificates provided in userspace (via a simple
          drop-in file mechanism).

        * systemd-dissect's inspection logic will now report for which uses a
          disk image is intended. Specifically, it will display whether an
          image is suitable for booting on UEFI or in a container (using
          systemd-nspawn's --image= switch), whether it can be used as portable
          service, or attached as system extension.

        * The system-extension.d/ drop-in files now support a new field
          SYSEXT_SCOPE= that may encode which purpose a system extension image
          is for: one of "initrd", "system" or "portable". This is useful to
